{
        Program Name : B_Dialog_Default_Key
        Package Name : Subroutine Library - Layer 4
        Purpose      : Button default behavior
        Institution  : Conroy & Conroy Co.
        Date Written :
        Written By   : Alan Conroy
        Version      : 1.0

        Copyright (C) 2006 by Alan Conroy.  All rights reserved.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          Implements TSpeedButton default behavior.
}

unit B_Dialog_Default_Key ;

interface

uses // C&C Subroutine Library - Layer 1...
     Behavior, // TSBehavior
     _Events ; // TGeneric_Event

type TForm_Default_Key_Behavior = class( TBehavior )
                                      public // API...
                                          function Allow_Normal_Processing( Event : TGeneric_Event ) : boolean ;
                                              override ;
                                          procedure Execute( Event : TGeneric_Event ) ;
                                              override ;
                                  end ;

implementation

uses // Borland...
     Windows, // VK_Down

     Buttons, // TSpeedButton
     Controls, // TControl
     Forms, // TForm
     SysUtils, // uppercase

     // C&C Subroutine Library - Layer 3...
     WinEvents ; // PWindows_Key_Down_Event


// TForm_Default_Key_Behavior methods...

// API...

function TForm_Default_Key_Behavior.Allow_Normal_Processing( Event : TGeneric_Event ) : boolean ;

var E : TWindows_Key_Down_Event ;
    Form : TForm ;

begin
    // Setup...
    Result := True ;
    if( ( Event = nil ) or ( Event.Event_Type <> EID_Windows_Key_Down ) ) then
    begin
        exit ;
    end ;
    E := TWindows_Key_Down_Event( Event ) ;
    Form := TForm( E.Source ) ;

    // Process key
    if( E.Key = VK_ESCAPE ) then
    begin
        Form.ModalResult := mrCancel ;
        Result := False ;
    end ;
end ; // TForm_Default_Key_Behavior.Allow_Normal_Processing


procedure TForm_Default_Key_Behavior.Execute( Event : TGeneric_Event ) ;

begin
    // This routine intentionally left blank
end ;



end.

