{
        Program Name : B_Horizontal_Spacing
        Package Name : Subroutine Library - Layer 4
        Purpose      : Button default behavior
        Institution  : Conroy & Conroy Co.
        Date Written :
        Written By   : Alan Conroy
        Version      : 1.0

        Copyright (C) 2006 by Alan Conroy.  All rights reserved.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          Implements horiontal spacing behavior.
}

unit B_Horizontal_Spacing ;

interface

uses // Borland...
     ExtCtrls, // TPanel

     // C&C Subroutine Library - Layer 1...
     Behavior, // TSBehavior
     _Events ; // PEvent

type TControl_Horizontal_Spacing = class( TBehavior )
                                       public // API...
                                           function Allow_Normal_Processing( Event : TGeneric_Event ) : boolean ;
                                               override ;
                                           procedure Execute( Event : TGeneric_Event ) ;
                                               override ;
                                   end ;

implementation

uses // Borland...
     Classes, // TList
     Controls, // TControl

     // C&C Subroutine Library - layer 3....
     WinEvents ; // TWindows_Key_Down_Event

// TControl_Horizontal_Spacing methods...

// API...

function TControl_Horizontal_Spacing.Allow_Normal_Processing( Event : TGeneric_Event ) : boolean ;

var Band : integer ; // Width of area for each control
    Control : TWinControl ;
    E : TGeneric_Event ;
    List : TList ; // Controls to position
    Loop : integer ; // Loop control
    Min_X : integer ; // Minimum X for control
    X : integer ; // Current X position

begin
    // Setup...
    Result := True ;
    if( ( Event = nil ) or ( Event.Event_Type <> EID_Windows_Resize ) ) then
    begin
        exit ;
    end ;
    E := TWindows_Key_Down_Event( Event ) ;
    Control := TWinControl( E.Source ) ;

    // Do the work...
    if( Control.HasParent and ( Control.ControlCount > 0 ) ) then
    begin
        // Build a list of controls to positions, in left-to-right order...
        List := TList.Create ;
        for Loop := 0 to Control.ControlCount - 1 do
        begin
            if( Control.Controls[ Loop ].Visible ) then
            begin
                for X := 0 to List.Count - 1 do
                begin
                    if( Control.Controls[ Loop ].Left < TControl( List[ X ] ).Left ) then
                    begin
                        List.Insert( X, Control.Controls[ Loop ] ) ;
                        break ;
                    end ;
                end ; // for X := 0 to List.Count - 1
                if( List.Indexof( Control.Controls[ Loop ] ) = -1 ) then // Not added yet
                begin
                    List.Add( Control.Controls[ Loop ] ) ;
                end ;
            end ; // if( Controls[ Loop ].Visible )
        end ; // for Loop := 0 to ChildCount - 1

        // Now position the controls...
        Band := Control.ClientWidth div List.Count ;
        for Loop := 0 to List.Count - 1 do
        begin
            X := ( Loop * Band ) + ( Band div 2 ) ; // Center point for control
            X := X - ( TControl( List[ Loop ] ).Width div 2 ) ;
            if( Loop > 0 ) then // Not the first one
            begin
                Min_X := TControl( List[ Loop - 1 ] ).Left + TControl( List[ Loop - 1 ] ).Width ;
                // Don't allow controls to overlap each other
            end else
            begin
                Min_X := 0 ; // Start at left side
            end ;
            if( X < Min_X ) then
            begin
                X := Min_X ;
            end ;
            TControl( List[ Loop ] ).Left := X ;
        end ; // for Loop := 0 to List.Count - 1

        // Clean up
        List.Free ;
    end ; // if( HasParent and ( Old <> ClientWidth ) )
end ;


procedure TControl_Horizontal_Spacing.Execute( Event : TGeneric_Event ) ;

begin
    // This routine intentionally left blank
end ;




end.
