{
        Program Name : Chars
        Package Name : LB
        Purpose      : Low-level character output
        Institution  : Conroy & Conroy Co.
        Date Written :
        Written By   : Alan Conroy
        Version      : 1.0

	      Copyright (C) 2009 by Alan Conroy.  All rights reserved.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          TDefault_Character is a generic character object.  It may be
        associated with a font, or it can stand-alone (using the default font,
        or the font associated with the output device).  It has a lot of
        overhead for a single character, and generally TFont_Character should be
        used instead.
}

unit Chars ;

interface

uses // C&C...
     _Chars ; // TCharacter

function Create_Character( C : char ) : TCharacter ;

implementation

type TDefault_Character = class( TBase_Delphi_Object )
                              private // Instance data...
                                  _Italic : integer ;
                                  _Bold : integer ;
                                  _Color : TColor ;
                                  _Size : integer ;
                                  _Value : string ;
                                  _Font : TFont ;

                              public // API...
                                  function Get_Italic_Amount : integer ;
                                      override ;
                                  function Get_Bold_Amount : integer ;
                                      override ;
                                  function Get_Italic : boolean ;
                                      override ;
                                  function Get_Bold : boolean ;
                                      override ;
                                  function Get_Font : TFont ;
                                      override ;
                                  function Get_Value : string ;
                                      override ;
                                  function Get_Color : TColor ;
                                      override ;
                                  function Get_Size : integer ;
                                      override ;
                                  procedure Set_Italic_Amount( Value : integer ) ;
                                      override ;
                                  procedure Set_Bold_Amount( Value : integer ) ;
                                      override ;
                                  procedure Set_Italic( Value : boolean ) ;
                                      override ;
                                  procedure Set_Bold( Value : boolean ) ;
                                      override ;
                                  procedure Set_Font( Value : TFont ) ;
                                      override ;
                                  procedure Set_Value( Value : string ) ;
                                      override ;
                                  procedure Set_Color( Value : TColor ) ;
                                      override ;
                                  procedure Set_Size( Value : integer ) ;
                                      override ;

                                  function Baseline : integer ; // Above baseline is ascent, below is descent
                                      override ;
                                  function Width : integer ;
                                      override ;
                                  function Height : integer ; // Total height, including ascent and descent
                                      override ;
                                  function Leading : integer ; // Internal leading
                                      override ;
                                  procedure Draw( Canvas : TCanvas ; Rect : TRect ;
                                      _Baseline : integer ) ;
                                      override ;
                  end ; // TDefault_Character

function TDefault_Character.Get_Italic_Amount : integer ;

begin
    Result := _Italic ;
end ;


function TDefault_Character.Get_Bold_Amount : integer ;

begin
    Result := _Bold ;
end ;


function TDefault_Character.Get_Italic : boolean ;

begin
    Result := ( _Italic <> 0 ) ;
end ;


function TDefault_Character.Get_Bold : boolean ;

begin
    Result := ( _Bold <> 0 ) ;
end ;


function TDefault_Character.Get_Font : TFont ;

begin
    Result := _Font ;
end ;


function TDefault_Character.Get_Value : string ;

begin
    Result := _Value ;
end ;


function TDefault_Character.Get_Color : TColor ;

begin
    Result := _Color ;
end ;


function TDefault_Character.Get_Size : integer ;

begin
    Result := _Size ;
end ;


procedure TDefault_Character.Set_Italic_Amount( Value : integer ) ;

begin
    _Italic := Value ;
end ;


procedure TDefault_Character.Set_Bold_Amount( Value : integer ) ;

begin
    _Bold := Value ;
end ;


procedure TDefault_Character.Set_Italic( Value : boolean ) ;

begin
    if( Value ) then
    begin
        _Italic := 25 ; // Tipped 25 degrees
    end else
    begin
        _Italic := 0 ;
    end ;
end ;


procedure TDefault_Character.Set_Bold( Value : boolean ) ;

begin
    if( Value ) then
    begin
        _Bold := 700 ;
    end else
    begin
        _Bold := 0 ;
    end ;
end ;


procedure TDefault_Character.Set_Font( Value : TFont ) ;

begin
    _Font := Value ;
end ;


procedure TDefault_Character.Set_Value( Value : string ) ;

begin
    _Value := Value ;
end ;


procedure TDefault_Character.Set_Color( Value : TColor ) ;

begin
    _Color := Value ;
end ;


procedure TDefault_Character.Set_Size( Value : integer ) ;

begin
    _Size := Value ;
end ;


function TDefault_Character.Baseline : integer ; // Above baseline is ascent, below is descent

begin
end ;


function TDefault_Character.Width : integer ;

begin
end ;


function TDefault_Character.Height : integer ; // Total height, including ascent and descent

begin
end ;


function TDefault_Character.Leading : integer ; // Internal leading

begin
end ;


procedure TDefault_Character.Draw( Canvas : TCanvas ; Rect : TRect ;
  _Baseline : integer ) ;

begin
end ;



// Unit API...

function Create_Character( C : char ) : TCharacter ;

begin
    Result := TDefault_Character.Create( C ) ;
end ;


end.

