unit DXPlayer_Main;

interface

uses Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants,
     System.Classes, Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs;

type
  TForm3 = class(TForm)
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form3: TForm3;

implementation

{$R *.dfm}

uses SysUtils,
     Windows,
     DirectSound,
     MMSystem,
     Classes,
     mp3stream;

procedure TForm3.FormCreate(Sender: TObject);

var mp3: TMP3;

begin
    IsMultiThread := True;

    mp3 := TMP3.Create('mp3.mp3');

    if DirectSoundCreate8(nil, DS, nil) <> DS_OK then Exit;

//    if DS.SetCooperativeLevel(FindWindow(nil, 'APP'), DSSCL_NORMAL) <> DS_OK then Exit;

    FillChar(wfm, SizeOf(wfm), 0);
    wfm.cbSize := SizeOf(wfm);
    wfm.nChannels := mp3.Fchannels;
    wfm.wBitsPerSample := 16;
    wfm.nSamplesPerSec := mp3.Frate;
    wfm.nAvgBytesPerSec := wfm.nSamplesPerSec * wfm.nChannels * 2;
    wfm.nBlockAlign := 2 * wfm.nChannels;
    wfm.wFormatTag := WAVE_FORMAT_PCM;

    // set up the buffer
    desc.dwSize := SizeOf(desc);
    desc.dwFlags := 0;
    desc.lpwfxFormat := @wfm;
    desc.dwReserved := 0;
    desc.dwBufferBytes := wfm.nAvgBytesPerSec * 2;

    desc.dwFlags :=
        DSBCAPS_STATIC or
        DSBCAPS_CTRLPOSITIONNOTIFY or
        DSBCAPS_CTRLVOLUME or
        DSBCAPS_GLOBALFOCUS ;

    ds.CreateSoundBuffer(desc,sbuffer,nil);
    sbuffer.QueryInterface(IID_IDirectSoundNotify8,dsnotify);

    events[0] := CreateEvent(nil,False,False,'0.25 played');;
    events[1] := CreateEvent(nil,False,False,'0.75 played');
    notifs[0].hEventNotify := events[0];
    notifs[0].dwOffset := wfm.nAvgBytesPerSec div 2;
    notifs[1].hEventNotify := events[1];
    notifs[1].dwOffset := (wfm.nAvgBytesPerSec * 3) div 2;

    if dsnotify.SetNotificationPositions(2,@notifs) <> DS_OK then Exit;

    mp3.Play;


    sleep(1000 * 60 * 1);


    mp3.Stop;

    CloseHandle(events[0]);
    CloseHandle(events[1]);

    dsnotify := nil;
    sbuffer := nil;
    DS := nil;

    mp3.Free;
end;




end.
