{----------------------------------------------------------------------------
file:      eDefines.inc
type:      Delphi/FPC include file

compiler:  Borland Pascal 7.0,
           Delphi 1-7,2005-2010,10
           Kylix 1,
           C++Builder 1-5 (Pascal Only)
           FPC/Lazarus

platforms: DOS, DPMI, Win16, Win32, Win64, Android, OSX, Linux, iOS

author:    mh@elitedev.com
date:      8/3/1997, last changed: 2/6/2001

contents:  Defines that can be flexibily used to determine the exact
           compiler version used, platform, and feature set.

(c)opyright elitedevelopments. all rights reserved.
            http://www.elitedev.com

 Third Party component developers are encouraged to use the set of defines
 established in this file, rather then their own system, for checking their
 component libraries against different versions of Delphi and C++Builder.

 This file may be distributed freely with both free and commercial source
 libraries, but you are asked to please leave this comment in place, and
 to return any improvements you make to this file to the maintainer that
 is noted above.
----------------------------------------------------------------------------}

{----------------------------------------------------------------------------
 Compiler and OS version defines:

 exact compiler versions:

 BP7             Borland Pascal 7.0
 CBUILDER1       C++Builder 1.0
 CBUILDER3       C++Builder 3.0
 CBUILDER4       C++Builder 4.0
 CBUILDER5       C++Builder 5.0
 DELPHI1         Delphi 1.0 (any Delphi)
 DELPHI2         Delphi 2.0
 DELPHI3         Delphi 3.0
 DELPHI4         Delphi 4.0
 DELPHI5         Delphi 5.0
 DELPHI6         Delphi 6.0
 DELPHI7         Delphi 7.0
 DELPHI2005      Delphi 2005
 DELPHI2006      Delphi 2006
 DELPHI2010      Delphi 2010
 DELPHIXE	       Delphi XE
 DELPHIXE2	     Delphi XE2
 DELPHIXE3	     Delphi XE3
 DELPHIXE4	     Delphi XE4
 DELPHIXE5	     Delphi XE5
 DELPHIXE6	     Delphi XE6
 DELPHIXE7	     Delphi XE7
 DELPHIXE8	     Delphi XE8
 DELPHI10	       Delphi 10
 DELPHI10_1	     Delphi 10.1
 DELPHI10_2	     Delphi 10.2
 DELPHI10_3	     Delphi 10.3
 DELPHI10_4      Delphi 10.4
 KYLIX1          Kylix 1.0
 TP4		         Turbo Pascal 4.0
 TP5		         Turbo Pascal 5.0
 TP55		         Turbo Pascal 5.5
 TP6		         Turbo Pascal 6.0
 TPW10		       Turbo Pascal for Windows 1.0
 TPW15		       Turbo Pascal for Windows 1.5


 minimum compiler versions:

 CBUILDER1UP     C++Builder 1.0 and above or Delphi 2 and above (any C++Builder)
 CBUILDER3UP     C++Builder 3.0 and above or Delphi 3.0 and above
 CBUILDER4UP     C++Builder 4.0 and above or Delphi 4.0 and above
 CBUILDER5UP     C++Builder 5.0 and above or Delphi 5.0 and above
 DELPHI1UP       Delphi 1.0 and above (any Delphi)
 DELPHI2UP       Delphi 2.0 and above
 DELPHI3UP       Delphi 3.0 and above
 DELPHI4UP       Delphi 4.0 and above
 DELPHI5UP       Delphi 5.0 and above
 DELPHI6UP       Delphi 6.0 and above
 DELPHI7UP       Delphi 7.0 and above
 DELPHI2005UP    Delphi 2005 and above
 DELPHI2006UP    Delphi 2006 and above
 DELPHI2010UP    Delphi 2010 and above
 DELPHIXEUP	     Delphi XE and above
 DELPHIXE2UP	   Delphi XE2 and above
 DELPHIXE3UP  	 Delphi XE3 and above
 DELPHIXE4UP	   Delphi XE4 and above
 DELPHIXE5UP  	 Delphi XE5 and above
 DELPHIXE6UP	   Delphi XE6 and above
 DELPHIXE7UP  	 Delphi XE7 and above
 DELPHIXE8UP	   Delphi XE8 and above
 DELPHI10UP  	   Delphi 10 and above
 DELPHI10_1UP    Delphi 10.1 and above
 DELPHI10_2UP 	 Delphi 10.2 and above
 DELPHI10_3UP 	 Delphi 10.3 and above
 KYLIX1UP        Kylix 1.0 and above (any Kylix)
 TP4UP	    	   Turbo Pascal 4.0 and above
 TP5UP           Turbo Pascal 5.0 and above
 TP55UP          Turbo Pascal 5.5 and above
 TP6UP           Turbo Pascal 6.0 and above
 TPW10UP         Turbo Pascal for Windows 1.0 and above (Any Turbo Pascal for Windows)
 TPW15UP         Turbo Pascal for Windows 1.5 and above


 compiler types:

 TP		           Turbo Pascal
 TPW		         Turbo Pascal for Windows
 BP              Borland Pascal (not Delphi or C++Builder)
 DELPHI          any Delphi version (but not C++Builder or Kylix)
 KYLIX           any Kylix version
 CBUILDER        any C++Builder (Pascal)
 FPC             Free Pascal
 FPC_DELPHI      Free Pascal in Delphi-compatibility mode


 target platforms compiler types:

 DELPHI_16BIT    16bit Delphi (but not C++Builder!)
 DELPHI_32BIT    32bit Delphi (but not C++Builder)
 DELPHI_64BIT    64bit Delphi (but not C++Builder)
 CBUILDER_32BIT  32bit C++Builder's Pascal (but not Delphi)


 target platforms:

 DOS             any DOS (plain and DPMI)
 REALMODE        16bit realmode DOS
 PROTECTEDMODE   16bit DPMI DOS

 MSWINDOWS       any Windows platform
 WIN16           16bit Windows
 WIN32           32bit Windows (Delphi symbol)
 WIN64           64bit Windows (Delphi symbol)

 OSX             Any MacOs platform
 OSX64           64-bit OSX platform

 DOS_OR_WINDOWS  Any DOS or any Windows

 LINUX           any Linix platform
 LINUX32         32bit Linux

 MOBILE          Android or iOS

 UOS             UOS


 compiler features:

 ANONYMOUS_METHODS               Anonymous methods support.
 ASM                             ASM supported.
 ASM_CPUID                       cpuid instruction supported by internal
                                 assembler.
 ASM_INLINE                      INLINE statement (assembler) supported.
 ASSIGN_CONSTANT_ARRAY_TO_DYNAMIC Dynamic arrays can be initialized from a
                                 constant array.
 DEFAULT_WIDESTRING              Strings default to widestrings.
 DELEGATION                      Delegations supported.
 DIRECT_RAM_ACCESS               Direct access to RAM allowed.
 DYNAMIC_ARRAYS                  Dynamic arrays supported.
 DYNAMIC_ARRAY_CONCATENATION     Dynamic array concatenation supported.
 DYNAMIC_OBJECTS                 Dynamic (heap) objects supported.
 DYNAMIC_STRINGS                 Dynamic strings supported.
 ENUMERATORS                     Enumerators and for...in supported.
 EXCEPTIONS                      Exceptions supported.
 FUNCTION_RESULT_REQUIRED        Functions must have a target for what they
                                 return.
 GENERICS                        Generics supported.
 INT64                           Non-Comp 64-bit integers (int64) supported.
 MOBILE                          Mobile device (Android, IOS)
 NOVCL                           No VCL on this platform
 OLEVARIANT                      OLEVariant is supported.
 OVERLOAD                        Overloaded methods are supported.
 OVERLOAD_FUNCTIONS              Overloaded functions are supported.
 POINTERMATH                     $POINTERMATH diretive supported.
 PROPERTIES                      Properties supported.
 REAL48                          Real48 type supported.
 RECORD_RETURNS                  Return of record structures supported.
 REINTRODUCE                     reintroduce is supported on methods.
 SCOPED_ENUMS                    Scoped enums supported.
 STATIC_PROPERTIES               Properties are allowed in static (old) classes.
 STDCALL_SUPPORTED               stdcall calling convention supported.
 UNICODE_STRING                  UnicodeString type supported
 UNIT_INIT_AND_FINAL             Unit initialization/finalization supported.
 UNIT_NAME_DOTS                  Unit names can contain dots (.) in them.
 VARIABLE_DECLARATION_ASSIGN     Assigning a variable a value in its declaration
                                 supported.
 WEAK_REFERENCES                 Weak and unsafe references are supported.
 WIDESTRINGS                     Widestrings are supported.


 component (LCL, VCL) library features:
 
 CL_ACTIONMANAGER_LARGE_IMAGE    TActionManager.DisabledImages, .LargeImages,
                                 and .LargeDisabledImages supported.
 CL_APPLICATION_DEFAULTFONT      TApplication.DefaultFont supported.
 CL_BITMAP_ALPHA                 TBitmap.AlphaFormat supported.
 CL_BUTTON_IMAGES                TButton.CommandLinkHint, .DropDownMenu
                                 .OnDropDownClick, .Images, .ImageIndex,
                                 .HotImageIndex, .DisabledImageIndex,
                                 .PressedImageIndex, .SelectedImageIndex,
                                 .DropDownMenu, .ElevationRequired,
                                 .ImageAlignment, .ImageMargins,
                                 .CommandLinkHint, .Style, and .OnDropDownClick
                                 supported.
 CL_BUTTONEDEDIT                 TButtonedEdit supported.
 CL_CATEGORY_PANEL               TCategoryPanel and TCategoryPanelGroup supported.
 CL_CB_HINT                      TComboBox.TextHint supported.
 CL_CHARACTER                    TCharacter class supported.
 CL_CONTROL_CUSTOMHINT           TControl.CustomHint and .ParentCustomHint
                                 supported.
 CL_CONTROL_HELPCONTEXT          TControl.HelpContext, .HelpKeyword, and
                                 .HelpType supported.
 CL_CUSTOMHINT                   TCustomHint and TBalloonHint supported.
 CL_CUSTOMLISTVIEW_ONCHECKED     TCustomListView.OnItemChecked support.
 CL_DBIMAGE_PROPORTIONAL         TDBImage.Proportional supported.
 CL_EDIT_ALIGNMENT               TEdit/TLabeledEdit.Alignment, .NumbersOnly, and
                                 .TextHint supported.
 CL_ENCODING                     TEncoding supported.
 CL_GRAPHIC_TRANSPARENCY         TGraphic.SupportsPartialTransparency supported.
 CL_IMAGELIST_ALPHA              TImageList.ColorDepth supported
 CL_LABEL_GLOW                   TLabel.GlowSizes supported.
 CL_LINKLABEL                    TLinkLabel supported.
 CL_LIST_CAPACITY                TList has .Capacity property.
 CL_LISTGROUPS                   TTListGroup and TListGroups supported.
 CL_LISTVIEW_GROUPS              TListView.GroupView, .Groups,
                                 .GroupHeaderImages, and .OnItemChecked
                                 supported.
 CL_CUSTOMHEADER_CHECKBOXES      TCustomHeaderControl.CheckBoxes, .NoSizing, and
                                 .OverFlow supported.
                                 THeaderSection.Checkbox, .Checked, and
                                 .FixedWidth supported.
 CL_MASKEDIT_ALIGNMENT           TMaskEdit.Alignment and .TextHint supported.
 CL_MEMO_CHARCASE                TMemo.CharCase supported.
 CL_OBJECT_EQUALS                TObject.Equals, .GetHashCode, and .ToString
                                 supported.
 CL_PANEL_HIDE_CAPTION           TPanel.ShowCaption supported.
 CL_POPUPACTIONBAR_STYLE         TPopupActionBar.Style supported.
 CL_PROGRESSBAR_CUSTOM           TProgressBar.Style, .MarqueeInterval,
                                 .BarColor, .BackgroundColor, .SmoothReverse,
                                 and .State supported.
 CL_RADIOGROUP_WORDWRAP          TRadioGroup.WordWrap supported.
 CL_RIBBONS                      TRibbon, TRibbonApplicationMenuBar, and
                                 TRibbonQuickAccessToolbar supported.
 CL_SCREEN_MESSAGEFONT           TScreen.MessageFont supported.
 CL_STREAMREADER                 TStreamReader and TStreamWriter supported.
 CL_STRINGBUILDER                TStringBuilder supported.
 CL_STRINGREADER                 TStringReader and TStringWriter supported.
 CL_TRAYICON_BALLOONCLICK        TTrayIcon.OnBalloonClick supported.
 CL_TREEVIEW_DISABLED            TTreeView supports disabled tree nodes and
                                 image index for expanded nodes.
 CL_WINCONTROL_DOUBLEBUFFERED    TWinControl.DoubleBuffered and
                                 .ParentDoubleBuffered supported.
----------------------------------------------------------------------------}

// Note: No $IFDEF support prior to Turbo Pascal 4.0

{ defines for Turbo Pascal 4.0 }
{$IFDEF VER40}
  {$DEFINE TP}
  {$DEFINE TP4}
  {$DEFINE TP4UP}
{$ENDIF}

{ defines for Turbo Pascal 5.0 }
{$IFDEF VER50}
  {$DEFINE TP}
  {$DEFINE TP5}
  {$DEFINE TP4UP}
  {$DEFINE TP5UP}
{$ENDIF}

{ defines for Turbo Pascal 5.5 }
{$IFDEF VER55}
  {$DEFINE TP}
  {$DEFINE TP55}
  {$DEFINE TP4UP}
  {$DEFINE TP5UP}
  {$DEFINE TP55UP}
{$ENDIF}

{ defines for Turbo Pascal 6.0 }
{$IFDEF VER60}
  {$DEFINE TP}
  {$DEFINE TP6}
  {$DEFINE TP4UP}
  {$DEFINE TP5UP}
  {$DEFINE TP55UP}
  {$DEFINE TP6UP}
{$ENDIF}

{$IFDEF TP}
  {$DEFINE NOVCL}
{$ENDIF}

{ defines for Turbo Pascal for Windows 1.0 }
{$IFDEF VER10}
  {$DEFINE TPW}
  {$DEFINE TPW10}
  {$DEFINE TPW10UP}
  {$DEFINE MSWINDOWS}
  {$DEFINE WIN16}
{$ENDIF}

{ defines for Turbo Pascal for Windows 1.5 }
{$IFDEF VER15}
  {$DEFINE TPW}
  {$DEFINE TPW15}
  {$DEFINE TPW10UP}
  {$DEFINE TPW15UP}
  {$DEFINE MSWINDOWS}
  {$DEFINE WIN16}
{$ENDIF}

{$IFDEF TPW}
  {$DEFINE NOVCL}
{$ENDIF}

{ defines for Borland Pascal 7.0 }
{$IFDEF VER70}
  {$DEFINE BP}
  {$DEFINE BP7}
  {$DEFINE _16BIT}

  { defines for BP7 DOS real mode }
  {$IFDEF MSDOS}
    {$DEFINE DOS}
    {$DEFINE REALMODE}
  {$ENDIF}

  { defines for BP7 DOS protected mode }
  {$IFDEF DPMI}
    {$DEFINE DOS}
    {$DEFINE PROTECTEDMODE}
  {$ENDIF}

  { defines for BP7 Windows }
  {$IFDEF WINDOWS}
    {$DEFINE MSWINDOWS}
    {$DEFINE WIN16}
  {$ENDIF}
{$ENDIF}

{$IFDEF BP}
  {$DEFINE NOVCL}
{$ENDIF}

{ defines for Delphi 1 }
{$IFDEF VER80}
  {$DEFINE DELPHI}
  {$DEFINE DELPHI1}
  {$DEFINE DELPHI1UP}
  {$DEFINE DELPHI_16BIT}
  {$DEFINE WIN16}
  {$DEFINE _16BIT}
{$ENDIF}

{ defines for Delphi 2 }
{$IFDEF VER90}
  {$DEFINE DELPHI}
  {$DEFINE DELPHI2}
  {$DEFINE DELPHI1UP}
  {$DEFINE DELPHI2UP}
{$ENDIF}

{ defines for C++Builder 1 }
{$IFDEF VER93}
  {$DEFINE DELPHI1UP}
  {$DEFINE DELPHI2UP}
  {$DEFINE CBUILDER}
  {$DEFINE CBUILDER1}
  {$DEFINE CBUILDER1UP}
{$ENDIF}

{ defines for Delphi 3 }
{$IFDEF VER100}
  {$DEFINE DELPHI}
  {$DEFINE DELPHI3}
  {$DEFINE DELPHI1UP}
  {$DEFINE DELPHI2UP}
  {$DEFINE DELPHI3UP}
{$ENDIF}

{ defines for C++Builder 3 }
{$IFDEF VER110}
  {$DEFINE DELPHI1UP}
  {$DEFINE DELPHI2UP}
  {$DEFINE DELPHI3UP}
  {$DEFINE CBUILDER}
  {$DEFINE CBUILDER3}
  {$DEFINE CBUILDER1UP}
  {$DEFINE CBUILDER3UP}
{$ENDIF}

{ defines for Delphi 4 }
{$IFDEF VER120}
  {$DEFINE DELPHI}
  {$DEFINE DELPHI4}
  {$DEFINE DELPHI1UP}
  {$DEFINE DELPHI2UP}
  {$DEFINE DELPHI3UP}
  {$DEFINE DELPHI4UP}
{$ENDIF}

{ defines for C++Builder 4 }
{$IFDEF VER125}
  {$DEFINE DELPHI1UP}
  {$DEFINE DELPHI2UP}
  {$DEFINE DELPHI3UP}
  {$DEFINE DELPHI4UP}
  {$DEFINE CBUILDER}
  {$DEFINE CBUILDER4}
  {$DEFINE CBUILDER1UP}
  {$DEFINE CBUILDER3UP}
  {$DEFINE CBUILDER4UP}
{$ENDIF}

{ defines for Delphi 5 and/or C++Builder 5 }
{$IFDEF VER130}
  {$DEFINE DELPHI1UP}
  {$DEFINE DELPHI2UP}
  {$DEFINE DELPHI3UP}
  {$DEFINE DELPHI4UP}
  {$DEFINE DELPHI5UP}
  {$IFNDEF BCB}
    {$DEFINE DELPHI}
    {$DEFINE DELPHI5}
  {$ELSE}
    {$DEFINE CBUILDER}
    {$DEFINE CBUILDER5}
    {$DEFINE CBUILDER1UP}
    {$DEFINE CBUILDER3UP}
    {$DEFINE CBUILDER4UP}
    {$DEFINE CBUILDER5UP}
  {$ENDIF}
{$ENDIF}

{ defines for Delphi 6 }
{$IFDEF VER140}
  {$DEFINE DELPHI}
  {$DEFINE DELPHI6}
  {$DEFINE DELPHI1UP}
  {$DEFINE DELPHI2UP}
  {$DEFINE DELPHI3UP}
  {$DEFINE DELPHI4UP}
  {$DEFINE DELPHI5UP}
  {$DEFINE DELPHI6UP}
{$ENDIF}

{ defines for Delphi 7 }
{$IFDEF VER150}
  {$DEFINE DELPHI}
  {$DEFINE DELPHI7}
  {$DEFINE DELPHI1UP}
  {$DEFINE DELPHI2UP}
  {$DEFINE DELPHI3UP}
  {$DEFINE DELPHI4UP}
  {$DEFINE DELPHI5UP}
  {$DEFINE DELPHI6UP}
  {$DEFINE DELPHI7UP}
{$ENDIF}

{ defines for Delphi 8 }
{$IFDEF VER160}
  {$DEFINE NET}
  {$DEFINE DELPHI}
  {$DEFINE DELPHI8}
  {$DEFINE DELPHI1UP}
  {$DEFINE DELPHI2UP}
  {$DEFINE DELPHI3UP}
  {$DEFINE DELPHI4UP}
  {$DEFINE DELPHI5UP}
  {$DEFINE DELPHI6UP}
  {$DEFINE DELPHI7UP}
  {$DEFINE DELPHI8UP}
{$ENDIF}

{ defines for Delphi 2005 }
{$IFDEF VER170}
  {$DEFINE DELPHI}
  {$DEFINE DELPHI2005}
  {$DEFINE DELPHI1UP}
  {$DEFINE DELPHI2UP}
  {$DEFINE DELPHI3UP}
  {$DEFINE DELPHI4UP}
  {$DEFINE DELPHI5UP}
  {$DEFINE DELPHI6UP}
  {$DEFINE DELPHI7UP}
  {$DEFINE DELPHI8UP}
  {$DEFINE DELPHI9UP}
  {$DEFINE DELPHI2005UP}
{$ENDIF}

{ defines for Delphi 2006 }
{$IFDEF VER180}
  {$DEFINE DELPHI}
  {$DEFINE DELPHI2006}
  {$DEFINE DELPHI1UP}
  {$DEFINE DELPHI2UP}
  {$DEFINE DELPHI3UP}
  {$DEFINE DELPHI4UP}
  {$DEFINE DELPHI5UP}
  {$DEFINE DELPHI6UP}
  {$DEFINE DELPHI7UP}
  {$DEFINE DELPHI8UP}
  {$DEFINE DELPHI9UP}
  {$DEFINE DELPHI2005UP}
  {$DEFINE DELPHI2006UP}
{$ENDIF}

{ defines for Delphi 2007 }
{$IFDEF VER185}
  {$DEFINE DELPHI}
  {$DEFINE DELPHI2007}
  {$DEFINE DELPHI1UP}
  {$DEFINE DELPHI2UP}
  {$DEFINE DELPHI3UP}
  {$DEFINE DELPHI4UP}
  {$DEFINE DELPHI5UP}
  {$DEFINE DELPHI6UP}
  {$DEFINE DELPHI7UP}
  {$DEFINE DELPHI8UP}
  {$DEFINE DELPHI9UP}
  {$DEFINE DELPHI2005UP}
  {$DEFINE DELPHI2006UP}
  {$DEFINE DELPHI2007UP}
{$ENDIF}

{ defines for Delphi 2007 .net }
{$IFDEF VER190}
  {$DEFINE NET}
  {$DEFINE DELPHI}
  {$DEFINE DELPHI2007}
  {$DEFINE DELPHI1UP}
  {$DEFINE DELPHI2UP}
  {$DEFINE DELPHI3UP}
  {$DEFINE DELPHI4UP}
  {$DEFINE DELPHI5UP}
  {$DEFINE DELPHI6UP}
  {$DEFINE DELPHI7UP}
  {$DEFINE DELPHI8UP}
  {$DEFINE DELPHI9UP}
  {$DEFINE DELPHI2005UP}
  {$DEFINE DELPHI2006UP}
  {$DEFINE DELPHI2007UP}
{$ENDIF}

{ defines for Delphi 2009 }
{$IFDEF VER200}
  {$DEFINE DELPHI}
  {$DEFINE DELPHI2009}
  {$DEFINE DELPHI1UP}
  {$DEFINE DELPHI2UP}
  {$DEFINE DELPHI3UP}
  {$DEFINE DELPHI4UP}
  {$DEFINE DELPHI5UP}
  {$DEFINE DELPHI6UP}
  {$DEFINE DELPHI7UP}
  {$DEFINE DELPHI8UP}
  {$DEFINE DELPHI9UP}
  {$DEFINE DELPHI2005UP}
  {$DEFINE DELPHI2006UP}
  {$DEFINE DELPHI2007UP}
  {$DEFINE DELPHI2009UP}
{$ENDIF}

{ defines for Delphi 2010 }
{$IFDEF VER210}
  {$DEFINE DELPHI}
  {$DEFINE DELPHI2010}
  {$DEFINE DELPHI1UP}
  {$DEFINE DELPHI2UP}
  {$DEFINE DELPHI3UP}
  {$DEFINE DELPHI4UP}
  {$DEFINE DELPHI5UP}
  {$DEFINE DELPHI6UP}
  {$DEFINE DELPHI7UP}
  {$DEFINE DELPHI8UP}
  {$DEFINE DELPHI9UP}
  {$DEFINE DELPHI2005UP}
  {$DEFINE DELPHI2006UP}
  {$DEFINE DELPHI2007UP}
  {$DEFINE DELPHI2009UP}
  {$DEFINE DELPHI2010UP}
{$ENDIF}

{ defines for Delphi XE }
{$IFDEF VER220}
  {$DEFINE DELPHI}
  {$DEFINE DELPHIXE}
  {$DEFINE DELPHI1UP}
  {$DEFINE DELPHI2UP}
  {$DEFINE DELPHI3UP}
  {$DEFINE DELPHI4UP}
  {$DEFINE DELPHI5UP}
  {$DEFINE DELPHI6UP}
  {$DEFINE DELPHI7UP}
  {$DEFINE DELPHI8UP}
  {$DEFINE DELPHI9UP}
  {$DEFINE DELPHI2005UP}
  {$DEFINE DELPHI2006UP}
  {$DEFINE DELPHI2007UP}
  {$DEFINE DELPHI2009UP}
  {$DEFINE DELPHI2010UP}
  {$DEFINE DELPHIXEUP}
{$ENDIF}

{ defines for Delphi XE2 }
{$IFDEF VER230}
  {$DEFINE DELPHI}
  {$DEFINE DELPHIXE2}
  {$DEFINE DELPHI1UP}
  {$DEFINE DELPHI2UP}
  {$DEFINE DELPHI3UP}
  {$DEFINE DELPHI4UP}
  {$DEFINE DELPHI5UP}
  {$DEFINE DELPHI6UP}
  {$DEFINE DELPHI7UP}
  {$DEFINE DELPHI8UP}
  {$DEFINE DELPHI9UP}
  {$DEFINE DELPHI2005UP}
  {$DEFINE DELPHI2006UP}
  {$DEFINE DELPHI2007UP}
  {$DEFINE DELPHI2009UP}
  {$DEFINE DELPHI2010UP}
  {$DEFINE DELPHIXEUP}
  {$DEFINE DELPHIXE2UP}
{$ENDIF}

{ defines for Delphi XE3 }
{$IFDEF VER240}
  {$DEFINE DELPHI}
  {$DEFINE DELPHIXE3}
  {$DEFINE DELPHI1UP}
  {$DEFINE DELPHI2UP}
  {$DEFINE DELPHI3UP}
  {$DEFINE DELPHI4UP}
  {$DEFINE DELPHI5UP}
  {$DEFINE DELPHI6UP}
  {$DEFINE DELPHI7UP}
  {$DEFINE DELPHI8UP}
  {$DEFINE DELPHI9UP}
  {$DEFINE DELPHI2005UP}
  {$DEFINE DELPHI2006UP}
  {$DEFINE DELPHI2007UP}
  {$DEFINE DELPHI2009UP}
  {$DEFINE DELPHI2010UP}
  {$DEFINE DELPHIXEUP}
  {$DEFINE DELPHIXE2UP}
  {$DEFINE DELPHIXE3UP}
{$ENDIF}

{ defines for Delphi XE4 }
{$IFDEF VER250}
  {$DEFINE DELPHI}
  {$DEFINE DELPHIXE4}
  {$DEFINE DELPHI1UP}
  {$DEFINE DELPHI2UP}
  {$DEFINE DELPHI3UP}
  {$DEFINE DELPHI4UP}
  {$DEFINE DELPHI5UP}
  {$DEFINE DELPHI6UP}
  {$DEFINE DELPHI7UP}
  {$DEFINE DELPHI8UP}
  {$DEFINE DELPHI9UP}
  {$DEFINE DELPHI2005UP}
  {$DEFINE DELPHI2006UP}
  {$DEFINE DELPHI2007UP}
  {$DEFINE DELPHI2009UP}
  {$DEFINE DELPHI2010UP}
  {$DEFINE DELPHIXEUP}
  {$DEFINE DELPHIXE2UP}
  {$DEFINE DELPHIXE3UP}
  {$DEFINE DELPHIXE4UP}
{$ENDIF}

{ defines for Delphi XE5 }
{$IFDEF VER260}
  {$DEFINE DELPHI}
  {$DEFINE DELPHIXE5}
  {$DEFINE DELPHI1UP}
  {$DEFINE DELPHI2UP}
  {$DEFINE DELPHI3UP}
  {$DEFINE DELPHI4UP}
  {$DEFINE DELPHI5UP}
  {$DEFINE DELPHI6UP}
  {$DEFINE DELPHI7UP}
  {$DEFINE DELPHI8UP}
  {$DEFINE DELPHI9UP}
  {$DEFINE DELPHI2005UP}
  {$DEFINE DELPHI2006UP}
  {$DEFINE DELPHI2007UP}
  {$DEFINE DELPHI2009UP}
  {$DEFINE DELPHI2010UP}
  {$DEFINE DELPHIXEUP}
  {$DEFINE DELPHIXE2UP}
  {$DEFINE DELPHIXE3UP}
  {$DEFINE DELPHIXE4UP}
  {$DEFINE DELPHIXE5UP}
{$ENDIF}

{ defines for Delphi XE6 }
{$IFDEF VER270}
  {$DEFINE DELPHI}
  {$DEFINE DELPHIXE6}
  {$DEFINE DELPHI1UP}
  {$DEFINE DELPHI2UP}
  {$DEFINE DELPHI3UP}
  {$DEFINE DELPHI4UP}
  {$DEFINE DELPHI5UP}
  {$DEFINE DELPHI6UP}
  {$DEFINE DELPHI7UP}
  {$DEFINE DELPHI8UP}
  {$DEFINE DELPHI9UP}
  {$DEFINE DELPHI2005UP}
  {$DEFINE DELPHI2006UP}
  {$DEFINE DELPHI2007UP}
  {$DEFINE DELPHI2009UP}
  {$DEFINE DELPHI2010UP}
  {$DEFINE DELPHIXEUP}
  {$DEFINE DELPHIXE2UP}
  {$DEFINE DELPHIXE3UP}
  {$DEFINE DELPHIXE4UP}
  {$DEFINE DELPHIXE5UP}
  {$DEFINE DELPHIXE6UP}
{$ENDIF}

{ defines for Delphi XE7 }
{$IFDEF VER280}
  {$DEFINE DELPHI}
  {$DEFINE DELPHIXE7}
  {$DEFINE DELPHI1UP}
  {$DEFINE DELPHI2UP}
  {$DEFINE DELPHI3UP}
  {$DEFINE DELPHI4UP}
  {$DEFINE DELPHI5UP}
  {$DEFINE DELPHI6UP}
  {$DEFINE DELPHI7UP}
  {$DEFINE DELPHI8UP}
  {$DEFINE DELPHI9UP}
  {$DEFINE DELPHI2005UP}
  {$DEFINE DELPHI2006UP}
  {$DEFINE DELPHI2007UP}
  {$DEFINE DELPHI2009UP}
  {$DEFINE DELPHI2010UP}
  {$DEFINE DELPHIXEUP}
  {$DEFINE DELPHIXE2UP}
  {$DEFINE DELPHIXE3UP}
  {$DEFINE DELPHIXE4UP}
  {$DEFINE DELPHIXE5UP}
  {$DEFINE DELPHIXE6UP}
  {$DEFINE DELPHIXE7UP}
{$ENDIF}

{ defines for Delphi XE8 }
{$IFDEF VER290}
  {$DEFINE DELPHI}
  {$DEFINE DELPHIXE8}
  {$DEFINE DELPHI1UP}
  {$DEFINE DELPHI2UP}
  {$DEFINE DELPHI3UP}
  {$DEFINE DELPHI4UP}
  {$DEFINE DELPHI5UP}
  {$DEFINE DELPHI6UP}
  {$DEFINE DELPHI7UP}
  {$DEFINE DELPHI8UP}
  {$DEFINE DELPHI9UP}
  {$DEFINE DELPHI2005UP}
  {$DEFINE DELPHI2006UP}
  {$DEFINE DELPHI2007UP}
  {$DEFINE DELPHI2009UP}
  {$DEFINE DELPHI2010UP}
  {$DEFINE DELPHIXEUP}
  {$DEFINE DELPHIXE2UP}
  {$DEFINE DELPHIXE3UP}
  {$DEFINE DELPHIXE4UP}
  {$DEFINE DELPHIXE5UP}
  {$DEFINE DELPHIXE6UP}
  {$DEFINE DELPHIXE7UP}
  {$DEFINE DELPHIXE8UP}
{$ENDIF}

{ defines for Delphi 10 (Seattle) }
{$IFDEF VER300}
  {$DEFINE DELPHI}
  {$DEFINE DELPHI10}
  {$DEFINE DELPHI1UP}
  {$DEFINE DELPHI2UP}
  {$DEFINE DELPHI3UP}
  {$DEFINE DELPHI4UP}
  {$DEFINE DELPHI5UP}
  {$DEFINE DELPHI6UP}
  {$DEFINE DELPHI7UP}
  {$DEFINE DELPHI8UP}
  {$DEFINE DELPHI9UP}
  {$DEFINE DELPHI2005UP}
  {$DEFINE DELPHI2006UP}
  {$DEFINE DELPHI2007UP}
  {$DEFINE DELPHI2009UP}
  {$DEFINE DELPHI2010UP}
  {$DEFINE DELPHIXEUP}
  {$DEFINE DELPHIXE2UP}
  {$DEFINE DELPHIXE3UP}
  {$DEFINE DELPHIXE4UP}
  {$DEFINE DELPHIXE5UP}
  {$DEFINE DELPHIXE6UP}
  {$DEFINE DELPHIXE7UP}
  {$DEFINE DELPHIXE8UP}
  {$DEFINE DELPHI10UP}
{$ENDIF}

{ defines for Delphi 10.1 (Berlin) }
{$IFDEF VER310}
  {$DEFINE DELPHI}
  {$DEFINE DELPHI10_1}
  {$DEFINE DELPHI1UP}
  {$DEFINE DELPHI2UP}
  {$DEFINE DELPHI3UP}
  {$DEFINE DELPHI4UP}
  {$DEFINE DELPHI5UP}
  {$DEFINE DELPHI6UP}
  {$DEFINE DELPHI7UP}
  {$DEFINE DELPHI8UP}
  {$DEFINE DELPHI9UP}
  {$DEFINE DELPHI2005UP}
  {$DEFINE DELPHI2006UP}
  {$DEFINE DELPHI2007UP}
  {$DEFINE DELPHI2009UP}
  {$DEFINE DELPHI2010UP}
  {$DEFINE DELPHIXEUP}
  {$DEFINE DELPHIXE2UP}
  {$DEFINE DELPHIXE3UP}
  {$DEFINE DELPHIXE4UP}
  {$DEFINE DELPHIXE5UP}
  {$DEFINE DELPHIXE6UP}
  {$DEFINE DELPHIXE7UP}
  {$DEFINE DELPHIXE8UP}
  {$DEFINE DELPHI10UP}
  {$DEFINE DELPHI10_1UP}
{$ENDIF}

{ defines for Delphi 10.2 (Tokyo) }
{$IFDEF VER320}
  {$DEFINE DELPHI}
  {$DEFINE DELPHI10_2}
  {$DEFINE DELPHI1UP}
  {$DEFINE DELPHI2UP}
  {$DEFINE DELPHI3UP}
  {$DEFINE DELPHI4UP}
  {$DEFINE DELPHI5UP}
  {$DEFINE DELPHI6UP}
  {$DEFINE DELPHI7UP}
  {$DEFINE DELPHI8UP}
  {$DEFINE DELPHI9UP}
  {$DEFINE DELPHI2005UP}
  {$DEFINE DELPHI2006UP}
  {$DEFINE DELPHI2007UP}
  {$DEFINE DELPHI2009UP}
  {$DEFINE DELPHI2010UP}
  {$DEFINE DELPHIXEUP}
  {$DEFINE DELPHIXE2UP}
  {$DEFINE DELPHIXE3UP}
  {$DEFINE DELPHIXE4UP}
  {$DEFINE DELPHIXE5UP}
  {$DEFINE DELPHIXE6UP}
  {$DEFINE DELPHIXE7UP}
  {$DEFINE DELPHIXE8UP}
  {$DEFINE DELPHI10UP}
  {$DEFINE DELPHI10_1UP}
  {$DEFINE DELPHI10_2UP}
{$ENDIF}

{ defines for Delphi 10.3 (Rio) }
{$IFDEF VER330}
  {$DEFINE DELPHI}
  {$DEFINE DELPHI10_3}
  {$DEFINE DELPHI1UP}
  {$DEFINE DELPHI2UP}
  {$DEFINE DELPHI3UP}
  {$DEFINE DELPHI4UP}
  {$DEFINE DELPHI5UP}
  {$DEFINE DELPHI6UP}
  {$DEFINE DELPHI7UP}
  {$DEFINE DELPHI8UP}
  {$DEFINE DELPHI9UP}
  {$DEFINE DELPHI2005UP}
  {$DEFINE DELPHI2006UP}
  {$DEFINE DELPHI2007UP}
  {$DEFINE DELPHI2009UP}
  {$DEFINE DELPHI2010UP}
  {$DEFINE DELPHIXEUP}
  {$DEFINE DELPHIXE2UP}
  {$DEFINE DELPHIXE3UP}
  {$DEFINE DELPHIXE4UP}
  {$DEFINE DELPHIXE5UP}
  {$DEFINE DELPHIXE6UP}
  {$DEFINE DELPHIXE7UP}
  {$DEFINE DELPHIXE8UP}
  {$DEFINE DELPHI10UP}
  {$DEFINE DELPHI10_1UP}
  {$DEFINE DELPHI10_2UP}
  {$DEFINE DELPHI10_3UP}
{$ENDIF}

{ defines for Delphi 10.4 (Sydney) }
{$IFDEF VER340}
  {$DEFINE DELPHI}
  {$DEFINE DELPHI10_4}
  {$DEFINE DELPHI1UP}
  {$DEFINE DELPHI2UP}
  {$DEFINE DELPHI3UP}
  {$DEFINE DELPHI4UP}
  {$DEFINE DELPHI5UP}
  {$DEFINE DELPHI6UP}
  {$DEFINE DELPHI7UP}
  {$DEFINE DELPHI8UP}
  {$DEFINE DELPHI9UP}
  {$DEFINE DELPHI2005UP}
  {$DEFINE DELPHI2006UP}
  {$DEFINE DELPHI2007UP}
  {$DEFINE DELPHI2009UP}
  {$DEFINE DELPHI2010UP}
  {$DEFINE DELPHIXEUP}
  {$DEFINE DELPHIXE2UP}
  {$DEFINE DELPHIXE3UP}
  {$DEFINE DELPHIXE4UP}
  {$DEFINE DELPHIXE5UP}
  {$DEFINE DELPHIXE6UP}
  {$DEFINE DELPHIXE7UP}
  {$DEFINE DELPHIXE8UP}
  {$DEFINE DELPHI10UP}
  {$DEFINE DELPHI10_1UP}
  {$DEFINE DELPHI10_2UP}
  {$DEFINE DELPHI10_3UP}
  {$DEFINE DELPHI10_4UP}
{$ENDIF}

{ Platform defines... }

{$IFDEF WIN32}
  {$DEFINE MSWINDOWS}
  {$DEFINE _32BIT}
{$ENDIF}

{$IFDEF WIN64}
  {$DEFINE MSWINDOWS}
  {$DEFINE _64BIT}
{$ENDIF}

{$IFDEF MACOS}
  {$DEFINE OSX}
{$ENDIF}
{$IFDEF MACOS32}
  {$DEFINE OSX}
  {$DEFINE _32BIT}
  {$UNDEF _64BIT}
{$ENDIF}
{$IFDEF MACOS64}
  {$DEFINE OSX}
  {$DEFINE _64BIT}
  {$UNDEF _32BIT}
{$ENDIF}

{$IFDEF DELPHI}
  {$IFDEF DELPHI2UP}
    {$DEFINE DELPHI_32BIT}
  {$ENDIF}
{$ENDIF}

{$IFDEF CBUILDER}
  {$DEFINE CBUILDER_32BIT}
{$ENDIF}

{$IFDEF LINUX}
  {$DEFINE _32BIT}
  {$DEFINE LINUX32}
  {$DEFINE KYLIX}
  {$DEFINE KYLIX1}
  {$DEFINE KYLIX1UP}
  {$DEFINE UNIX}
{$ENDIF}

{$IFDEF FPC}
  {$IFDEF LINUX}
    {$UNDEF _32BIT}
    {$UNDEF LINUX32}
  {$ENDIF}
  {$IFDEF CPU16}
    {$DEFINE _16BIT}
    {$UNDEF _32BIT}
    {$UNDEF _64BIT}
  {$ENDIF}
  {$IFDEF CPU32}
    {$DEFINE _32BIT}
    {$IFDEF LINUX}
      {$DEFINE LINUX32}
    {$ENDIF}
  {$ENDIF}
  {$IFDEF CPU64}
    {$DEFINE _64BIT}
    {$IFDEF LINUX}
      {$DEFINE LINUX64}
    {$ENDIF}
  {$ENDIF}
{$ENDIF}

{$IFDEF ANDROID}
  {$DEFINE MOBILE}
  {$DEFINE _32BIT}
{$ENDIF}
{$IFDEF OSX}
  {$DEFINE _32BIT}
  {$DEFINE MAC_OR_WINDOWS}
{$ENDIF}
{$IFDEF CPU32BITS}
    {$DEFINE _32BIT}
    {$UNDEF _64BIT}
{$ENDIF}
{$IFDEF CPU64BITS}
    {$DEFINE _64BIT}
    {$UNDEF _32BIT}
{$ENDIF}

{$IFDEF DELPHI}
  {$DEFINE FPC_OR_DELPHI}
{$ENDIF}
{$IFDEF FPC}
  {$DEFINE FPC_OR_DELPHI}
{$ENDIF}
{$IFDEF LAZARUS}
  {$DEFINE FPC_OR_DELPHI}
{$ENDIF}
{$IFDEF FPC_DELPHI}
  {$DEFINE FPC_OR_DELPHI}
{$ENDIF}
{$IFDEF MSDOS}
  {$DEFINE MSDOS_OR_DPMI}
{$ENDIF}
{$IFDEF DPMI}
  {$DEFINE MSDOS_OR_DPMI}
{$ENDIF}

{$IFDEF MSWINDOWS}
  {$IFNDEF CONSOLE}
    {$DEFINE WINDOWS}
  {$ENDIF}
{$ENDIF}
{$IFDEF WINDOWS}
  {$DEFINE WINDOWS_OR_CONSOLE}
{$ENDIF}
{$IFDEF CONSOLE}
  {$DEFINE WINDOWS_OR_CONSOLE}
{$ENDIF}

{$IFDEF MSWINDOWS}
  {$DEFINE DOS_OR_WINDOWS}
  {$DEFINE MAC_OR_WINDOWS}
{$ENDIF}
{$IFDEF MSDOS}
  {$DEFINE DOS_OR_WINDOWS}
{$ENDIF}

{$IFDEF ANDROID32}
  {$DEFINE MOBILE}
  {$DEFINE _32BIT}
{$ENDIF}
{$IFDEF IOS}
  {$DEFINE MOBILE}
{$ENDIF}


{$IFDEF DELPHI}
  {$IFDEF _64BIT}
    {$DEFINE DELPHI_64BIT}
  {$ENDIF}
{$ENDIF}

{ Feature definitions... }

{$IFDEF BP}
  {$DEFINE FUNCTION_RESULT_REQUIRED}
{$ENDIF}
{$IFDEF TP}
  {$DEFINE FUNCTION_RESULT_REQUIRED}
{$ENDIF}
{$IFDEF TPW}
  {$DEFINE FUNCTION_RESULT_REQUIRED}
{$ENDIF}
{$IFDEF FPC_OR_DELPHI}
  {$DEFINE RECORD_RETURNS} { Return of record structures supported }
  {$DEFINE DYNAMIC_OBJECTS} { Dynamic (heap) objects supported }
  {$DEFINE UNIT_INIT_AND_FINAL} { Unit initialization/finalization supported }
  {$DEFINE VARIABLE_DECLARATION_ASSIGN} { Assigning a variable a value in its declaration supported }
  {$DEFINE DYNAMIC_STRINGS} { Dynamic strings supported }
  {$DEFINE EXCEPTIONS} { Exceptions supported }
  {$DEFINE DELEGATION} { Delegations supported }
  {$DEFINE ASM} { ASM supported }
{$ENDIF}
{$IFDEF FPC}
  {$DEFINE DYNAMIC_ARRAYS}  { Dynamic arrays }
  {$DEFINE PROPERTIES} { Properties supported }
  {$DEFINE INT64} { (non-Comp) int64 integers are supported }
  {$DEFINE OLEVARIANT}  { OLEVariant is supported }
  {$DEFINE OVERLOAD}  { overloaded functions are supported }
  {$DEFINE REAL48} { Real48 type supported }
  {$DEFINE REINTRODUCE}  { reintroduce is supported on methods }
  {$DEFINE WIDESTRINGS} { Widestrings are supported }
  {$DEFINE CL_CONTROL_HELPCONTEXT}
  {$DEFINE CL_LIST_CAPACITY}
{$ENDIF}
{$IFDEF DELPHI2UP}
  {$DEFINE PROPERTIES} { Properties supported }
  {$DEFINE STATIC_PROPERTIES} { Properties are supported in static object classes }
  {$DEFINE CARDINAL} { Cardinal (usigned 32-bit integer) supported }
  {$IFNDEF UOS}
    {$DEFINE VCL}
  {$ENDIF}
{$ENDIF}
{$IFDEF DELPHI3UP}
  {$DEFINE DYNAMIC_ARRAYS}  { Dynamic arrays }
  {$DEFINE INT64} { (non-Comp) int64 integers are supported }
  {$DEFINE OLEVARIANT}  { OLEVariant is supported }
  {$DEFINE OVERLOAD}  { overloaded functions are supported }
  {$DEFINE REAL48} { Real48 type supported }
  {$DEFINE REINTRODUCE}  { reintroduce is supported on methods }
  {$IFNDEF MOBILE}
    {$DEFINE WIDESTRINGS} { Widestrings are supported }
  {$ENDIF}
  {$DEFINE CL_LIST_CAPACITY}
{$ENDIF}
{$IFDEF DELPHI5UP}
  {$DEFINE ASM_CPUID}
  {$DEFINE CL_CONTROL_HELPCONTEXT}
{$ENDIF}
{$IFNDEF DELPHI5UP}
  {$DEFINE DIRECT_RAM_ACCESS}
{$ENDIF}
{$IFNDEF DELPHI7UP}
  {$DEFINE UNIT_NAME_DOTS}
{$ENDIF}
{$IFDEF DELPHI2005UP}
  {$DEFINE ENUMERATORS}
{$ENDIF}
{$IFDEF DELPHI2006UP}
  {$DEFINE INLINE_FUNCTIONS}
{$ENDIF}
{$IFDEF DELPHI2009UP}
  {$DEFINE DEFAULT_WIDESTRING}
  {$DEFINE SCOPED_ENUMS}
  {$DEFINE OVERLOAD_FUNCTIONS}
  {$DEFINE GENERICS}
  {$DEFINE ANONYMOUS_METHODS}
  {$DEFINE UNICODE_STRING}
  {$DEFINE POINTERMATH}
  {$DEFINE CL_BUTTONEDEDIT}
  {$DEFINE CL_CATEGORY_PANEL}
  {$DEFINE CL_CHARACTER}
  {$DEFINE CL_LINKLABEL}
  {$DEFINE CL_LISTGROUPS}
  {$DEFINE CL_ENCODING}
  {$DEFINE CL_STRINGBUILDER}
  {$DEFINE CL_CUSTOMHINT}
  {$DEFINE CL_STRINGREADER}
  {$DEFINE CL_STREAMREADER}
  {$DEFINE CL_ACTIONMANAGER_LARGE_IMAGE}
  {$DEFINE CL_APPLICATION_DEFAULTFONT}
  {$DEFINE CL_BITMAP_ALPHA}
  {$DEFINE CL_BUTTON_IMAGES}
  {$DEFINE CL_CB_HINT}
  {$DEFINE CL_CONTROL_CUSTOMHINT}
  {$DEFINE CL_CUSTOMLISTVIEW_ONCHECKED}
  {$DEFINE CL_DBIMAGE_PROPORTIONAL}
  {$DEFINE CL_EDIT_ALIGNMENT}
  {$DEFINE CL_GRAPHIC_TRANSPARENCY}
  {$DEFINE CL_IMAGELIST_ALPHA}
  {$DEFINE CL_LABEL_GLOW}
  {$DEFINE CL_LISTVIEW_GROUPS}
  {$DEFINE CL_CUSTOMHEADER_CHECKBOXES}
  {$DEFINE CL_MASKEDIT_ALIGNMENT}
  {$DEFINE CL_MEMO_CHARCASE}
  {$DEFINE CL_OBJECT_EQUALS}
  {$DEFINE CL_PANEL_HIDE_CAPTION}
  {$DEFINE CL_POPUPACTIONBAR_STYLE}
  {$DEFINE CL_PROGRESSBAR_CUSTOM}
  {$DEFINE CL_RADIOGROUP_WORDWRAP}
  {$DEFINE CL_SCREEN_MESSAGEFONT}
  {$DEFINE CL_TRAYICON_BALLOONCLICK}
  {$DEFINE CL_TREEVIEW_DISABLED}
  {$DEFINE CL_WINCONTROL_DOUBLEBUFFERED}
{$ENDIF}
{$IFDEF DELPHIXE7UP}
  {$DEFINE ASSIGN_CONSTANT_ARRAY_TO_DYNAMIC}
  {$DEFINE DYNAMIC_ARRAY_CONCATENATION}
{$ENDIF}
{$IFDEF DELPHI10_1UP}
  {$DEFINE WEAK_REFERENCES}
{$ENDIF}
{$IFDEF _32BIT}
  {$DEFINE STDCALL_SUPPORTED}
{$ENDIF}
{$IFDEF _64BIT}
  {$DEFINE STDCALL_SUPPORTED}
{$ENDIF}

{$IFDEF DELPHI}
  {$DEFINE ASM_INLINE}
{$ENDIF}

{$IFDEF MOBILE}
  {$DEFINE NOVCL}
  {$UNDEF ASM}
  {$UNDEF ASM_CPUID}
  {$UNDEF ASM_INLINE}
{$ENDIF}

{$IFDEF OSX}
  {$DEFINE NOVCL}
  {$IFDEF _64BIT}
    {$DEFINE OSX64}
  {$ENDIF}
{$ENDIF}

{$IFDEF OSX64}
  {$UNDEF ASM}
  {$UNDEF ASM_CPUID}
  {$UNDEF ASM_INLINE}
{$ENDIF}

