{$IFNDEF FPC}
  {$N+}
{$ENDIF}
{
        Program Name : ErrMastr
        Package Name : Subroutine Library - Layer 1
        Purpose      : Master error control
        Institution  : Conroy & Conroy Co.
        Date Written : 10-Jan-1999
        Written By   : Alan Conroy
        Version      : 1.0A

        Copyright (C) 1999-2001 by Alan Conroy.  Released to the public domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

          16-Nov-2002   EAC         Fix BP compilation error.

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          This unit provides a single place for all application error
        handling.

          USE_UEH should be defined for applications which are going to use the
        UEH DLL, but the DLL itself should not define USE_UEH.  The DLL should
        define UEH instead.
}

unit ErrMastr ;

interface

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

{$I EDEFINES.INC}

uses { Borland... }
{$IFDEF BP}
     Objects, { TCollection }
     Strings, { strpas }
{$ENDIF}

     { C&C... }
//     _UEHDefs, { PSError_Interface }
     _UE, { tUnified_Exception }
     UE ; { TStandard_Error_Interface }

      { Master Error Operation.. }
const TMEO_Silent = 0 ;
      TMEO_Ignore = 1 ;
      TMEO_Show = 2 ;

      { Standard Error Levels... }
const SEL_Success = 0 ;
      SEL_Notification = 1 ;
      SEL_Warning = 2 ;
      SEL_Error = 3 ;
      SEL_Fatal = 4 ;

{$IFDEF FPC_OR_DELPHI}
function Error_Code( Facility, Code : longint ) : tUnified_Exception ;
{$ELSE}
function Error_Code( Facility, Code : longint ) : PSUnified_Exception ;
{$ENDIF}
//function Get_Error_Text( const UEC : TUnified_Exception ; Level : longint ) : PAnsiChar ;
//function Get_Error_Text_Old( const UEC : TUEC ; Level : longint ) : PAnsiChar ;
function Last_Error : Ansistring ;
//function Register_Error_Interface( EI : PSError_Interface ) : longbool ;
procedure Set_Master_Error_Operation( MEO : longint ) ;
function Facility_Count : longint ;
function Facility_From_Index( Index : longint ) : longint ;
//function Facility_Name_From_Index( Index : longint ) : PAnsiChar ;
function Unregister_Error_Interface( Facility : longint ) : longbool ;
//function Get_Error_Text_Ex( const UEC : TUnified_Exception ; Level : longint ;
//    var Size, Typ : longint ) : PAnsiChar ;
//function Severity( const UEC : TUnified_Exception ) : longint ;
function Version : longint ;
function DOS_ERT( Code : integer ) : Ansistring ;

var _Last_Error : PSUnified_Exception ;
    Master_Error_Operation : integer ;


implementation

uses { C&C... }
     _Applic, { Application_Manager }

{$IFDEF FPC_OR_DELPHI}
     { Borland... }
     SysUtils, { inttostr }
     Windows, { FormatMessage }

     { C&C... }
     Collect, { TCollection }
{$ELSE}
  {$IFDEF WINDOWS}
     WinDOS, { GetDate }
  {$ELSE}
     DOS, { GetEnv }
  {$ENDIF}
{$ENDIF}
     L10n ; { Text_* }

{$IFDEF USE_UEH}
var UEH32_Handle : integer = 0 ;
    UEH_Error_Code : function ( Facility, Code : longint ) : TUnified_Exception ; stdcall ;
    UEH_Get_Error_Text : function ( UEC : TUnified_Exception ; Level : longint ) : PAnsiChar ;
        stdcall ;
    UEH_Get_Error_Text_Ex : function ( UEC : TUnified_Exception ; Level : longint ;
        var Size, Typ : longint ) : PAnsiChar ; stdcall ;
    UEH_Last_Error : function  : PAnsiChar ; stdcall ;
    UEH_Log_Error : procedure ( UEC : TUnified_Exception ; T : PAnsiChar ; Level : longint ) ;
        stdcall ;
    UEH_Register_Error_Interface : function ( EI : PSError_Interface ) : longbool ;
        stdcall ;
    UEH_Set_Master_Error_Operation : procedure ( MEO : longint ) ; stdcall ;
    UEH_Facility_Count : function  : longint ; stdcall ;
    UEH_Facility_From_Index : function ( Index : longint ) : longint ; stdcall ;
    UEH_Facility_Name_From_Index : function ( Index : longint ) : PAnsichar ;
        stdcall ;
    UEH_Unregister_Error_Interface : function ( Facility : longint ) : longbool ;
        stdcall ;
    UEH_Version : function : longint ; stdcall ;
    UEH_Severity : function( UEC : TUnified_Exception ) : longint ; stdcall ;
{$ENDIF}

{$IFDEF FPC_OR_DELPHI}
type tDOS_EI = class( TStandard_Error_Interface )
                   public
                       function Get_Facility : longint ; override ;
                       function Get_Name : PAnsichar ;
                       function Translate_Error( _Code : longint ) : PAnsichar ;
                       procedure Done ;
                       function Facility_Version : longint ;
               end ;
{$ENDIF}
type tSDOS_EI = object( TSStandard_Error_Interface )
                    public
                        function Get_Facility : longint ; virtual ;
                        function Get_Name : Ansistring ; virtual ;
                        function Translate_Error( _Code : longint ) : Ansistring ;
                            virtual ;
                        function Facility_Version : longint ; virtual ;
                end ;
                
{$IFDEF FPC_OR_DELPHI}
type tWindows_EI = class( TStandard_Error_Interface )
                       public
                           function Get_Facility : longint ; override ;
                           function Get_Name : PAnsichar ;
                           function Translate_Error( _Code : longint ) : PAnsichar ;
                           procedure Done ;
                           function Facility_Version : longint ;
                   end ;
{$ENDIF}
type tSWindows_EI = object( TSStandard_Error_Interface )
                        public
                            function Get_Facility : longint ; virtual ;
                            function Get_Name : Ansistring ; virtual ;
                            function Translate_Error( _Code : longint ) : Ansistring ;
                                virtual ;
                            function Facility_Version : longint ; virtual ;
                    end ;

{$IFNDEF FPC_OR_DELPHI}
type pSDOS_EI = ^tSDOS_EI ;
     pSWindows_EI = ^tSWindows_EI ;
{$ENDIF}


function Date : Ansistring ;

    function Months( M : integer ) : Ansistring ;

    begin
        case M of
            0 : Months := Text_Month_Jan ;
            1 : Months := Text_Month_Feb ;
            2 : Months := Text_Month_Mar ;
            3 : Months := Text_Month_Apr ;
            4 : Months := Text_Month_May ;
            5 : Months := Text_Month_Jun ;
            6 : Months := Text_Month_Jul ;
            7 : Months := Text_Month_Aug ;
            8 : Months := Text_Month_Sep ;
            9 : Months := Text_Month_Oct ;
            10 : Months := Text_Month_Nov ;
            else Months := Text_Month_Dec ;
        end ;
    end ;


var Day_String, Year_String : string[ 4 ] ;
    Year, Month, Day : Word ;
{$IFNDEF FPC_OR_DELPHI}
    DOW : word ;
{$ENDIF}

begin
{$IFDEF FPC_OR_DELPHI}
    DecodeDate( SysUtils.Date, Year, Month, Day ) ;
{$ELSE}
    Getdate( Year, Month, Day, Dow ) ;
{$ENDIF}
    Str( Year, Year_String ) ;
    Str( Day, Day_String ) ; { Convert day and year to strings }
    if( Length( Day_String ) = 1 ) then
    begin
        Day_String := '0' + Day_String ;
    end ;
    Date := Day_String + '-' + Months( Month ) + '-' + Year_String ;
    { Now return value }
end ;


function Time : Ansistring ;

var Am_Pm : string[ 2 ] ;
    Hour, Minute, Second, Hundreths : Word ;
    Hour_String, Minute_String : string[ 2 ] ;

begin
{$IFDEF FPC_OR_DELPHI}
    DecodeTime( SysUtils.Time, Hour, Minute, Second, Hundreths ) ;
{$ELSE}
    Gettime( Hour, Minute, Second, Hundreths ) ;
{$ENDIF}
    Am_Pm := 'AM' ;
    if( Hour > 11 ) then
    begin
        Am_Pm := 'PM' ;
        if( Hour > 12 ) then
        begin
            Hour := Hour - 12 ;
        end ;
    end ;
    if( Hour = 0 ) then
    begin
        Hour := 12 ;
    end ;
    Str( Hour, Hour_String ) ;
    Str( Minute, Minute_String ) ; { Convert hour and minute to strings }
    if( Length( Minute_String ) = 1 ) then
    begin
        Minute_String := '0' + Minute_String ;
    end ;
    Time := Hour_String + ':' + Minute_String + ' ' + Am_Pm ; { Now return value }
end ;


procedure Clear_IOResult ;

{$IFNDEF FPC_OR_DELPHI}
var Dummy : integer ;
{$ENDIF}

begin
{$IFNDEF FPC_OR_DELPHI}
    Dummy :=
{$ENDIF}
    IOResult ;
end ;


{ Copied from Standard.  Must have here because we cannot reference Standard in
  this unit or else it initializes before we do - which is bad. }
procedure CC_Log( const X : Ansistring ) ; { Log a message }

{$IFDEF FPC_OR_DELPHI}
    function GetEnv( const X : Ansistring ) : Ansistring ;

    var Y : array[ 0..127 ] of Ansichar ;

    begin
        if( GetEnvironmentVariableA( PAnsiChar( X ), PAnsiChar( @Y ), 127 ) = 0 ) then
        begin
            GetEnv := '' ; { Not defined }
        end else
        begin
            GetEnv := Ansistring( @Y ) ;
        end ;
    end ;
{$ELSE}
  {$IFDEF WINDOWS}
    function GetENV( const X : Ansistring ) : Ansistring ;

    Type Env_Array = array[ 1..255 ] of Byte ;
         Env_Pointer = ^Env_Array ;

    var A : integer ;
        Ep : Env_Pointer ;
        Env : Ansistring ;
        Z : array[ 0..255 ] of Ansichar ;

    begin
        StrPCopy( Z, X ) ;
        Ep := Env_Pointer( Getenvvar( Z ) ) ;
        Env := '' ;
        if( Ep <> nil ) then {If variable is defined}
        begin
            A := 1 ;
            while( Ep^[ A ] <> 0 ) do {Until end of variable}
            begin
                Env := Env + Ansichar( Ep^[ A ] ) ;
                inc( A ) ;
            end ;
        end ;
        GetENV := Env ;
    end ;
  {$ENDIF}

    function FileExists( const S : Ansistring ) : boolean ;

    var F : file ;
        I : integer ;

    begin
        assign( F, S ) ;
        {$I-}
        reset( F ) ;
        {$I+}
        I := IOResult ;
        FileExists := ( I = 0 ) ;
        if( I = 0 ) then
        begin
            {$I-}
            close( F ) ;
            {$I+}
        end ;
        I := IOResult ;
    end ;
{$ENDIF}

var F : text ;
    S : Ansistring ;

begin
{$IFDEF FPC_OR_DELPHI}
  try
{$ENDIF}
    S := GetEnv( 'CCLOG' ) ;
    if( length( S ) > 0 ) then { Symbol is defined }
    begin
        assign( F, S ) ;
        if( FileExists( S ) ) then
        begin
            {$I-}
            append( F ) ;
            {$I+}
        end else
        begin
            {$I-}
            rewrite( F ) ;
            {$I+}
        end ;
        if( IOResult <> 0 ) then
        begin
            exit ; { Error opening file }
        end ;
        if( Application_Manager <> nil ) then
        begin
{$IFDEF FPC_OR_DELPHI}
            try
{$ENDIF}
                S := Application_Manager^.Get_Name ;
                if( length( S ) > 0 ) then
                begin
                    S := S + ' ' ;
                end ;
                if( length( Application_Manager^.Get_Version ) > 0 ) then
                begin
                    S := S + Application_Manager^.Get_Version ;
                end ;
{$IFDEF FPC_OR_DELPHI}
            except
            end ;
{$ENDIF}
        end else
        begin
            S := '' ;
        end ;
        {$I-}
        writeln( F, S, ' on ', Date, ' at ', Time, ': ', X ) ;
        {$I+}
        Clear_IOResult ;
        {$I-}
        close( F ) ;
        {$I+}
        Clear_IOResult ;
    end ; { if( length( S ) > 0 ) }
{$IFDEF FPC_OR_DELPHI}
  except
  end ;
{$ENDIF}
end ; { CC_Log }



const DOS_Name : Ansistring = 'MSDOS' ;

var DOS_Error_Text : array[ 0..127 ] of Ansichar ;

function DOS_ERT( Code : integer ) : Ansistring ;

var Err_String : Ansistring ;

begin
    case Code of
        0 : Err_String := Text_DOS_Error_Success ;
        1 : Err_String := Text_DOS_Error_1 ;
        2 : Err_String := Text_DOS_Error_2 ;
        3 : Err_String := Text_DOS_Error_3 ;
        4 : Err_String := Text_DOS_Error_4 ;
        5 : Err_String := Text_DOS_Error_5 ;
        6 : Err_String := Text_DOS_Error_6 ;
        7 : Err_String := Text_DOS_Error_7 ;
        8 : Err_String := Text_DOS_Error_8 ;
        9 : Err_String := Text_DOS_Error_9 ;
        10 : Err_String := Text_DOS_Error_10 ;
        11 : Err_String := Text_DOS_Error_11 ;
        12 : Err_String := Text_DOS_Error_12 ;
        13 : Err_String := Text_DOS_Error_13 ;
        14 : Err_String := Text_DOS_Error_14 ;
        15 : Err_String := Text_DOS_Error_15 ;
        16 : Err_String := Text_DOS_Error_16 ;
        17 : Err_String := Text_DOS_Error_17 ;
        18 : Err_String := Text_DOS_Error_18 ;
        19 : Err_String := Text_DOS_Error_19 ;
        20 : Err_String := Text_DOS_Error_20 ;
        21 : Err_String := Text_DOS_Error_21 ;
        22 : Err_String := Text_DOS_Error_22 ;
        23 : Err_String := Text_DOS_Error_23 ;
        24 : Err_String := Text_DOS_Error_24 ;
        25 : Err_String := Text_DOS_Error_25 ;
        26 : Err_String := Text_DOS_Error_26 ;
        27 : Err_String := Text_DOS_Error_27 ;
        28 : Err_String := Text_DOS_Error_28 ;
        29 : Err_String := Text_DOS_Error_29 ;
        30 : Err_String := Text_DOS_Error_30 ;
        31 : Err_String := Text_DOS_Error_31 ;
        32 : Err_String := Text_DOS_Error_32 ;
        33 : Err_String := Text_DOS_Error_33 ;
        34 : Err_String := Text_DOS_Error_34 ;
        35 : Err_String := Text_DOS_Error_35 ;
        36 : Err_String := Text_DOS_Error_36 ;
        38 : Err_String := Text_DOS_Error_38 ;
        50 : Err_String := Text_DOS_Error_50 ;
        51 : Err_String := Text_DOS_Error_51 ;
        52 : Err_String := Text_DOS_Error_52 ;
        53 : Err_String := Text_DOS_Error_53 ;
        54 : Err_String := Text_DOS_Error_54 ;
        55 : Err_String := Text_DOS_Error_55 ;
        56 : Err_String := Text_DOS_Error_56 ;
        57 : Err_String := Text_DOS_Error_57 ;
        58 : Err_String := Text_DOS_Error_58 ;
        59 : Err_String := Text_DOS_Error_59 ;
        60 : Err_String := Text_DOS_Error_60 ;
        61 : Err_String := Text_DOS_Error_61 ;
        62 : Err_String := Text_DOS_Error_62 ;
        63 : Err_String := Text_DOS_Error_63 ;
        64 : Err_String := Text_DOS_Error_64 ;
        65 : Err_String := Text_DOS_Error_65 ;
        66 : Err_String := Text_DOS_Error_66 ;
        67 : Err_String := Text_DOS_Error_67 ;
        68 : Err_String := Text_DOS_Error_68 ;
        69 : Err_String := Text_DOS_Error_69 ;
        70 : Err_String := Text_DOS_Error_70 ;
        71 : Err_String := Text_DOS_Error_71 ;
        72 : Err_String := Text_DOS_Error_72 ;
        80 : Err_String := Text_DOS_Error_80 ;
        81 : Err_String := Text_DOS_Error_81 ;
        82 : Err_String := Text_DOS_Error_82 ;
        83 : Err_String := Text_DOS_Error_83 ;
        84 : Err_String := Text_DOS_Error_84 ;
        85 : Err_String := Text_DOS_Error_85 ;
        86 : Err_String := Text_DOS_Error_86 ;
        87 : Err_String := Text_DOS_Error_87 ;
        88 : Err_String := Text_DOS_Error_88 ;
        89 : Err_String := Text_DOS_Error_89 ;
        90 : Err_String := Text_DOS_Error_90 ;
        91 : Err_String := Text_DOS_Error_91 ;
        92 : Err_String := Text_DOS_Error_92 ;
        93 : Err_String := Text_DOS_Error_93 ;
        95 : Err_String := Text_DOS_Error_95 ;
        100 : Err_String := Text_DOS_Error_100 ;
        101 : Err_String := Text_DOS_Error_101 ;
        102 : Err_String := Text_DOS_Error_102 ;
        103 : Err_String := Text_DOS_Error_103 ;
        104 : Err_String := Text_DOS_Error_104 ;
        105 : Err_String := Text_DOS_Error_105 ;
        106 : Err_String := Text_DOS_Error_106 ;
        107 : Err_String := Text_DOS_Error_107 ;
        108 : Err_String := Text_DOS_Error_108 ;
        109 : Err_String := Text_DOS_Error_109 ;
        110 : Err_String := Text_DOS_Error_110 ;
        111 : Err_String := Text_DOS_Error_111 ;
        112 : Err_String := Text_DOS_Error_112 ;
        113 : Err_String := Text_DOS_Error_113 ;
        114 : Err_String := Text_DOS_Error_114 ;
        115 : Err_String := Text_DOS_Error_115 ;
        116 : Err_String := Text_DOS_Error_116 ;
        117 : Err_String := Text_DOS_Error_117 ;
        118 : Err_String := Text_DOS_Error_118 ;
        119 : Err_String := Text_DOS_Error_119 ;
        120 : Err_String := Text_DOS_Error_120 ;
        121 : Err_String := Text_DOS_Error_121 ;
        122 : Err_String := Text_DOS_Error_122 ;
        123 : Err_String := Text_DOS_Error_123 ;
        124 : Err_String := Text_DOS_Error_124 ;
        125 : Err_String := Text_DOS_Error_125 ;
        126 : Err_String := Text_DOS_Error_126 ;
        127 : Err_String := Text_DOS_Error_127 ;
        128 : Err_String := Text_DOS_Error_128 ;
        129 : Err_String := Text_DOS_Error_129 ;
        130 : Err_String := Text_DOS_Error_130 ;
        131 : Err_String := Text_DOS_Error_131 ;
        132 : Err_String := Text_DOS_Error_132 ;
        133 : Err_String := Text_DOS_Error_133 ;
        134 : Err_String := Text_DOS_Error_134 ;
        135 : Err_String := Text_DOS_Error_135 ;
        136 : Err_String := Text_DOS_Error_136 ;
        137 : Err_String := Text_DOS_Error_137 ;
        138 : Err_String := Text_DOS_Error_138 ;
        139 : Err_String := Text_DOS_Error_139 ;
        140 : Err_String := Text_DOS_Error_140 ;
        141 : Err_String := Text_DOS_Error_141 ;
        142 : Err_String := Text_DOS_Error_142 ;
        143 : Err_String := Text_DOS_Error_143 ;
        144 : Err_String := Text_DOS_Error_144 ;
        145 : Err_String := Text_DOS_Error_145 ;
        146 : Err_String := Text_DOS_Error_146 ;
        147 : Err_String := Text_DOS_Error_147 ;
        148 : Err_String := Text_DOS_Error_148 ;
        149 : Err_String := Text_DOS_Error_149 ;
        150 : Err_String := Text_DOS_Error_150 ;
        151 : Err_String := Text_DOS_Error_151 ;
        152 : Err_String := Text_DOS_Error_152 ;
        153 : Err_String := Text_DOS_Error_153 ;
        154 : Err_String := Text_DOS_Error_154 ;
        155 : Err_String := Text_DOS_Error_155 ;
        156 : Err_String := Text_DOS_Error_156 ;
        157 : Err_String := Text_DOS_Error_157 ;
        158 : Err_String := Text_DOS_Error_158 ;
        159 : Err_String := Text_DOS_Error_159 ;
        160 : Err_String := Text_DOS_Error_160 ;
        161 : Err_String := Text_DOS_Error_161 ;
        162 : Err_String := Text_DOS_Error_162 ;
        163 : Err_String := Text_DOS_Error_163 ;
        164 : Err_String := Text_DOS_Error_164 ;
        165 : Err_String := Text_DOS_Error_165 ;
        180 : Err_String := Text_DOS_Error_180 ;
        181 : Err_String := Text_DOS_Error_181 ;
        182 : Err_String := Text_DOS_Error_182 ;
        183 : Err_String := Text_DOS_Error_183 ;
        184 : Err_String := Text_DOS_Error_184 ;
        185 : Err_String := Text_DOS_Error_185 ;
        186 : Err_String := Text_DOS_Error_186 ;
        187 : Err_String := Text_DOS_Error_187 ;
        188 : Err_String := Text_DOS_Error_188 ;
        189 : Err_String := Text_DOS_Error_189 ;
        190 : Err_String := Text_DOS_Error_190 ;
        191 : Err_String := Text_DOS_Error_191 ;
        192 : Err_String := Text_DOS_Error_192 ;
        193 : Err_String := Text_DOS_Error_193 ;
        194 : Err_String := Text_DOS_Error_194 ;
        195 : Err_String := Text_DOS_Error_195 ;
        196 : Err_String := Text_DOS_Error_196 ;
        197 : Err_String := Text_DOS_Error_197 ;
        198 : Err_String := Text_DOS_Error_198 ;
        199 : Err_String := Text_DOS_Error_199 ;
        200 : Err_String := Text_DOS_Error_200 ;
        201 : Err_String := Text_DOS_Error_201 ;
        202 : Err_String := Text_DOS_Error_202 ;
        203 : Err_String := Text_DOS_Error_203 ;
        204 : Err_String := Text_DOS_Error_204 ;
        205 : Err_String := Text_DOS_Error_205 ;
        206 : Err_String := Text_DOS_Error_206 ;
        207 : Err_String := Text_DOS_Error_207 ;
        208 : Err_String := Text_DOS_Error_208 ;
        209 : Err_String := Text_DOS_Error_209 ;
        210 : Err_String := Text_DOS_Error_210 ;
        211 : Err_String := Text_DOS_Error_211 ;
        212 : Err_String := Text_DOS_Error_212 ;
        213 : Err_String := Text_DOS_Error_213 ;
        214 : Err_String := Text_DOS_Error_214 ;
        215 : Err_String := Text_DOS_Error_215 ;
        216 : Err_String := Text_DOS_Error_216 ;

        { RAS error codes... }
        600 : Err_String := Text_DOS_Error_600 ;
        601 : Err_String := Text_DOS_Error_601 ;
        602 : Err_String := Text_DOS_Error_602 ;
        603 : Err_String := Text_DOS_Error_603 ;
        604 : Err_String := Text_DOS_Error_604 ;
        605 : Err_String := Text_DOS_Error_605 ;
        606 : Err_String := Text_DOS_Error_606 ;
        607 : Err_String := Text_DOS_Error_607 ;
        608 : Err_String := Text_DOS_Error_608 ;
        609 : Err_String := Text_DOS_Error_609 ;
        610 : Err_String := Text_DOS_Error_610 ;
        611 : Err_String := Text_DOS_Error_611 ;
        612 : Err_String := Text_DOS_Error_612 ;
        613 : Err_String := Text_DOS_Error_613 ;
        614 : Err_String := Text_DOS_Error_614 ;
        615 : Err_String := Text_DOS_Error_615 ;
        616 : Err_String := Text_DOS_Error_616 ;
        617 : Err_String := Text_DOS_Error_617 ;
        618 : Err_String := Text_DOS_Error_618 ;
        619 : Err_String := Text_DOS_Error_619 ;
        620 : Err_String := Text_DOS_Error_620 ;
        621 : Err_String := Text_DOS_Error_621 ;
        622 : Err_String := Text_DOS_Error_622 ;
        623 : Err_String := Text_DOS_Error_623 ;
        624 : Err_String := Text_DOS_Error_624 ;
        625 : Err_String := Text_DOS_Error_625 ;
        626 : Err_String := Text_DOS_Error_626 ;
        627 : Err_String := Text_DOS_Error_627 ;
        628 : Err_String := Text_DOS_Error_628 ;
        629 : Err_String := Text_DOS_Error_629 ;
        630 : Err_String := Text_DOS_Error_630 ;
        631 : Err_String := Text_DOS_Error_631 ;
        632 : Err_String := Text_DOS_Error_632 ;
        633 : Err_String := Text_DOS_Error_633 ;
        634 : Err_String := Text_DOS_Error_634 ;
        635 : Err_String := Text_DOS_Error_635 ;
        636 : Err_String := Text_DOS_Error_636 ;
        637 : Err_String := Text_DOS_Error_637 ;
        638 : Err_String := Text_DOS_Error_638 ;
        639 : Err_String := Text_DOS_Error_639 ;
        640 : Err_String := Text_DOS_Error_640 ;
        641 : Err_String := Text_DOS_Error_641 ;
        642 : Err_String := Text_DOS_Error_642 ;
        643 : Err_String := Text_DOS_Error_643 ;
        644 : Err_String := Text_DOS_Error_644 ;
        645 : Err_String := Text_DOS_Error_645 ;
        646 : Err_String := Text_DOS_Error_646 ;
        647 : Err_String := Text_DOS_Error_647 ;
        648 : Err_String := Text_DOS_Error_648 ;
        649 : Err_String := Text_DOS_Error_649 ;
        650 : Err_String := Text_DOS_Error_650 ;
        651 : Err_String := Text_DOS_Error_651 ;
        652 : Err_String := Text_DOS_Error_652 ;
        653 : Err_String := Text_DOS_Error_653 ;
        654 : Err_String := Text_DOS_Error_654 ;
        655 : Err_String := Text_DOS_Error_655 ;
        656 : Err_String := Text_DOS_Error_656 ;
        657 : Err_String := Text_DOS_Error_657 ;
        658 : Err_String := Text_DOS_Error_658 ;
        659 : Err_String := Text_DOS_Error_659 ;
        660 : Err_String := Text_DOS_Error_660 ;
        661 : Err_String := Text_DOS_Error_661 ;
        662 : Err_String := Text_DOS_Error_662 ;
        663 : Err_String := Text_DOS_Error_663 ;
        664 : Err_String := Text_DOS_Error_664 ;
        665 : Err_String := Text_DOS_Error_665 ;
        666 : Err_String := Text_DOS_Error_666 ;
        667 : Err_String := Text_DOS_Error_667 ;
        668 : Err_String := Text_DOS_Error_668 ;
        669 : Err_String := Text_DOS_Error_669 ;
        670 : Err_String := Text_DOS_Error_670 ;
        671 : Err_String := Text_DOS_Error_671 ;
        672 : Err_String := Text_DOS_Error_672 ;
        673 : Err_String := Text_DOS_Error_673 ;
        674 : Err_String := Text_DOS_Error_674 ;
        675 : Err_String := Text_DOS_Error_675 ;
        676 : Err_String := Text_DOS_Error_676 ;
        677 : Err_String := Text_DOS_Error_677 ;
        678 : Err_String := Text_DOS_Error_678 ;
        679 : Err_String := Text_DOS_Error_679 ;
        680 : Err_String := Text_DOS_Error_680 ;
        681 : Err_String := Text_DOS_Error_681 ;
        682 : Err_String := Text_DOS_Error_682 ;
        683 : Err_String := Text_DOS_Error_683 ;
        684 : Err_String := Text_DOS_Error_684 ;
        685 : Err_String := Text_DOS_Error_685 ;
        686 : Err_String := Text_DOS_Error_686 ;
        687 : Err_String := Text_DOS_Error_687 ;
        688 : Err_String := Text_DOS_Error_688 ;
        689 : Err_String := Text_DOS_Error_689 ;
        690 : Err_String := Text_DOS_Error_690 ;
        691 : Err_String := Text_DOS_Error_691 ;
        692 : Err_String := Text_DOS_Error_692 ;
        693 : Err_String := Text_DOS_Error_693 ;
        694 : Err_String := Text_DOS_Error_694 ;
        695 : Err_String := Text_DOS_Error_695 ;
        696 : Err_String := Text_DOS_Error_696 ;
        697 : Err_String := Text_DOS_Error_697 ;
        698 : Err_String := Text_DOS_Error_698 ;
        699 : Err_String := Text_DOS_Error_699 ;
        700 : Err_String := Text_DOS_Error_700 ;
        701 : Err_String := Text_DOS_Error_701 ;
        702 : Err_String := Text_DOS_Error_702 ;
        703 : Err_String := Text_DOS_Error_703 ;
        704 : Err_String := Text_DOS_Error_704 ;
        705 : Err_String := Text_DOS_Error_705 ;
        706 : Err_String := Text_DOS_Error_706 ;
        707 : Err_String := Text_DOS_Error_707 ;
        708 : Err_String := Text_DOS_Error_708 ;
        709 : Err_String := Text_DOS_Error_709 ;
        710 : Err_String := Text_DOS_Error_710 ;
        711 : Err_String := Text_DOS_Error_711 ;
        712 : Err_String := Text_DOS_Error_712 ;
        713 : Err_String := Text_DOS_Error_713 ;
        714 : Err_String := Text_DOS_Error_714 ;
        715 : Err_String := Text_DOS_Error_715 ;
        716 : Err_String := Text_DOS_Error_716 ;
        717 : Err_String := Text_DOS_Error_717 ;
        718 : Err_String := Text_DOS_Error_718 ;
        719 : Err_String := Text_DOS_Error_719 ;
        720 : Err_String := Text_DOS_Error_720 ;
        721 : Err_String := Text_DOS_Error_721 ;
        722 : Err_String := Text_DOS_Error_722 ;
        723 : Err_String := Text_DOS_Error_723 ;
        724 : Err_String := Text_DOS_Error_724 ;
        725 : Err_String := Text_DOS_Error_725 ;
        726 : Err_String := Text_DOS_Error_726 ;
        727 : Err_String := Text_DOS_Error_727 ;
        728 : Err_String := Text_DOS_Error_728 ;
        729 : Err_String := Text_DOS_Error_729 ;
        730 : Err_String := Text_DOS_Error_730 ;
        731 : Err_String := Text_DOS_Error_731 ;
        732 : Err_String := Text_DOS_Error_732 ;
        733 : Err_String := Text_DOS_Error_733 ;
        734 : Err_String := Text_DOS_Error_734 ;
        735 : Err_String := Text_DOS_Error_735 ;
        736 : Err_String := Text_DOS_Error_736 ;
        737 : Err_String := Text_DOS_Error_737 ;
        738 : Err_String := Text_DOS_Error_738 ;
        739 : Err_String := Text_DOS_Error_739 ;
        740 : Err_String := Text_DOS_Error_740 ;
        741 : Err_String := Text_DOS_Error_741 ;
        742 : Err_String := Text_DOS_Error_742 ;
        743 : Err_String := Text_DOS_Error_743 ;
        744 : Err_String := Text_DOS_Error_744 ;
        752 : Err_String := Text_DOS_Error_752 ;
        else
        Begin
            Str( Code, Err_String ) ;
            Err_String := Substitute1( Text_Error_Unused_Error_Number, Err_String ) ;
        end ;
    end ; { Case Code of }
    DOS_ERT := Err_String ;
end ; { DOS_ERT }


{$IFDEF FPC_OR_DELPHI}
{ TDOS_EI methods... }

function tDOS_EI.Get_Facility : longint ;

begin
    Get_Facility := 1 ;
end ;


function tDOS_EI.Get_Name : PAnsichar ;

begin
    Get_Name := PAnsiChar( DOS_Name ) ;
end ;


function tDOS_EI.Translate_Error( _Code : longint ) : PAnsichar ;

var Err_String : Ansistring ;

begin
    Err_String := DOS_ERT( _Code ) + #0 ;
    move( Err_String[ 1 ], DOS_Error_Text[ 0 ], length( Err_String ) ) ;
    Translate_Error := @DOS_Error_Text ;
end ; { tDOS_EI.Translate_Error }


procedure tDOS_EI.Done ;

begin
{ Destroyed in this unit. }
end ;


function tDOS_EI.Facility_Version : longint ;

begin
    Facility_Version := 21 ; { DOS 2.1 }
end ;
{$ENDIF}



{ TSDOS_EI methods... }

function tSDOS_EI.Get_Facility : longint ;

begin
    Get_Facility := 1 ;
end ;


function tSDOS_EI.Get_Name : Ansistring ;

begin
    Get_Name := DOS_Name ;
end ;


function tSDOS_EI.Translate_Error( _Code : longint ) : Ansistring ;

var Err_String : Ansistring ;

begin
    Err_String := DOS_ERT( _Code ) ;
    Translate_Error := Err_String ;
end ; { tSDOS_EI.Translate_Error }


function tSDOS_EI.Facility_Version : longint ;

begin
    Facility_Version := 21 ; { DOS 2.1 }
end ;



const Windows_Name : Ansistring = 'MS Windows' ;

var Windows_Error_Text : array[ 0..127 ] of Ansichar ;

{$IFDEF FPC_OR_DELPHI}
{ tWindows_EI methods... }

function tWindows_EI.Get_Facility : longint ;

begin
    Get_Facility := 0 ;
end ;


function tWindows_EI.Get_Name : PAnsichar ;

begin
    Get_Name := PAnsiChar( Windows_Name ) ;
end ;


function tWindows_EI.Translate_Error( _Code : longint ) : PAnsichar ;

begin
    FormatMessage( FORMAT_MESSAGE_FROM_SYSTEM or FORMAT_MESSAGE_IGNORE_INSERTS,
        nil, _Code, 0, @Windows_Error_Text, 128, nil ) ;
    Windows_Error_Text[ 127 ] := #0 ;
    Translate_Error := @Windows_Error_Text ;
end ;


procedure tWindows_EI.Done ;

begin
{ Destroyed in this unit. }
end ;


function tWindows_EI.Facility_Version : longint ;

begin
    Facility_Version := 40 ; { MS Windows 95/NT and later }
end ;
{$ENDIF}



{ tSWindows_EI methods... }

function tSWindows_EI.Get_Facility : longint ;

begin
    Get_Facility := 0 ;
end ;


function tSWindows_EI.Get_Name : Ansistring ;

begin
    Get_Name := Windows_Name ;
end ;


function tSWindows_EI.Translate_Error( _Code : longint ) : Ansistring ;

var S : Ansistring ;

begin
    str( _Code, S ) ;
    S := Substitute1( Text_Unknown_Error_Code, S ) ;
    Translate_Error := S ;
end ;


function tSWindows_EI.Facility_Version : longint ;

begin
    Facility_Version := 40 ; { MS Windows 95/NT and later }
end ;



{ Internal unit data... }

var Interfaces : TCollection ;
    Facility_IDs : TCollection ;
    Last_Error_Text : array[ 0..254 ] of Ansichar ;
{$IFDEF FPC_OR_DELPHI}
    State : integer = 0 ;
{$ELSE}
    State : integer ;
{$ENDIF}

{ Internal unit utility methods... }

{ Unit API... }

{$IFDEF FPC_OR_DELPHI}
function Error_Code( Facility, Code : longint ) : tUnified_Exception ;
{$ELSE}
function Error_Code( Facility, Code : longint ) : PSUnified_Exception ;
{$ENDIF}

begin
    Result := Create_Simple_UE( Facility, -1, Code, 0, '', '' ) ;
end ;


(*
function Get_Error_Text_Old( const UEC : TUEC ; Level : longint ) : Ansichar ;

var Dummy : integer ;
    EI : PSError_Interface ;
    Num1, S, Txt : Ansistring ;
    _S, _T : longint ;

begin
    if( State = 0 ) then { Not in a valid state }
    begin
        Dummy := -1 ;
    end else
    begin
        Dummy := Facility_IDs.IndexOf( pointer( UEC.Facility ) ) ;
    end ;
    if( Dummy = -1 ) then
    begin
        str( UEC.Facility, Num1 ) ;
        str( UEC.Code, S ) ;
        Txt := Substitute2( Text_Facility_n_Error_n, S, '' ) ;
    end else
    begin
        EI := Interfaces.At( Dummy ) ;
{$IFDEF FPC_OR_DELPHI}
        Txt := strpas( TError_Interface( EI ).Get_Name ) + ' - ' +
            strpas( TError_Interface( EI ).Translate_Error( UEC.Code ) ) ;
        if( TError_Interface( EI ).Version >= 12 ) then { Supports severity }
        begin
            if( Level = -1 ) then
            begin
                Level := TError_Interface( EI ).Severity( UEC.Code ) ;
            end ;
        end ;
{$ELSE}
        Txt := EI^.Get_Name + ' - ' + EI^.Translate_Error( UEC.Code ) ;
        if( EI^.Version >= 12 ) then { Supports severity }
        begin
            if( Level = -1 ) then
            begin
                Level := EI^.Severity( UEC.Code ) ;
            end ;
        end ;
{$ENDIF}
    end ;
    case Level of
        SEL_Success : S := Text_Error_Severity_Success ;
        SEL_Notification : S := Text_Error_Severity_Notification  ;
        SEL_Warning : S := Text_Error_Severity_Warning ;
        SEL_Error : S := Text_Error_Severity_Error ;
        SEL_Fatal : S := Text_Error_Severity_Fatal ;
        else S := '' ;
    end ;
    if( length( S ) > 0 ) then
    begin
        str( UEC.Code, Num1 ) ;
        S := S + num1 + ': ' ;
    end ;
    S := S + Txt + #0 ;
    move( S[ 1 ], Last_Error_Text[ 0 ], length( S ) ) ;
    Get_Error_Text_Old := @Last_Error_Text ;
end ;


function Get_Error_Text( const UEC : TUnified_Exception ; Level : longint ) : Ansichar ;

var Dummy : integer ;
    EI : PSError_Interface ;
    Num1, S, Txt : Ansistring ;
    _S, _T : longint ;

begin
{$IFDEF USE_UEH}
    if( assigned( UEH_Get_Error_Text ) ) then
    begin
        Result := UEH_Get_Error_Text( UEC, Level ) ;
        exit ;
    end ;
{$ENDIF}
    if( State = 0 ) then { Not in a valid state }
    begin
        Dummy := -1 ;
    end else
    begin
        Dummy := Facility_IDs.IndexOf( pointer( UEC.Get_Facility ) ) ;
    end ;
    if( Dummy = -1 ) then
    begin
        str( UEC.Get_Facility, Num1 ) ;
        str( UEC.Get_Error, S ) ;
        Txt := Substitute2( Text_Facility_n_Error_n, S, UEC.Error_Text( _S, _T ) ) ;
    end else
    begin
        EI := Interfaces.At( Dummy ) ;
{$IFDEF FPC_OR_DELPHI}
        Txt := strpas( TError_Interface( EI ).Get_Name ) + ' - ' +
            strpas( TError_Interface( EI ).Translate_Error( UEC.Get_Error ) ) ;
        if( TError_Interface( EI ).Version >= 12 ) then { Supports severity }
        begin
            if( Level = -1 ) then
            begin
                Level := TError_Interface( EI ).Severity( UEC.Get_Error ) ;
            end ;
        end ;
{$ELSE}
        Txt := EI^.Get_Name + ' - ' + EI^.Translate_Error( UEC.Code ) ;
        if( EI^.Version >= 12 ) then { Supports severity }
        begin
            if( Level = -1 ) then
            begin
                Level := EI^.Severity( UEC.Code ) ;
            end ;
        end ;
{$ENDIF}
    end ;
    case Level of
        SEL_Success : S := Text_Error_Severity_Success ;
        SEL_Notification : S := Text_Error_Severity_Notification  ;
        SEL_Warning : S := Text_Error_Severity_Warning ;
        SEL_Error : S := Text_Error_Severity_Error ;
        SEL_Fatal : S := Text_Error_Severity_Fatal ;
        else S := '' ;
    end ;
    if( length( S ) > 0 ) then
    begin
        str( UEC.Get_Error, Num1 ) ;
        S := S + num1 + ': ' ;
    end ;
    S := S + Txt + #0 ;
    move( S[ 1 ], Last_Error_Text[ 0 ], length( S ) ) ;
    Get_Error_Text := @Last_Error_Text ;
end ; { Get_Error_Text }


function Get_Error_Text_Ex( const UEC : TUnified_Exception ; Level : longint ;
    var Size, Typ : longint ) : Ansichar ;

var Dummy : integer ;
    EI : PSError_Interface ;
    P : Ansichar ;
    Num1, S, Txt : Ansistring ;

begin
{$IFDEF USE_UEH}
    if( assigned( UEH_Get_Error_Text_Ex ) ) then
    begin
        Result := UEH_Get_Error_Text_Ex( UEC, Level, Size, Typ ) ;
        exit ;
    end ;
{$ENDIF}
    if( State = 0 ) then { Not in a valid state }
    begin
        Dummy := -1 ;
    end else
    begin
        Dummy := Facility_IDs.IndexOf( pointer( UEC.Get_Facility ) ) ;
    end ;
    if( Dummy > -1 ) then
    begin
        EI := Interfaces.At( Dummy ) ;
{$IFDEF FPC_OR_DELPHI}
        if( TError_Interface( EI ).Version >= 12 ) then { Supports extended error translation }
        begin
            Txt := strpas( TError_Interface( EI ).Get_Name ) + ' - ' +
                strpas( TError_Interface( EI ).Translate_Error_Ex( UEC.Get_Error, Size, Typ ) ) ;
            if( Level = -1 ) then
            begin
                Level := TError_Interface( EI ).Severity( UEC.Get_Error ) ;
            end ;
{$ELSE}
        if( EI^.Version >= 12 ) then { Supports extended error translation }
        begin
            Txt := EI^.Get_Name + ' - ' + EI^.Translate_Error_Ex( UEC.Get_Error, Size, Typ ) ;
            if( Level = -1 ) then
            begin
                Level := EI^.Severity( UEC.Code ) ;
            end ;
{$ENDIF}
            case Level of
                SEL_Success : S := Text_Error_Severity_Success ;
                SEL_Notification : S := Text_Error_Severity_Notification ;
                SEL_Warning : S := Text_Error_Severity_Warning ;
                SEL_Error : S := Text_Error_Severity_Error ;
                SEL_Fatal : S := Text_Error_Severity_Fatal ;
                else S := '' ;
            end ;
            if( length( S ) > 0 ) then
            begin
                str( UEC.Get_Error, Num1 ) ;
                S := S + num1 + ': ' ;
            end ;
            S := S + Txt ;
            Size := length( S ) ;
            S := S + #0 ;
            move( S[ 1 ], Last_Error_Text[ 0 ], length( S ) ) ;
            Get_Error_Text_Ex := @Last_Error_Text ;
            exit ;
        end ; { if( EI.Version >= 12 ) }
    end ; { if( Dummy > -1 ) }

    P := Get_Error_Text( UEC, Level ) ;
    if( P = nil ) then
    begin
        Size := 0 ;
    end else
    begin
        Size := strlen( P ) ;
    end ;
    Typ := 0 ; { 7-bit ASCII }
    Get_Error_Text_Ex := P ;
end ; { Get_Error_Text_Ex }
*)


function Last_Error : Ansistring ;

var _S, _T : longint ;

begin
    Last_Error := _Last_Error.Error_Text( _S, _T ) ;
end ;


(*
{ Registers the error interface, returning True if succesful; false otherwise. }
function Register_Error_Interface( EI : PSError_Interface ) : longbool ;

var Dummy, Index : integer ;
    Old_EI : PSError_Interface ;
    Facility_Version, Old_Facility_Version, Version, Old_Version : longint ;

begin
{$IFDEF USE_UEH}
    if( assigned( UEH_Register_Error_Interface ) ) then
    begin
        Result := UEH_Register_Error_Interface( EI ) ;
        exit ;
    end ;
{$ENDIF}
    if( EI = nil ) then
    begin
        Register_Error_Interface := False ;
        exit ;
    end ;
    if( State = 0 ) then { Not in a valid state }
    begin
        Register_Error_Interface := False ;
        exit ;
    end ;
    Register_Error_Interface := True ;
{$IFDEF FPC_OR_DELPHI}
    Dummy := TError_Interface( EI ).Get_Facility ;
    Version := TError_Interface( EI ).Version ;
    Facility_Version := TError_Interface( EI ).Facility_Version ;
{$ELSE}
    Dummy := EI^.Get_Facility ;
    Version := EI^.Version ;
    Facility_Version := EI^.Facility_Version ;
{$ENDIF}
    Index := Facility_IDs.IndexOf( pointer( Dummy ) ) ;
    if( Index <> -1 ) then { This facility was already registered }
    begin
        Old_EI := PSError_Interface( Interfaces.At( Index ) ) ;
{$IFDEF FPC_OR_DELPHI}
        Old_Version := TError_Interface( Old_EI ).Version ;
        Old_Facility_Version := TError_Interface( Old_EI ).Facility_Version ;
{$ELSE}
        Old_Version := Old_EI^.Version ;
        Old_Facility_Version := Old_EI^.Facility_Version ;
{$ENDIF}
        if(
            ( Old_Facility_Version < Facility_Version )
            or
            (
              ( Old_Facility_Version = Facility_Version )
              and
              ( Old_Version < Version )
            )
          ) then
        begin
            { We get here if the previous registered facility was an older
              version of the facility, or the same facility version, but
              supporting an older UEH specification. }
{$IFDEF FPC_OR_DELPHI}
            Old_EI^.Done ; { Get rid of the old one }
{$ELSE}
            Old_EI^.Done ; { Get rid of the old one }
{$ENDIF}
            Unregister_Error_Interface( Dummy ) ; { Remove it from our list }
        end else
        begin
            Register_Error_Interface := False ;
            exit ;
        end ;
    end ;
    Facility_IDs.Insert( pointer( Dummy ) ) ;
    Interfaces.Insert( EI ) ;
end ; { Register_Error_Interface }
*)


procedure Set_Master_Error_Operation( MEO : longint ) ;

begin
{$IFDEF USE_UEH}
    if( assigned( UEH_Set_Master_Error_Operation ) ) then
    begin
        UEH_Set_Master_Error_Operation( MEO ) ;
        exit ;
    end ;
{$ENDIF}
    Master_Error_Operation := MEO ;
end ;


function Facility_Count : longint ;

begin
{$IFDEF USE_UEH}
    if( assigned( UEH_Facility_Count ) ) then
    begin
        Result := UEH_Facility_Count ;
        exit ;
    end ;
{$ENDIF}
    if( State = 0 ) then { Not in a valid state }
    begin
        Facility_Count := 0 ;
    end else
    begin
        Facility_Count := Facility_IDs.Count ;
    end ;
end ;


function Facility_From_Index( Index : longint ) : longint ;

begin
    if( ( Index < 0 ) or ( Index >= Facility_Count ) ) then
    begin
        Facility_From_Index := -1 ;
        exit ;
    end ;
{$IFDEF USE_UEH}
    if( assigned( UEH_Facility_From_Index ) ) then
    begin
        Result := UEH_Facility_From_Index( Index ) ;
        exit ;
    end ;
{$ENDIF}
    if( ( State = 0 ) or ( Facility_IDs.Count <= Index ) or ( Index < 0 ) ) then { Not in a valid state, or out of range }
    begin
        Facility_From_Index := -1 ;
    end else
    begin
        Facility_From_Index := integer( Facility_IDs.At( Index ) ) ;
    end ;
end ;


{$IFNDEF FPC_OR_DELPHI}
var Temp_Facility_Name_From_Index : string[ 255 ] ;
{$ENDIF}

(*
function Facility_Name_From_Index( Index : longint ) : Ansichar ;

var EI : PSError_Interface ;

begin
    if( ( Index < 0 ) or ( Index >= Facility_Count ) ) then
    begin
        Facility_Name_From_Index := nil ;
        exit ;
    end ;
{$IFDEF USE_UEH}
    if( assigned( UEH_Facility_Name_From_Index ) ) then
    begin
        Result := UEH_Facility_Name_From_Index( Index ) ;
        exit ;
    end ;
{$ENDIF}
    if( ( State = 0 ) or ( Facility_IDs.Count <= Index ) or ( Index < 0 ) ) then { Not in a valid state, or out of range }
    begin
        Facility_Name_From_Index := nil ;
    end else
    begin
        EI := Interfaces.At( Index ) ;
{$IFDEF FPC_OR_DELPHI}
        Facility_Name_From_Index := TError_Interface( EI ).Get_Name ;
{$ELSE}
        Temp_Facility_Name_From_Index := EI^.Get_Name ;
        Facility_Name_From_Index := @Temp_Facility_Name_From_Index[ 1 ] ;
{$ENDIF}
    end ;
end ;
*)


function Unregister_Error_Interface( Facility : longint ) : longbool ;

var Dummy : integer ;

begin
{$IFDEF USE_UEH}
    if( assigned( UEH_Unregister_Error_Interface ) ) then
    begin
        Result := UEH_Unregister_Error_Interface( Facility ) ;
        exit ;
    end ;
{$ENDIF}
    { The following check is here because, for some unknown reason on Windows
      2000, the DLL finalization code is called prior to the shut down of other
      DLLs which reference this one.  Our finalization clears the valid state
      and releases memory, then other DLLs may call this one to unregister their
      error interfaces, which would result in an error if we did our normal
      processing.  So we ignore calls when our state is invalid. }
    if( State = 0 ) then { Not in a valid state }
    begin
        Unregister_Error_Interface := False ;
        exit ;
    end ;
    Unregister_Error_Interface := True ;
    Dummy := Facility_IDs.IndexOf( pointer( Facility ) ) ;
    if( Dummy = -1 ) then
    begin
        Unregister_Error_Interface := False ;
        exit ;
    end ;
    Facility_IDs.AtDelete( Dummy ) ;
    Interfaces.AtDelete( Dummy ) ;
end ; { Unregister_Error_Interface }


function Version : longint ;

begin
{$IFDEF USE_UEH}
    if( assigned( UEH_Version ) ) then
    begin
        Result := UEH_Version ;
        exit ;
    end ;
{$ENDIF}
    Version := 12 ; { Compatible with UEH specification 1.2 }
end ;


(*
function Severity( const UEC : TUnified_Exception ) : longint ;

var Dummy : integer ;
    EI : PSError_Interface ;

begin
{$IFDEF USE_UEH}
    if( assigned( UEH_Severity ) ) then
    begin
        Result := UEH_Severity( UEC ) ;
        exit ;
    end ;
{$ENDIF}
    if( State = 0 ) then { Not in a valid state }
    begin
        Severity := UEH_Error ;
        exit ;
    end ;
    Dummy := Facility_IDs.IndexOf( pointer( UEC.Get_Facility ) ) ;
    if( Dummy = -1 ) then
    begin
        Severity := UEH_Error ;
        exit ;
    end ;
    EI := Interfaces.At( Dummy ) ;
{$IFDEF FPC_OR_DELPHI}
    if( TError_Interface( EI ).Version >= 12 ) then { Supports severity }
    begin
        Severity := TError_Interface( EI ).Severity( UEC.Get_Error ) ;
        exit ;
    end ;
{$ELSE}
    if( EI^.Version >= 12 ) then { Supports severity }
    begin
        Severity := EI^.Severity( UEC.Code ) ;
        exit ;
    end ;
{$ENDIF}
    Severity := UEH_Error ;
end ; { Severity }
*)


{ Unit initialization/finalization code... }

{$IFDEF FPC_OR_DELPHI}
var DOS_EI : TDOS_EI ;
    Windows_EI : TWindows_EI ;
{$ELSE}
var DOS_EI : pSDOS_EI ;
    Windows_EI : pSWindows_EI ;
{$ENDIF}

procedure Initialize_Unit ;

begin
    CC_Log( 'Entering ErrMastr.Initialize_Unit' ) ;
    { Setup... }
    Master_Error_Operation := TMEO_Silent ;
{$IFNDEF FPC_OR_DELPHI}
    State := 0 ;
{$ENDIF}
    if( State = 1 ) then { Already initialized }
    begin
        exit ;
    end ;

    { Setup unit variables... }
    Interfaces.Init( 0, 4 ) ;
    Facility_IDs.Init( 0, 4 ) ;
    _Last_Error := nil ;

{$IFDEF USE_UEH}
    UEH32_Handle := LoadLibrary( 'UEH32.DLL' ) ;
    if( UEH32_Handle <> 0 ) then { Found library }
    begin
        UEH_Error_Code := GetProcAddress( UEH32_Handle, 'UEH_Error_Code' ) ;
        UEH_Get_Error_Text := GetProcAddress( UEH32_Handle, 'UEH_Get_Error_Text' ) ;
        UEH_Get_Error_Text_Ex := GetProcAddress( UEH32_Handle, 'UEH_Get_Error_Text_Ex' ) ;
        UEH_Last_Error := GetProcAddress( UEH32_Handle, 'UEH_Last_Error' ) ;
        UEH_Log_Error := GetProcAddress( UEH32_Handle, 'UEH_Log_Error' ) ;
        UEH_Register_Error_Interface := GetProcAddress( UEH32_Handle, 'UEH_Register_Error_Interface' ) ;
        UEH_Set_Master_Error_Operation := GetProcAddress( UEH32_Handle, 'UEH_Set_Master_Error_Operation' ) ;
        UEH_Facility_Count := GetProcAddress( UEH32_Handle, 'UEH_Facility_Count' ) ;
        UEH_Facility_From_Index := GetProcAddress( UEH32_Handle, 'UEH_Facility_From_Index' ) ;
        UEH_Facility_Name_From_Index := GetProcAddress( UEH32_Handle, 'UEH_Facility_Name_From_Index' ) ;
        UEH_Unregister_Error_Interface := GetProcAddress( UEH32_Handle, 'UEH_Unregister_Error_Interface' ) ;
        UEH_Version := GetProcAddress( UEH32_Handle, 'UEH_Version' ) ;
        UEH_Severity := GetProcAddress( UEH32_Handle, 'UEH_Severity' ) ;
        exit ;
    end ;
{$ENDIF}

    { Create default error interfaces for DOS and Windows.. }
    State := 1 ;
{$IFDEF FPC_OR_DELPHI}
    DOS_EI := TDOS_EI.Create ;
    Windows_EI := TWindows_EI.Create ;
//    Register_Error_Interface( PSError_Interface( DOS_EI ) ) ;
//    Register_Error_Interface( PSError_Interface( Windows_EI ) ) ;
{$ELSE}
    new( DOS_EI, Init ) ;
    new( Windows_EI, Init ) ;
    Register_Error_Interface( DOS_EI ) ;
    Register_Error_Interface( Windows_EI ) ;
{$ENDIF}
    CC_Log( 'Exiting ErrMastr.Initialize_Unit' ) ;
end ; { Initialize_Unit }


procedure Terminate_Unit ;

{$IFNDEF USE_UEH}
  {$IFNDEF UEH}
var Dummy : integer ;
  {$ENDIF}
{$ENDIF}

begin
    CC_Log( 'Entering ErrMastr.Terminate_Unit' ) ;
{$IFDEF USE_UEH}
    if( UEH32_Handle <> 0 ) then
    begin
        FreeLibrary( UEH32_Handle ) ;
    end ;
{$ELSE}
  {$IFDEF FPC_OR_DELPHI}
    Unregister_Error_Interface( DOS_EI.Get_Facility ) ;
    Unregister_Error_Interface( Windows_EI.Get_Facility ) ;
    DOS_EI.Free ;
    DOS_EI := nil ;
    Windows_EI.Free ;
    Windows_EI := nil ;
    State := 0 ;
  {$ELSE}
    Unregister_Error_Interface( DOS_EI^.Get_Facility ) ;
    Unregister_Error_Interface( Windows_EI^.Get_Facility ) ;
    DOS_EI^.Done ;
    Windows_EI^.Done ;
  {$ENDIF}
  {$IFNDEF UEH}
(*
    for Dummy := 0 to Interfaces.Count - 1 do
    begin
        if( Interfaces.At( Dummy ) <> nil ) then
        begin
    {$IFDEF FPC_OR_DELPHI}
            try
                TError_Interface( Interfaces.At( Dummy ) ).Done ;
            except
            end ;
    {$ELSE}
            PSError_Interface( Interfaces.At( Dummy ) )^.Done ;
    {$ENDIF}
        end ;
    end ;
*)
  {$ENDIF}
    Interfaces.Done ;
    Facility_IDs.Done ;
{$ENDIF}
    CC_Log( 'Exiting ErrMastr.Terminate_Unit' ) ;
end ; { Terminate_Unit }

{$IFDEF FPC_OR_DELPHI}
initialization
{$ELSE}
begin
{$ENDIF}

    Initialize_Unit ;

{$IFDEF FPC_OR_DELPHI}
finalization
    Terminate_Unit ;
{$ENDIF}
end.

