{$IFNDEF FPC}
  {$N+}
{$ENDIF}
{
        Program Name : GIO
        Package Name : Subroutine Library - Layer 3
        Purpose      : General I/O routines
        Institution  : Conroy & Conroy Co.
        Date Written : 10-Jan-2014
        Written By   : Alan Conroy
        Version      : 1.0

        Copyright (C) 1999-2014 by Alan Conroy.  Released to the public domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

}

unit GIO ;

interface

{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

{$I EDEFINES.INC}

uses { Borland... }
{$IFDEF BP}
     Objects, { TCollection }
     Strings, { strpas }
{$ENDIF}

     { Subroutine Library - Layer 0... }
     _UE ; { PSUnified_Exception }

procedure Log_Error( const UEC : PSUnified_Exception ; const T : string ;
    Level : longint ) ;

//Function Input_Line( X : Integer ) : String ;


implementation

uses { VCL... }
{$IFDEF CCME_Show}
     Dialogs, { ShowMessage }
{$ENDIF}
     SysUtils, { Exception }

     { Subroutine Library - Layer 3... }
     CCStandard ; { CC_Log }

var _Last_Error : PSUnified_Exception ;

(*
Function Input_Line( X : Integer ) : string ;

Var Accumulate : string ;
    Count : Integer ;
    Reg : Char ;
    Reg_Ax : Integer ;

Label Loop ;

Begin
    Count := 1 ;
Loop:
    Read( Kbd, Reg ) ;
    Reg_Ax := Ord( Reg ) And 127 ;
    Accumulate[ Count ] := Chr( Reg_Ax ) ;
    Count := Count + 1 ;
    If ( Reg_Ax = 10 ) Or ( Reg_Ax = 13 ) Or ( Reg_Ax = 12 ) Or ( Reg_Ax = 27 ) Then
    {LF, CR, FF, ESC are delimiters}
    Begin
        If X <> 0 Then If Reg_Ax = 27 Then Write( '$' ) Else Write( Reg ) ;
        If Reg_Ax = 13 Then
        Begin
            Accumulate[ Count ] := Chr( 10 ) ;
            Count := Count + 1 ;
            If X <> 0 Then Write( Chr( 10 ) )
        End ;
        If Reg_Ax = 10 Then
        Begin
            Accumulate[ Count ] := Chr( 13 ) ;
            Count := Count + 1 ;
            If X <> 0 Then Write( Chr( 13 ) )
        End ;
        Accumulate[ 0 ] := Chr( Count - 1 ) ;
        Input_Line := Accumulate ;
        Exit
    End ;
    If Reg_Ax = 21 Then {Control-U}
    Begin
        Count := 1 ;
        If X <> 0 Then Writeln( '^U' ) ;
        Goto Loop
    End ;
    If Reg_Ax = 127 Then {Delete}
    Begin
        Count := Count - 2 ;
        If Count < 1 Then Count := 1 ;
        If X <> 0 Then Write( ' ' ) ;
        Goto Loop
    End ;
    If Count = 254 Then
    Begin
        Write( '' ) ; {End of input buffer}
        Count := Count - 1 ;
        Goto Loop
    End ;
    If X <> 0 Then Write( Reg ) ;
    Goto Loop
End ;
*)


procedure Log_Error( const UEC : PSUnified_Exception ; const T : string ;
    Level : longint ) ;

{$IFDEF CCME_Show}
var Txt : string ;
    _S, _T : longint ;
{$ENDIF}

begin
{$IFDEF CCME_Ignore}
    exit ; { Ignore errors }
{$ENDIF}
    _Last_Error := UEC ;
{$IFDEF CCME_Show}
    if( UEC = nil ) then
    begin
        Txt := T ;
    end else
    begin
        Txt := UEC.Error_Text( _S, _T ) ;
    end ;
    CC_Log( Txt + T ) ; { Log a message }
  {$IFDEF FPC_OR_DELPHI}
    if( Level = UE_Fatal ) then
    begin
        raise Exception.Create( Txt + T ) ;
    end ;
    ShowMessage( Txt + T ) ;
  {$ELSE}
    {$I-}
    writeln( Txt, T ) ;
    {$I+}
    Clear_IOResult ;
    if( Level = SEL_Fatal ) then
    begin
        halt ;
    end ;
  {$ENDIF}
{$ENDIF}
end ; { Log_Error }


end.

