{
        Program Name : Help
        Package Name : Subroutine Library - Layer 4
        Purpose      : General-purpose help routine
        Institution  : Conroy & Conroy
        Original Date: 18-Aug-88
        Date Written : 02-Jun-1991
        Written By   : Alan Conroy
        Version      : 2.1

        Copyright (C) 1988 by Alan Conroy.  Released to the public domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *********************************************************
        *                                                       *
        *        M O D I F I C A T I O N   H I S T O R Y        *
        *                                                       *
        *********************************************************

             DATE      BY             REASON

        *********************************************************
        *                                                       *
        *           P R O G R A M   P U R P O S E               *
        *                                                       *
        *********************************************************

          This procedure provides help from .HLP files.
}

unit Helps ;

interface

{$IFDEF FPC}
  {$MODE DELPHI}
{$ENDIF}

{$I EDEFINES.INC}

procedure Help( Command, Command1 : string ) ;

implementation

uses { Borland... }
{$IFDEF DYNAMIC_STRINGS}
     SysUtils, { strpas }
{$ELSE}
     Strings, { strpas }
{$ENDIF}

     { Subroutine Library - Layer 0... }
     _ASCII,
     L10N, // Text_*
     _UE, { PSUnified_Exception }

     { Subroutine Library - Layer 1... }
     CommonUt, { Edit }
     _Files, { TSFile }
     _FiP, { FSOM_Read_Only }

     { Subroutine Library - Layer 3... }
     CCStandard, { Extension_Pos }
     Filestd, { Filename }
     GetChars,
     Parse, { Program_Path }

     { Subroutine Library - Layer 4... }
     SMU ;

procedure Help( Command, Command1 : string ) ;

label Try_Again ;

var Column : Integer ; { Column count }
    Header : Boolean ; { True if header displayed }
    Help_File : PSFile ; { Main help file }
    Help_Files : array[ 0..39 ] of string[ 32 ] ; { Help filenames per level }
    Help_Line : array[ 0..39 ] of Integer ; { Line in help file for "*" }
    Icf, T : Boolean ;
    Level : Integer ; { Current help file level }
    Line_Count : Integer ;
    { Number of lines displayed on screen since last input }
    Lr : Integer ; { Count of lines read }
    Screen_Length : Integer ;
    Topics : array[ 1..39 ] of string ; { Help topics per level }
    Wildcard : Integer ;

function Out( X : string ) : boolean ; { Output a line of text }

var A : Integer ;
    B : Char ;

begin
    Out := False ;
    if( ( Length( X ) > 0 ) and ( Ord( X[ 1 ] ) = 12 ) ) then
    begin
        Line_Count := Screen_Length - 1 ;
    end else { FF is end of screen }
    begin
        if( ( Length( X ) > 0 ) and ( Level > 1 ) ) then for A := 2 to Level do
        begin
            Output_Text( '  ' ) ;
        end ;
        Output_Text( X + CRLF ) ;
        Line_Count := Line_Count + 1 ;
    end ;
    if( Line_Count = Screen_Length - 1 ) then
    begin
        Output_Text( Text_Prompt_Press_Any_Key_To_Continue ) ;
        Update_Window( Current_Window ) ;
        B := Default_Input.Get_Char( 0, 0 ) ;
        Output_Text( CR + '                            ' + CR ) ;
        if( ( B = ETX ) or ( B = EM ) or ( B = SUB ) or ( B = ESC ) ) then
        begin
            Out := True ;
            exit ;
        end ;
        Update_Window( Current_Window ) ;
        Line_Count := 0
    end ;
end ; { Out }


procedure Further ; { Display subtopic names }

begin
    Column := 0 ;
    Header := False ;
    while( not Help_File^.Eof ) do
    begin
        Help_File^.Readln( Command ) ;
        Lr := Lr + 1 ;
        if( Copy( Command, 1, 1 ) = '*' ) then
        begin
            if( Copy( Command, 2, 1 ) <> '|' ) then
            begin
                If( not Header ) then
                begin
                    if( Out( '' ) ) then
                    begin
                        exit ;
                    end ;
                    Output_Text( Text_Further_Help_Is_Available_On + CRLF ) ;
                    if( Out( '' ) ) then
                    begin
                        exit ;
                    end ;
                    if( Out( '' ) ) then
                    begin
                        exit ;
                    end ;
                    Header := True
                end ;
                if( Column > 72 ) then
                begin
                    if( Out( '' ) ) then
                    begin
                        exit ;
                    end ;
                    Column := 0
                end ;
                while( ( Column and 7 ) <> 0 ) do
                begin
                    Column := Column + 1 ;
                    Output_Text( ' ' )
                end ;
                Column := Column + Length( Command ) ;
                if( Column > 79 ) then
                begin
                    if( Out( '' ) ) then
                    begin
                        exit ;
                    end ;
                    Column := Length( Command )
                end ;
                Output_Text( Copy( Command, 2, Length( Command ) - 1 ) + ' ' ) ;
            end ;
        end ;
    end ;
    if( Header ) then
    begin
        Out( '' ) ;
    end ;
end ; { Further }


function Print_Help( X : string ) : Boolean ;
{ Display help for current topic - return TRUE if OK, FALSE if error }

var Dummy : Integer ; { Dummy loop variable }
    Lc : Integer ; { Lines printed, lines read count }
    _S, _T : longint ;
    Topic, Z : string ;
    UEC : PSUnified_Exception ;
    
label Done, Next_Line, Next_Line1, Prompt, Prompt1, Start ;

begin
    if( Current_Window = nil ) then
    begin
        Screen_Length := 24 ;
    end else
    begin
        Screen_Length := Current_Window^.Rows ;
    end ;
Start:
    Icf := False ;
    Print_Help := True ;
    Help_File^.Reset( Help_File^.FileName ) ;
    Lr := 0 ;
    if( Length( X ) = 0 ) then { Initial state }
    begin
        while( not Help_File^.Eof ) do
        begin
            Help_File^.Readln( Z ) ;
            Lr := Lr + 1 ;
            if( Copy( Z, 1, 1 ) = '*' ) then
            begin
                goto Prompt ;
            end ;
            if( Out( Z ) ) then
            begin
                break ;
            end ;
        end ;
        goto Prompt ;
    end ;
    Lc := Pos( ' ', X + ' ' ) ;
    Topic := Copy( X, 1, Lc - 1 ) ; { Get topic }
    Topics[ Level ] := Topic ;
    X := Copy( X, Lc + 1, Length( X ) - Lc ) ; { Get sub-topic(s) }
    if( Topic = '*' ) then
    begin
        if( Wildcard > Level ) then
        begin
            Wildcard := Level ;
        end ;
    end ;
Next_Line:
    if( Help_File^.Eof ) then { No match found }
    begin
        if( Topic <> '*' ) then
        begin
            Output_Text( Substitute1( Text_Sorry_No_Help_For_x_Found_At_This_Level, Topic ) + CRLF ) ;
            Print_Help := False
        end ;
        Exit ;
    end ;
    Help_File^.Readln( Z ) ;
    Lr := Lr + 1 ;
    Z := Edit( Z, 188 ) ;
    if( Copy( Z, 1, 1 ) <> '*' ) then
    begin
        goto Next_Line ;
    end ;
    if( ( Topic <> '*' ) and ( Z <> '*' + Topic ) and ( Z <> '*|' + Topic ) ) then
    begin
        goto Next_Line ;
    end ;
    if( Topic = '*' ) then
    begin
        Topics[ Level ] := Copy( Z, 2, Length( Z ) - 1 ) ;
    end ;
    Out( Topics[ Level ] ) ;
    Out( '' ) ;
Next_Line1:
    while( not Help_File^.Eof ) do { Find and display text for this topic }
    begin
        Help_File^.Readln( Command ) ;
        Lr := Lr + 1 ;
        if( Copy( Command, 1, 1 ) = '@' ) then { Indirect help }
        begin
            if( Level = 40 ) then
            begin
                Output_Text( Text_Warning_Nesting_Exceeds_40_Levels + CRLF ) ;
                Help_File^.Close ;
                Exit ;
            end ;
            Icf := True ;
            Command := Copy( Command, 2, Length( Command ) - 1 ) ; { Strip @ }
            if( Extension_Pos( Command ) = 0 ) then
            begin
                Command := Command + '.HLP' ;
            end ;
            { Default extension is .HLP }
            if( ( Pos( ':', Command ) = 0 ) and ( Pos( '\', Command ) = 0 ) ) then
            begin
                Command := FileName( Command ) ; { Find file }
            end ;
            Help_Line[ Level - 1 ] := Lr ;
            Help_File^.Close ;
            Help_File := Open( Command, FSOM_Text, UEC ) ;
            Lr := 0 ;
            if( Help_File^.IO_Error <> nil ) then
            begin
                Output_Text( Help_File^.IO_Error.Error_Text( _S, _T ) + ' - ' + Command + CRLF ) ;
                { Open previous file }
                Help_File^.Close ;
                Help_File := Open( Help_Files[ Level ], FSOM_Text, UEC ) ;
                Lr := 0 ;
                if( Help_Line[ Level ] > 0 ) then
                begin
                    for Dummy := 1 to Help_Line[ Level ] do
                    begin
                        Help_File^.Readln( Z ) ;
                    end ;
                end ;
                Lr := Help_Line[ Level ] ;
                Exit ;
            end ;
            Help_Files[ Level ] := Command ;
        end else
        begin
            if( ( Copy( Command, 1, 1 ) = '*' ) and ( Command[ 2 ] <> '|' ) ) then
            begin
                if( Topic = '*' ) then { Wildcard topic match }
                begin
                    if( Icf ) then { Sub-topic was in a separate file }
                    begin
                        Further ; { Display further topics }
                        Icf := False ;
                        Help_File^.Close ;
                        Help_File := Open( Help_Files[ Level - 1 ], FSOM_Text, UEC ) ;
                        Lr := Help_Line[ Level - 1 ] ;
                        for Dummy := 1 to Lr do
                        begin
                            Help_File^.Readln( Z ) ;
                        end ;
                        Command := Z ;
                    end else
                    begin
                        if( Out( '' ) ) then
                        begin
                            exit ;
                        end ;
                        if( Out( '' ) ) then
                        begin
                            exit ;
                        end ;
                        if( Out( Copy( Command, 2, Length( Command ) - 1 ) ) ) then
                        begin
                            exit ;
                        end ;
                    end ;
                    if( Out( '' ) ) then
                    begin
                        exit ;
                    end ;
                    goto Next_Line1 ;
                end ;
                if( ( not Icf ) and ( Level > 0 ) and ( Topic <> '?' ) ) then
                begin
                    exit ;
                end ;
                goto Prompt ;
            end ;
            if( Copy( Command, 1, 1 ) <> '*' ) then
            begin
                if( Length( X ) > 0 ) then { Sub topics specified }
                begin
                    Help_Line[ Level ] := Lr ;
                    Level := Level + 1 ;
                    T := Print_Help( X ) ;
                    if( ( Kb_Buffer = Chr( 3 ) ) Or ( Kb_Buffer = Chr( 25 ) ) ) then
                    begin
                        Exit ;
                    end ;
                    Level := Level - 1 ;
                    if( not T ) then
                    begin
                        Print_Help := False ;
                        Exit ; { Error on a subtopic }
                    end ;
                    Help_Line[ Level ] := Lr ;
                    Help_File^.Close ;
                    Help_File := Open( Help_Files[ Level ], FSOM_Text, UEC ) ;
                    Lr := 0 ;
                    if( Topic = '*' ) then
                    begin
                        for Dummy := 1 to Help_Line[ Level ] do
                        begin
                            Help_File^.Readln( Z ) ;
                        end ;
                        Lr := Help_Line[ Level ]
                    end ;
                    goto Done ;
                end ;
                if( Out( Command ) ) then
                begin
                    exit ;
                end ;
            end ;
        end ;
    end ; { Eof }
    if( ( Topic = '*' ) and Icf ) then { Eof with wildcard }
    begin
        Help_File^.Close ;
        Help_File := Open( Help_Files[ Level - 1 ], FSOM_Text, UEC ) ;
        Icf := False ;
        Lr := Help_Line[ Level - 1 ] ;
        for Dummy := 1 to Lr do
        begin
            Help_File^.Readln( Z ) ;
        end ;
        goto Next_Line ;
    end ;
Done:
    if( Topic = '*' ) then
    begin
        Exit ; { end of file on wild-card so back up }
    end ;
Prompt:
    if( Wildcard < Level ) then
    begin
        Exit ;
    end ;
    Help_File^.Reset( Help_File^.FileName ) ;
    Lr := 0 ;
    Further ; { Display further topics }
Prompt1:
    if( Level > 0 ) then
    begin
        for Dummy := 1 to Level do
        begin
            Output_Text( Topics[ Dummy ] + ' ' ) ;
        end ;
    end ;
    Output_Text( Text_Prompt_Topic ) ;
    Update_Window( Current_Window ) ;
    Window_Read ;
    X := Kb_Buffer ;
    Line_Count := 0 ;
    X := Edit( X, 188 ) ;
    if( Length( X ) = 0 ) then
    begin
        Exit ;
    end ;
    if( X = '?' ) then
    begin
        X := '' ;
        goto Start ; { Re-display current help }
    end ;
    if( ( X = Chr( 26 ) ) Or ( X = Chr( 3 ) ) Or ( X = Chr( 25 ) ) ) then
    begin
        Exit ; { Exit on control-C or control-Y }
    end ;
    if( Level > 0 ) then
    begin
        for Dummy := 1 to Level do
        begin
            if( Out( Topics[ Dummy ] ) ) then
            begin
                goto Prompt1 ;
            end ;
            if( Out( '' ) ) then
            begin
                goto Prompt1 ;
            end ;
        end ;
    end ;
    Help_Line[ Level ] := Lr ;
    Level := Level + 1 ;
    T := Print_Help( X ) ;
    if( ( Kb_Buffer = Chr( 3 ) ) or ( Kb_Buffer = Chr( 25 ) ) ) then
    begin
        Exit ;
    end ;
    Level := Level - 1 ;
    Help_File^.Close ;
    Help_File := Open( Help_Files[ Level ], FSOM_Text, UEC ) ;
    if( UEC <> nil ) then
    begin
        writeln( Substitute2( Text_Error_Opening_x, UEC.Error_Text( _S, _T ), Help_Files[ Level ] ) ) ;
        halt ;
    end ;
    Lr := 0 ;
    goto Prompt1 ;
end ; { Print_Help }


var UEC : PSUnified_Exception ;
    S : string ;

begin
Try_Again:
    S := FileName( Program_Path + Command ) ; { Find help file }
    Help_File := Open( S, FSOM_Input or FSOM_Read_Only, UEC ) ;
    if( UEC <> nil ) then
    begin
        If Pos( '.', Command ) = 0 then
        begin
            Command := Command + '.HLP' ; { Default extension }
            goto Try_Again ;
        end ;
        Output_Text( Text_Error_Help_Not_Available + CRLF ) ;
        Exit ;
    end ;
    Help_Files[ 0 ] := S ;
    Level := 0 ;
    Command := Command1 ; { Get input }
    Command := Edit( Command, 188 ) ;
    if( Length( Command ) > 0 ) then
    begin
        Level := 1 ;
    end ;
    Wildcard := 255 ;
    Line_Count := 0 ;
    T := Print_Help( Command ) ;
end ;



end.
