{$D-}
{
              Program Name : Misc
              Package Name : Subroutine Library - Layer 4
              Purpose      : Misc. Pascal functions
              Institution  : Conroy & Conroy Company
              Original Vers: 22-Aug-86
              Date Written : 25-Jan-1990
              Written By   : Alan Conroy
              Version      : 2.0A
              
              Copyright (C) 1986-1990 by Alan Conroy.  Released to the public domain.

              TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *********************************************************
        *                                                       *
        *        M O D I F I C A T I O N   H I S T O R Y        *
        *                                                       *
        *********************************************************

            DATE      BY             REASON

         1-Nov-2002   EAC            Fix compilation errors in BP.

        *********************************************************
        *                                                       *
        *           P R O G R A M   P U R P O S E               *
        *                                                       *
        *********************************************************

}

unit Misc ;

interface

{$I EDEFINES.INC}

function Closest_Power_Of_2( X : longint ) : longint ;
{$IFDEF DELPHI_32BIT}
function Closest_Power_Of_2_Ex( X : int64 ) : int64 ;
{$ENDIF}
function Mid( const C : AnsiString ; Beginning, Count : Integer ) : AnsiString ;
procedure Sleep( X : Integer ) ;
{$IFDEF DELPHI}
function Space( X : integer ) : AnsiString ;
{$ELSE}
function Space( X : Byte ) : AnsiString ;
{$ENDIF}

implementation

uses { Subroutine Library - Layer 1 }
     CommonUt, { Set_Length }

     { Subroutine Library - Layer 3 }
     O_S, { OS }
     _CCStandard ; { Bit_Values }

function Closest_Power_Of_2( X : longint ) : longint ;

var Dummy : integer ;
    Saved : longint ;

begin
    Closest_Power_Of_2 := 0 ;
    for Dummy := 0 to 31 do
    begin
	Saved := X ; { Save it just in case }
	X := X and ( not Bit_Values[ Dummy ] ) ;
	if( X = 0 ) then
	begin
	    Closest_Power_Of_2 := Saved ;
	    exit ;
	end ;
    end ;
end ;


{$IFDEF DELPHI_32BIT}
function Closest_Power_Of_2_Ex( X : int64 ) : int64 ;

var Dummy : integer ;
    Saved : int64 ;

begin
    Closest_Power_Of_2_Ex := 0 ;
    for Dummy := 0 to 63 do
    begin
	Saved := X ; { Save it just in case }
	X := X and ( not XBit_Values[ Dummy ] ) ;
	if( X = 0 ) then
	begin
	    Closest_Power_Of_2_Ex := Saved ;
	    exit ;
	end ;
    end ;
end ;
{$ENDIF}


{$IFDEF DELPHI}
function Space( X : integer ) : AnsiString ;
{$ELSE}
function Space( X : Byte ) : AnsiString ;
{$ENDIF}

var A : AnsiString ;
    B : Integer ;

begin
    Set_Length( A, X ) ;
    for B := 1 to X do
    begin
        A[ B ] := ' ' ;
    end ;
    Space := A ;
end ;


function Mid( const C : AnsiString ; Beginning, Count : Integer ) : AnsiString ;
{ This function is a MID function (BASIC-Plus style) for Pascal.
  Difference from COPY: Return Null string instead of error when range is not
  within string. }

var A, B : Integer ;

begin
    A := Count ;
    B := Beginning ;
    if( Beginning < 1 ) then
    begin
        A := A + Beginning - 1 ;
        B := 1
    end ;
    if( ( A < 1 ) or ( B > Length( C ) ) ) then
    begin
        Mid := '' ;
    end else
    begin
        Mid := Copy( C, B, A ) ;
    end ;
end ;


procedure Sleep( X : Integer ) ; { Pause for X seconds }

var H, M, D, S, NS : word ;
    Y, Z : Integer ;
    Termination : integer ;

begin
    if( X < 0 ) then
    begin
        Y := -X ;
    end else
    begin
        Y := X ;
    end ;
    while( Y > 0 ) do { Until all seconds used up }
    begin
        if( Y > 59 ) then
        begin
            Z := 59 ;
        end else
        begin
            Z := Y ; { Only do 59 seconds at a time }
        end ;
        OS^.Get_Time( H, M, S, D, NS ) ;
        D := S ;
        Termination := Z + S ;
        if( Termination > 59 ) then
        begin
            Termination := Termination - 59 ; { Get second to stop }
        end ;
        while( D <> Termination ) do
        begin
            if( X < 0 ) then { Negative sleep value }
            begin
                if( OS^.Pending_Input( 0 ) ) then
                begin
                    exit ;
                end ;
            end ;
            OS^.Get_Time( H, M, S, D, NS ) ;
            D := S ;
        end ;
        Y := Y - Z ; { Subtract seconds waited so far }
        OS^.Reschedule ;
    end ;
end ; { Sleep }



end.
