{
        Program Name : ModMem
        Package Name : Subroutine Library - Layer 4
        Purpose      : Memory modification dialog
        Institution  : Conroy & Conroy Co.
        Date Written : 14-Jun-2002
        Written By   : Alan Conroy
        Version      : 1.1

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        Released to the public domain.

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          This dialog is used to modify memory.

        *************************************************************
        *                                                           *
        *        C O N T R I B U T O R S                            *
        *                                                           *
        *************************************************************

        AC (EAC)    Alan Conroy    http://www.conroyhome.net/alan

}

unit ModMem ;

interface

uses // Borland...
     Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
     StdCtrls, Buttons, ExtCtrls,

     // Subroutine Library - Layer 4
     TDialogs ; // TDialog

type
  TModify_Memory_Dialog = class(TDialog)
    Button_Panel: TPanel;
    OK_Button: TBitBtn;
    Cancel_Button: TBitBtn;
    Help_Button: TBitBtn;
    Label1: TLabel;
    Address: TEdit;
    Label2: TLabel;
    Data: TEdit;
    Literal_Text: TCheckBox;
    GroupBox1: TGroupBox;
    Byte_RB: TRadioButton;
    Word_RB: TRadioButton;
    Long_RB: TRadioButton;
    procedure Help_ButtonClick(Sender: TObject);
    procedure AddressChange(Sender: TObject);
    procedure FormShow(Sender: TObject);

  private { Private declarations }

  public // API...
      Address_Value : int64 ;
      Base : integer ;

      function Get_Size : integer ;
      procedure Set_Size( Value : integer ) ;

      property Size : integer
          read Get_Size
          write Set_Size ;
  end ;

var Modify_Memory_Dialog : TModify_Memory_Dialog = nil ;

implementation

uses // C&C Subroutine Library - Layer 0...
     L10N, // Text_*

     // C&C Subroutine Library - Layer 1...
     CVT, // Translate_Value
     CommonUt ; // Edit

{$IFDEF FPC}
  {$R *.LFM}
{$ELSE}
  {$R *.DFM}
{$ENDIF}

// TModify_Memory_Dialog methods...

procedure TModify_Memory_Dialog.Help_ButtonClick( Sender : TObject ) ;

begin
    Application.HelpContext( HelpContext ) ;
end ;


procedure TModify_Memory_Dialog.AddressChange( Sender : TObject ) ;

var B : boolean ;
    Dummy : integer ;
    S, Work : string ;
    V : int64 ;

begin
    if( length( Address.Text ) = 0 ) then
    begin
        OK_Button.Enabled := False ;
        exit ;
    end ;
    B := Translate_Value( Edit( Address.Text, 2 ), 0, Base, Address_Value ) ;
    S := Edit( Data.Text, 16 ) ;
    if( length( S ) = 0 ) then
    begin
        OK_Button.Enabled := False ;
        exit ;
    end ;
    if( not Literal_Text.Checked ) then
    begin
        while( length( S ) > 0 ) do
        begin
            Dummy := pos( ' ', S + ' ' ) ;
            Work := copy( S, 1, Dummy - 1 ) ;
            S := copy( S, Dummy + 1, length( S ) ) ;
            B := Translate_Value( Work, 0, Base, V ) ;
            if( not B ) then
            begin
                break ;
            end ;
        end ;
    end ;
    OK_Button.Enabled := B ;
end ;


function TModify_Memory_Dialog.Get_Size : integer ;

begin
    if( Byte_RB.Checked ) then
    begin
        Result := 1 ;
    end else
    if( Word_RB.Checked ) then
    begin
        Result := 2 ;
    end else
    begin
        Result := 4 ;
    end ;
end ;


procedure TModify_Memory_Dialog.Set_Size( Value : integer ) ;

begin
    case Value of
        1 : Byte_RB.Checked := True ;
        2 : Word_RB.Checked := True ;
        4 : Long_RB.Checked := True ;
    end ;
end ;


procedure TModify_Memory_Dialog.FormShow( Sender : TObject ) ;

begin
    Caption := Text_Caption_Modify_Memory ;
    Label1.Caption := Text_Address ;
    Label2.Caption := Text_Data ;
    OK_Button.Caption := Text_Button_Caption_OK ;
    Cancel_Button.Caption := Text_Button_Caption_Cancel ;
    Help_Button.Caption := Text_Button_Caption_Help ;
    Literal_Text.Caption := Text_Literal_Text ;
    GroupBox1.Caption := Text_Caption_Size ;
    Byte_RB.Caption := Text_Byte1 ;
    Word_RB.Caption := Text_Word1 ;
    Long_RB.Caption := Text_Long1 ;
end ;


end.
