{
        Program Name : _AEL
        Package Name : Subroutine Library - Layer 1
        Purpose      : Abstract Application Event Logger
        Institution  : Conroy & Conroy Co.
        Date Written : 31-January-2003
        Written By   : Alan Conroy
        Version      : 1.0

        Copyright (C) 2003-2015 by Alan Conroy.  Released to the Public Domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          The classes in this unit are used to provide an OO event logging
	interface.
}

unit _AEL ;

interface

{$I EDEFINES.INC}

uses { C&C Subroutine Library... }
     CommBase, { TBase_Object }
     ComInter { TCommon_COM_Interface }
{$IFNDEF MOBILE}
     ,_DebugIn { PDebug_Interface }
{$ENDIF}
     ,_Types { Ansistring }
     ;

{$IFDEF DYNAMIC_OBJECTS}
type TApplication_Event_Logger = class( TBase_Delphi_Object )
                                     public { API... }
                                         procedure Log_Event( const S : Ansistring ) ;
                                             virtual ; abstract ;
                                         procedure Trace_Enter( const S : Ansistring ) ;
                                             virtual ; abstract ;
                                         procedure Trace_Exit( const S : Ansistring ) ;
                                             virtual ; abstract ;
                                 end ;

type TCOM_Application_Event_Logger = class( TCommon_COM_Interface )
                                         public { API... }
                                             procedure Log_Event( S : PAnsiChar ) ;
                                                 virtual ; stdcall ; abstract ;
                                             procedure Trace_Enter( S : PAnsiChar ) ;
                                                 virtual ; stdcall ; abstract ;
                                             procedure Trace_Exit( S : PAnsiChar ) ;
                                                 virtual ; stdcall ; abstract ;
                                     end ;
{$ENDIF}

type TSApplication_Event_Logger = object( TBase_Object )
                                     public { Constructors and destructors... }
                                         constructor Init ;

                                     public { API... }
{$IFNDEF MOBILE}
                                         function Debugger : PSDebug_Interface ;
                                             virtual ;
{$ENDIF}
                                         procedure Log_Event( const S : Ansistring ) ;
                                             virtual ;
                                         procedure Trace_Enter( const S : Ansistring ) ;
                                             virtual ;
                                         procedure Trace_Exit( const S : Ansistring ) ;
                                             virtual ;
                                 end ;
     PSApplication_Event_Logger = ^TSApplication_Event_Logger ;


implementation

{ TApplication_Event_Logger methods... }

{ Constructors and destructors... }

constructor TSApplication_Event_Logger.Init ;

begin
    { Default does nothing }

    inherited Init ;
end ;


{ API... }

{$IFNDEF MOBILE}
function TSApplication_Event_Logger.Debugger : PSDebug_Interface ;

begin
    Debugger := nil ;
end ;
{$ENDIF}


procedure TSApplication_Event_Logger.Log_Event( const S : Ansistring ) ;

begin
    { Default does nothing }
end ;


procedure TSApplication_Event_Logger.Trace_Enter( const S : Ansistring ) ;

begin
    { Default does nothing }
end ;


procedure TSApplication_Event_Logger.Trace_Exit( const S : Ansistring ) ;

begin
    { Default does nothing }
end ;


end.
