{
        Unit Name    : _Buffers
        Package Name : Subroutine Library - Layer 1
        Purpose      : Buffer class
        Institution  : Conroy & Conroy Co.
        Date Written : 29-Sep-2015
        Written By   : Alan Conroy
        Version      : 1.0

        Copyright (c) 2015 by Alan Conroy.  Released to the Public Domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          TSBuffer and TBuffer are arbitrarily-sized, 0-index-based buffers.
}

unit _Buffers ;

interface

{$I EDEFINES.INC}

uses { Subroutine Library - Layer 0... }
     CommBase, { TBase_Delphi_Object }
     Typedefs, { PByte_Array }
     _Types, { PAnsichar }

     { Subroutine Library - Layer 1... }
     _Stores, { TStore_Address }
     MStores, { PSManaged_Store }
     Stores ; { TBase_Store }


type PSBuffer = ^TSBuffer ;
     TSBuffer = object( TBase_Object )
                    public { API... }
                        function Classname : string ; virtual ;
                        procedure Move( Old : PSBuffer ;
                            Old_Offset, New_Size, New_Offset : integer ) ;
                            virtual ;
                        function As_PChar : PAnsiChar ; virtual ;
                        procedure Zero( Pos, Len : longint ) ; virtual ;
                        function Get_Byte( Pos : longint ) : byte ; virtual ;
                        procedure Set_Byte( D : byte ; Pos : longint ) ;
                            virtual ;
                        procedure Get_Data( var D ; Pos, Len : longint ) ;
                            virtual ;
                        procedure Set_Data( var D ; Pos, Len : longint ) ;
                            virtual ;
                        procedure Set_Size( S : longint ) ; virtual ;
                        function Get_Size : longint ; virtual ;
                        function Get_Store : PSManaged_Store ; virtual ;
                        procedure Set_Store( S : PSManaged_Store ) ; virtual ;
                        procedure Fill( Pos, Len, Value : longint ) ; virtual ;
                        function Contiguous : boolean ; virtual ;
                end ; { TSBuffer }

{$IFDEF DYNAMIC_OBJECTS}
type TBuffer = class( TBase_Store )
                   protected // Property handlers...
                       function Get_Size : longint ; virtual ; abstract ;
                       procedure Set_Size( _S : longint ) ; virtual ; abstract ;

                   public // API...
                       { Add Len bytes from Buf to the end of the buffer,
                         resizing the buffer to hold the new data.  Returns the
                         starting offset of the added data. }
                       function Add( Buf : PChar ; Len : longint ) : longint ;
                           virtual ; abstract ;

                       { Read data }
                       procedure Read( PTR, Size : TStore_Address ;
                           var Buffer ) ; virtual ; abstract ;

                       procedure Write( PTR, Size : TStore_Address ;
                           var Buffer ) ; virtual ; abstract ;

                   published // Properties...
                       property Size : longint // Size of buffer, in bytes
                           read Get_Size
                           write Set_Size ;
               end ;
{$ENDIF}


implementation

{ TSBuffer methods... }

{ API... }

function TSBuffer.Classname : string ;

begin
    Classname := 'TSBuffer' ;
end ;


procedure TSBuffer.Move( Old : PSBuffer ;
    Old_Offset, New_Size, New_Offset : integer ) ;

begin
end ;


function TSBuffer.As_PChar : PAnsiChar ;

begin
    As_PChar := nil ;
end ;


procedure TSBuffer.Zero( Pos, Len : longint ) ;

begin
end ;


function TSBuffer.Get_Byte( Pos : longint ) : byte ;

begin
    Get_Byte := 0 ;
end ;


procedure TSBuffer.Set_Byte( D : byte ; Pos : longint ) ;

begin
end ;


procedure TSBuffer.Get_Data( var D ; Pos, Len : longint ) ;

begin
end ;


procedure TSBuffer.Set_Data( var D ; Pos, Len : longint ) ;

begin
end ;


procedure TSBuffer.Set_Size( S : longint ) ;

begin
end ;


function TSBuffer.Get_Size : longint ;

begin
    Get_Size := 0 ;
end ;


function TSBuffer.Get_Store : PSManaged_Store ;

begin
    Get_Store := nil ;
end ;


procedure TSBuffer.Set_Store( S : PSManaged_Store ) ;

begin
end ;


procedure TSBuffer.Fill( Pos, Len, Value : longint ) ;

begin
end ;


function TSBuffer.Contiguous : boolean ;

begin
    Contiguous := True ;
end ;



end.
