{
        Program Name : _Chars
        Package Name : C&C Subroutine Library - Layer 1
        Purpose      : Character class definition
        Institution  : Conroy & Conroy Co.
        Date Written :
        Written By   : Alan Conroy
        Version      : 1.0

	    Copyright (C) 2009 by Alan Conroy.  All rights reserved.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON                         

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

}

unit _Chars ;

interface

uses // C&C Subroutine library Layer 0...
     _Common, // TBase_Delphi_Object

     // C&C Subroutine library Layer 1...
     _Fonts ; // TFont

{$IFDEF DYNAMIC_OBJECTS}
type TCharacter = class( TBase_Delphi_Object )
                      public // API...
                          function Get_Italic_Amount : integer ;
                              virtual ; stdcall ; abstract ;
                          function Get_Bold_Amount : integer ;
                              virtual ; stdcall ; abstract ;
                          function Get_Italic : boolean ;
                              virtual ; stdcall ; abstract ;
                          function Get_Bold : boolean ;
                              virtual ; stdcall ; abstract ;
                          function Get_Font : TFont ;
                              virtual ; stdcall ; abstract ;
                          function Get_Value : string ;
                              virtual ; stdcall ; abstract ;
                          function Get_Color : TColor ;
                              virtual ; stdcall ; abstract ;
                          function Get_Size : integer ;
                              virtual ; stdcall ; abstract ;
                          procedure Set_Italic_Amount( Value : integer ) ;
                              virtual ; stdcall ; abstract ;
                          procedure Set_Bold_Amount( Value : integer ) ;
                              virtual ; stdcall ; abstract ;
                          procedure Set_Italic( Value : boolean ) ;
                              virtual ; stdcall ; abstract ;
                          procedure Set_Bold( Value : boolean ) ;
                              virtual ; stdcall ; abstract ;
                          procedure Set_Font( Value : TFont ) ;
                              virtual ; stdcall ; abstract ;
                          procedure Set_Value( Value : string ) ;
                              virtual ; stdcall ; abstract ;
                          procedure Set_Color( Value : TColor ) ;
                              virtual ; stdcall ; abstract ;
                          procedure Set_Size( Value : integer ) ;
                              virtual ; stdcall ; abstract ;

                          function Baseline : integer ; // Above baseline is ascent, below is descent
                              virtual ; stdcall ; abstract ;
                          function Width : integer ;
                              virtual ; stdcall ; abstract ;
                          function Height : integer ; // Total height, including ascent and descent
                              virtual ; stdcall ; abstract ;
                          function Leading : integer ; // Internal leading
                              virtual ; stdcall ; abstract ;
                          procedure Draw( Canvas : TCanvas ; Rect : TRect ;
                              _Baseline : integer ) ;
                              virtual ; stdcall ; abstract ;

  {$IFDEF PROPERTIES}
                      public // Properties...
                          property Color : TColor
                              read Get_Color
                              write Set_Color ;
                          property Font : TFont
                              read Get_Font
                              write Set_Font ;
                          property Size : integer
                              read Get_Size
                              write Set_Size ;
                          property Italic_Amount : integer
                              read Get_Italic_Amount
                              write Set_Italic_Amount ;
                          property Bold_Amount : integer
                              read Get_Bold_Amount
                              write Set_Bold_Amount ;
                          property Italic : boolean
                              read Get_Italic
                              write Set_Italic ;
                          property Bold : boolean
                              read Get_Bold
                              write Set_Bold ;
                          property Value : string
                              read Get_String
                              write Set_String ;
  {$ENDIF}
                  end ; // TCharacter
{$ENDIF}

implementation

end.

