{$IFNDEF FPC}
  {$N+}
{$ENDIF}
{
        Program Name : _TPM
        Package Name : Subroutine Library - Layer 1
        Purpose      : Text Presentation Manager class definitions
        Institution  : Conroy & Conroy Co.
        Date Written : 27-Jun-2007
        Written By   : Alan Conroy
        Version      : 1.0

        Copyright (C) 2007-2008 by Alan Conroy.  Released to the public domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          The text presentation manager is used to provide text for use in
        various circumstances.

          LEVEL 2 CERTIFICATION: 6-Sep-2006 by EAC
}

unit _TPM ;

interface

{$IFDEF FPC}
  {$MODE DELPHI}
{$ENDIF}

{$I EDEFINES.INC}

uses { Layer 0... }
     _Common, { TObject }
     COMInter, { TCommon_COM_Interface }
     _Types ; { PAnsiChar }

{$IFDEF DYNAMIC_OBJECTS}
type TCOM_Numeric_Text_Presentation_Manager = class( TCommon_COM_Interface )
                                                  public { API... }
                                                      function Decimal : PAnsiChar ;
                                                          virtual ; stdcall ; abstract ;
                                                      { Character(s) to use for
                                                        decimal point. }

                                                      function Group : PAnsiChar ;
                                                          virtual ; stdcall ; abstract ;
                                                      { Character(s) to use for
                                                        thounsand separator. }

                                                      function Negative : PAnsiChar ;
                                                          virtual ; stdcall ; abstract ;
                                                      { Character(s) to use for
                                                        negative sign. }

                                                      function Positive : PAnsiChar ;
                                                          virtual ; stdcall ; abstract ;
                                                      { Character(s) to use for
                                                        positive sign. }

(*
                S := Get_Locale_Info( LOCALE_SGROUPING, 'Digit grouping' ) ;
                S := Get_Locale_Info( LOCALE_IDIGITS, 'Number of fractional digits' ) ;
                S := Get_Locale_Info( LOCALE_ILZERO, 'Leading zeros for decimal' ) ;
                S := Get_Locale_Info( LOCALE_INEGNUMBER, 'Negative number mode' ) ;
                S := Get_Locale_Info( LOCALE_SNATIVEDIGITS, 'Native ASCII 0-9' ) ;
                S := Get_Locale_Info( LOCALE_IPOSSIGNPOSN, 'Positive sign position' ) ;
                S := Get_Locale_Info( LOCALE_INEGSIGNPOSN, 'Negative sign position' ) ;
*)
                                              end ;

type TCOM_Monetary_Text_Presentation_Manager = class( TCommon_COM_Interface )
                                                   public { API... }
                                                       function Decimal : PAnsiChar ;
                                                           virtual ; stdcall ; abstract ;
                                                       { Character(s) to use for
                                                         decimal point. }

                                                       function Group : PAnsiChar ;
                                                           virtual ; stdcall ; abstract ;
                                                       { Character(s) to use for
                                                         thounsand separator. }

                                                       function Money_Symbol : PAnsiChar ;
                                                           virtual ; stdcall ; abstract ;
                                                       { Character(s) used for
                                                         money. }

                                                       function Internationl_Money_Symbol : PAnsiChar ;
                                                           virtual ; stdcall ; abstract ;
                                                       { Character(s) used for
                                                         international money. }

(*
                S := Get_Locale_Info( LOCALE_SMONGROUPING, 'Monetary grouping' ) ;
                S := Get_Locale_Info( LOCALE_ICURRDIGITS, 'Number local monetary digits' ) ;
                S := Get_Locale_Info( LOCALE_IINTLCURRDIGITS, 'Number international monetary digits' ) ;
                S := Get_Locale_Info( LOCALE_ICURRENCY, 'Positive currency mode' ) ;
                S := Get_Locale_Info( LOCALE_INEGCURR, 'Negative currency mode' ) ;
                S := Get_Locale_Info( LOCALE_IPOSSYMPRECEDES, 'Monetary symbol precedes positive amount' ) ;
                S := Get_Locale_Info( LOCALE_IPOSSEPBYSPACE, 'Monetary symbol separated by space from positive amount' ) ;
                S := Get_Locale_Info( LOCALE_INEGSYMPRECEDES, 'Monetary symbol precedes negative amount' ) ;
                S := Get_Locale_Info( LOCALE_INEGSEPBYSPACE, 'Monetary symbol separated by space from negative amount' ) ;
*)
                                               end ;

type TCOM_Date_Text_Presentation_Manager = class( TCommon_COM_Interface )
                                               public { API... }
                                                   function AM : PAnsiChar ;
                                                       virtual ; stdcall ; abstract ;
                                                   { Character used to indicate
                                                     AM. }

                                                   function Date_Separator : PAnsiChar ;
                                                       virtual ; stdcall ; abstract ;
                                                   { Character(s) used to
                                                     separate date components. }

                                                   function Days( M : integer ) : PAnsiChar ;
                                                       virtual ; stdcall ; abstract ;
                                                   { Name of day with passed
                                                     ordinal (1-7). }

                                                   function Months( M : integer ) : PAnsiChar ;
                                                       virtual ; stdcall ; abstract ;
                                                   { Name of month with passed
                                                     ordinal (1-13). }

                                                   function PM : PAnsiChar ;
                                                       virtual ; stdcall ; abstract ;
                                                   { Character used to indicate
                                                     PM. }

                                                   function Short_Days( M : integer ) : PAnsiChar ;
                                                       virtual ; stdcall ; abstract ;
                                                   { Name of day with passed
                                                     ordinal (1-7), abbreviated. }

                                                   function Short_Months( M : integer ) : PAnsiChar ;
                                                       virtual ; stdcall ; abstract ;
                                                   { Name of month with passed
                                                     ordinal (1-13),
                                                     abbreviated. }

                                                   function Time_Separator : PAnsiChar ;
                                                       virtual ; stdcall ; abstract ;
                                                   { Character(s) used to
                                                     separate time components. }

(*
                S := Get_Locale_Info( LOCALE_SSHORTDATE, 'Short date format string' ) ;
                S := Get_Locale_Info( LOCALE_SLONGDATE, 'Long date format string' ) ;
                S := Get_Locale_Info( LOCALE_STIMEFORMAT, 'Time format string' ) ;
                S := Get_Locale_Info( LOCALE_IDATE, 'Short date format ordering' ) ;
                S := Get_Locale_Info( LOCALE_ILDATE, 'Long date format ordering' ) ;
                S := Get_Locale_Info( LOCALE_ITIME, 'Time format specifier' ) ;
                S := Get_Locale_Info( LOCALE_ITIMEMARKPOSN, 'Time marker position' ) ;
                S := Get_Locale_Info( LOCALE_ICENTURY, 'Century format specifier (short date)' ) ;
                S := Get_Locale_Info( LOCALE_ITLZERO, 'Leading zeros in time field' ) ;
                S := Get_Locale_Info( LOCALE_IDAYLZERO, 'Leading zeros in day field (short date)' ) ;
                S := Get_Locale_Info( LOCALE_IMONLZERO, 'Leading zeros in month field (short date)' ) ;
                S := Get_Locale_Info( LOCALE_ICALENDARTYPE, 'Type of calendar specifier' ) ;
                S := Get_Locale_Info( LOCALE_IOPTIONALCALENDAR, 'Additional calendar types specifier' ) ;
                S := Get_Locale_Info( LOCALE_IFIRSTDAYOFWEEK, 'First day of week specifier' ) ;
                S := Get_Locale_Info( LOCALE_IFIRSTWEEKOFYEAR, 'First week of year specifier' ) ;
*)
                                           end ;

type TCOM_Text_Presentation_Manager = class( TCommon_COM_Interface )
                                          public { API... }
                                              function Numeric_Text_Presentation_Manager :
                                                TCOM_Numeric_Text_Presentation_Manager ;
                                                  virtual ; stdcall ; abstract ;
                                              { Returns a presentation manager
                                                for numeric text. }

                                              function Monetary_Text_Presentation_Manager :
                                                TCOM_Monetary_Text_Presentation_Manager ;
                                                  virtual ; stdcall ; abstract ;
                                              { Returns a presentation manager
                                                for monetary text. }

                                              function Date_Text_Presentation_Manager :
                                                TCOM_Date_Text_Presentation_Manager ;
                                                  virtual ; stdcall ; abstract ;
                                              { Returns a presentation manager
                                                for date/time text. }
                                      end ;

type TNumeric_Text_Presentation_Manager = class( TDelphi_Object )
                                              public { API... }
                                                  function Decimal : Ansistring ;
                                                      virtual ; abstract ;
                                                  { Character(s) to use for
                                                    decimal point. }

                                                  function Group : Ansistring ;
                                                      virtual ; abstract ;
                                                  { Character(s) to use for
                                                    thounsand separator. }

                                                  function Negative : Ansistring ;
                                                      virtual ; abstract ;
                                                  { Character(s) to use for
                                                    negative sign. }

                                                  function Positive : Ansistring ;
                                                      virtual ; abstract ;
                                                  { Character(s) to use for
                                                    positive sign. }
                                          end ;

type TMonetary_Text_Presentation_Manager = class( TDelphi_Object )
                                               public { API... }
                                                   function Decimal : Ansistring ;
                                                       virtual ; abstract ;
                                                   { Character(s) to use for
                                                     decimal point. }

                                                   function Group : Ansistring ;
                                                       virtual ; abstract ;
                                                   { Character(s) to use for
                                                     thounsand separator. }

                                                   function Money_Symbol : Ansistring ;
                                                       virtual ; abstract ;
                                                   { Character(s) used for
                                                     money. }

                                                   function Internationl_Money_Symbol : Ansistring ;
                                                       virtual ; abstract ;
                                                   { Character(s) used for
                                                     international money. }
                                           end ;

type TDate_Text_Presentation_Manager = class( TDelphi_Object )
                                           public { API... }
                                               function AM : Ansistring ;
                                                   virtual ; abstract ;
                                               { Character used to indicate
                                                 AM. }

                                               function Date_Separator : Ansistring ;
                                                   virtual ; abstract ;
                                               { Character(s) used to
                                                 separate date components. }

                                               function Days( M : integer ) : Ansistring ;
                                                   virtual ; abstract ;
                                               { Name of day with passed
                                                 ordinal (1-7). }

                                               function Months( M : integer ) : Ansistring ;
                                                   virtual ; abstract ;
                                               { Name of month with passed
                                                 ordinal (1-13). }

                                               function PM : Ansistring ;
                                                   virtual ; abstract ;
                                               { Character used to indicate
                                                 PM. }

                                               function Short_Days( M : integer ) : Ansistring ;
                                                   virtual ; abstract ;
                                               { Name of day with passed
                                                 ordinal (1-7), abbreviated. }

                                               function Short_Months( M : integer ) : Ansistring ;
                                                   virtual ; abstract ;
                                               { Name of month with passed
                                                 ordinal (1-13),
                                                 abbreviated. }

                                               function Time_Separator : Ansistring ;
                                                   virtual ; abstract ;
                                               { Character(s) used to
                                                 separate time components. }
                                       end ;

type TText_Presentation_Manager = class( TDelphi_Object )
                                      public { API... }
                                          function Numeric_Text_Presentation_Manager : TNumeric_Text_Presentation_Manager ;
                                              virtual ; abstract ;
                                          { Returns a presentation manager
                                            for numeric text. }

                                          function Monetary_Text_Presentation_Manager : TMonetary_Text_Presentation_Manager ;
                                              virtual ; abstract ;
                                          { Returns a presentation manager
                                            for monetary text. }

                                          function Date_Text_Presentation_Manager : TDate_Text_Presentation_Manager ;
                                              virtual ; abstract ;
                                          { Returns a presentation manager
                                            for date/time text. }
                                  end ;
{$ENDIF}

type TSNumeric_Text_Presentation_Manager = object( TObject )
                                               public { API... }
                                                   function Decimal : Ansistring ;
                                                       virtual ;
                                                   { Character(s) to use for
                                                     decimal point. }

                                                   function Group : Ansistring ;
                                                       virtual ;
                                                   { Character(s) to use for
                                                     thounsand separator. }

                                                   function Negative : Ansistring ;
                                                       virtual ;
                                                   { Character(s) to use for
                                                     negative sign. }

                                                    function Positive : Ansistring ;
                                                       virtual ;
                                                   { Character(s) to use for
                                                     positive sign. }
                                           end ;
     PSNumeric_Text_Presentation_Manager = ^TSNumeric_Text_Presentation_Manager ;

type TSMonetary_Text_Presentation_Manager = object( TObject )
                                                public { API... }
                                                    function Decimal : Ansistring ;
                                                        virtual ;
                                                    { Character(s) to use for
                                                      decimal point. }

                                                    function Group : Ansistring ;
                                                        virtual ;
                                                    { Character(s) to use for
                                                      thounsand separator. }

                                                    function Money_Symbol : Ansistring ;
                                                        virtual ;
                                                    { Character(s) used for
                                                      money. }

                                                    function Internationl_Money_Symbol : Ansistring ;
                                                        virtual ;
                                                    { Character(s) used for
                                                      international money. }
                                            end ;
     PSMonetary_Text_Presentation_Manager = ^TSMonetary_Text_Presentation_Manager ;

type TSDate_Text_Presentation_Manager = object( TObject )
                                            public { API... }
                                                function AM : Ansistring ;
                                                    virtual ;
                                                { Character used to indicate
                                                  AM. }

                                                function Date_Separator : Ansistring ;
                                                    virtual ;
                                                { Character(s) used to
                                                  separate date components. }

                                                function Days( M : integer ) : Ansistring ;
                                                    virtual ;
                                                { Name of day with passed
                                                  ordinal (1-7). }

                                                function Months( M : integer ) : Ansistring ;
                                                    virtual ;
                                                { Name of month with passed
                                                  ordinal (1-13). }

                                                function PM : Ansistring ;
                                                    virtual ;
                                                { Character used to indicate
                                                  PM. }

                                                function Short_Days( M : integer ) : Ansistring ;
                                                    virtual ;
                                                { Name of day with passed
                                                  ordinal (1-7), abbreviated. }

                                                function Short_Months( M : integer ) : Ansistring ;
                                                    virtual ;
                                                { Name of month with passed
                                                  ordinal (1-13),
                                                  abbreviated. }

                                                function Time_Separator : Ansistring ;
                                                    virtual ;
                                                { Character(s) used to
                                                  separate time components. }
                                        end ;
     PSDate_Text_Presentation_Manager = ^TSDate_Text_Presentation_Manager ;

type TSText_Presentation_Manager = object( TObject )
                                       public { API... }
                                          function Numeric_Text_Presentation_Manager : PSNumeric_Text_Presentation_Manager ;
                                              virtual ;
                                          { Returns a presentation manager
                                            for numeric text. }

                                          function Monetary_Text_Presentation_Manager : PSMonetary_Text_Presentation_Manager ;
                                              virtual ;
                                          { Returns a presentation manager
                                            for monetary text. }

                                          function Date_Text_Presentation_Manager : PSDate_Text_Presentation_Manager ;
                                              virtual ;
                                          { Returns a presentation manager
                                            for date/time text. }
                                    end ;
     PSText_Presentation_Manager = ^TSText_Presentation_Manager ;

{$IFDEF CC_Regression_Test}
procedure Test_Unit ;
{$ENDIF}

implementation

uses { C&C... }
     L10N ; { Text_* }

{ TSNumeric_Text_Presentation_Manager methods... }

function TSNumeric_Text_Presentation_Manager.Decimal : Ansistring ;

begin
    Decimal := '.' ;
end ;


function TSNumeric_Text_Presentation_Manager.Group : Ansistring ;

begin
    Group := ',' ;
end ;


function TSNumeric_Text_Presentation_Manager.Negative : Ansistring ;

begin
    Negative := '-' ;
end ;


function TSNumeric_Text_Presentation_Manager.Positive : Ansistring ;

begin
    Positive := '+' ;
end ;



{ TSMonetary_Text_Presentation_Manager methods... }

function TSMonetary_Text_Presentation_Manager.Decimal : Ansistring ;

begin
    Decimal := '.' ;
end ;


function TSMonetary_Text_Presentation_Manager.Group : Ansistring ;

begin
    Group := ',' ;
end ;


function TSMonetary_Text_Presentation_Manager.Money_Symbol : Ansistring ;

begin
    Money_Symbol := '$' ;
end ;


function TSMonetary_Text_Presentation_Manager.Internationl_Money_Symbol : Ansistring ;

begin
    Internationl_Money_Symbol := '$' ;
end ;



{ TSDate_Text_Presentation_Manager methods... }

function TSDate_Text_Presentation_Manager.AM : Ansistring ;

begin
    AM := 'AM' ;
end ;


function TSDate_Text_Presentation_Manager.Date_Separator : Ansistring ;

begin
    Date_Separator := '-' ;
end ;


function TSDate_Text_Presentation_Manager.Days( M : integer ) : Ansistring ;

begin
    case M of
        1 :  Days := Text_Day_Sunday ;
        2 :  Days := Text_Day_Monday ;
        3 :  Days := Text_Day_Tuesday ;
        4 :  Days := Text_Day_Wednesday ;
        5 :  Days := Text_Day_Thursday ;
        6 :  Days := Text_Day_Friday ;
        7 :  Days := Text_Day_Saturday ;
        else Days := '' ;
    end ;
end ;


function TSDate_Text_Presentation_Manager.Months( M : integer ) : Ansistring ;

begin
    case M of
        1 :  Months := Text_Month_January ;
        2 :  Months := Text_Month_February ;
        3 :  Months := Text_Month_March ;
        4 :  Months := Text_Month_April ;
        5 :  Months := Text_Month_May ;
        6 :  Months := Text_Month_June ;
        7 :  Months := Text_Month_July ;
        8 :  Months := Text_Month_August ;
        9 :  Months := Text_Month_September ;
        10 :  Months := Text_Month_October ;
        11 :  Months := Text_Month_November ;
        12 :  Months := Text_Month_December ;
        else Months := '' ;
    end ;
end ;


function TSDate_Text_Presentation_Manager.PM : Ansistring ;

begin
    PM := 'PM' ;
end ;


function TSDate_Text_Presentation_Manager.Short_Days( M : integer ) : Ansistring ;

begin
    case M of
        1 :  Short_Days := Text_Sun ;
        2 :  Short_Days := Text_Mon ;
        3 :  Short_Days := Text_Tue ;
        4 :  Short_Days := Text_Wed ;
        5 :  Short_Days := Text_Thu ;
        6 :  Short_Days := Text_Fri ;
        7 :  Short_Days := Text_Sat ;
        else Short_Days := '' ;
    end ;
end ;


function TSDate_Text_Presentation_Manager.Short_Months( M : integer ) : Ansistring ;

begin
    case M of
        1 :  Short_Months := Text_Month_Jan ;
        2 :  Short_Months := Text_Month_Feb ;
        3 :  Short_Months := Text_Month_Mar ;
        4 :  Short_Months := Text_Month_Apr ;
        5 :  Short_Months := Text_Month_May ;
        6 :  Short_Months := Text_Month_Jun ;
        7 :  Short_Months := Text_Month_Jul ;
        8 :  Short_Months := Text_Month_Aug ;
        9 :  Short_Months := Text_Month_Sep ;
        10 :  Short_Months := Text_Month_Oct ;
        11 :  Short_Months := Text_Month_Nov ;
        12 :  Short_Months := Text_Month_Dec ;
        else Short_Months := '' ;
    end ;
end ;


function TSDate_Text_Presentation_Manager.Time_Separator : Ansistring ;

begin
    Time_Separator := ':' ;
end ;



{ TSText_Presentation_Manager methods... }

function TSText_Presentation_Manager.Numeric_Text_Presentation_Manager : PSNumeric_Text_Presentation_Manager ;

begin
    Numeric_Text_Presentation_Manager := new( PSNumeric_Text_Presentation_Manager, Init ) ;
end ;


function TSText_Presentation_Manager.Monetary_Text_Presentation_Manager : PSMonetary_Text_Presentation_Manager ;

begin
    Monetary_Text_Presentation_Manager := new( PSMonetary_Text_Presentation_Manager, Init ) ;
end ;


function TSText_Presentation_Manager.Date_Text_Presentation_Manager : PSDate_Text_Presentation_Manager ;

begin
    Date_Text_Presentation_Manager := new( PSDate_Text_Presentation_Manager, Init ) ;
end ;



{$IFDEF CC_Regression_Test}
procedure Error ;

begin
    writeln( 'Errors' ) ;
    halt ;
end ;


procedure Test_Dates( Test_Date : PSDate_Text_Presentation_Manager ) ;

var Loop : integer ;

begin
    for Loop := 1 to 7 do
    begin
        if( copy( Test_Date^.Days( Loop ), 1, 3 )  <> Test_Date^.Short_Days( Loop ) ) then
        begin
            Error ;
        end ;
    end ;
    for Loop := 1 to 12 do
    begin
        if( copy( Test_Date^.Months( Loop ), 1, 3 )  <> Test_Date^.Short_Months( Loop ) ) then
        begin
            Error ;
        end ;
    end ;
    if( Test_Date^.AM <> 'AM' ) then
    begin
        Error ;
    end ;
    if( Test_Date^.PM <> 'PM' ) then
    begin
        Error ;
    end ;
    if( Test_Date^.Date_Separator <> '-' ) then
    begin
        Error ;
    end ;
    if( Test_Date^.Time_Separator <> ':' ) then
    begin
        Error ;
    end ;
    dispose( Test_Date, done ) ;
end ;


procedure Test_Numerics( Test_Numeric : PSNumeric_Text_Presentation_Manager ) ;

begin
    if( Test_Numeric^.Decimal <> '.' ) then
    begin
        Error ;
    end ;
    if( Test_Numeric^.Group <> ',' ) then
    begin
        Error ;
    end ;
    if( Test_Numeric^.Negative <> '-' ) then
    begin
        Error ;
    end ;
    if( Test_Numeric^.Positive <> '+' ) then
    begin
        Error ;
    end ;
    dispose( Test_Numeric, done ) ;
end ;


procedure Test_Monetarys( Test_Monetary : PSMonetary_Text_Presentation_Manager ) ;

begin
    if( Test_Monetary^.Decimal <> '.' ) then
    begin
        Error ;
    end ;
    if( Test_Monetary^.Group <> ',' ) then
    begin
        Error ;
    end ;
    if( Test_Monetary^.Money_Symbol <> '$' ) then
    begin
        Error ;
    end ;
    if( Test_Monetary^.Internationl_Money_Symbol <> '$' ) then
    begin
        Error ;
    end ;
    dispose( Test_Monetary, done ) ;
end ;


procedure Test_Unit ;

var Test : TSText_Presentation_Manager ;

begin
    Test.Init ;
    Test_Dates( Test.Date_Text_Presentation_Manager ) ;
    Test_Numerics( Test.Numeric_Text_Presentation_Manager ) ;
    Test_Monetarys( Test.Monetary_Text_Presentation_Manager ) ;
    Test.Done ;
end ;
{$ENDIF}


end.
