{$N+}
{
        Program Name : _CacheMa
        Package Name : Subroutine Library - Layer 1
        Purpose      : Cache Manager class
        Institution  : Conroy & Conroy Co.
        Date Written : 18-Jun-1994
        Written By   : Alan Conroy
        Version      : 1.0

        Copyright (C) 1994-2008 by Alan Conroy.  Released to the public domain.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          The cache manager is used to manage multiple caches.
}

unit _CacheMa ;

interface

{$I EDEFINES.INC}

uses { Layer 0... }
     Collect, { TCollection }
{$IFDEF BP}
     Objects, { TCollection }
{$ENDIF}
     _Types, { int64 }
     CommBase ; { TBase_Object }

type TCache_Handler = function( Siz, Code : longint ) : longint ;
{ Cache handlers are passed a size (Siz) to free.  If size is zero (0) then
  Code indicates a special operation to perform.  For now, the only defined
  code is 0, which indicates that the function should return the amount of
  memory currently allocated in its cache.  If Size is not zero, Code is
  ignored.  If size is negative, then the cache should be completely zeroed. }

{$IFDEF DELEGATION}
type TCache_Event = function( Size, Code : longint ) : longint of object ;
{$ENDIF}

type TSCache_Manager = object( TBase_Object )
                           public { API... }
                               procedure Initialize ; virtual ;
                               procedure Terminate ; virtual ;
                               procedure Add_Handler( Routine : TCache_Handler ;
                                   Priority : longint ) ; virtual ;
                               { This routine adds a cache handler to the cache
                                 chain.  Routine is a pointer to the cache
                                 handler and Priority is the relative priority
                                 of this cache. }

                               procedure Delete_Handler( Routine : TCache_Handler ) ;
                                   virtual ;
                               { This routine removes a cache handler from the
                                 cache handler list. }

                               procedure Free_Cache( Siz, Priority : longint ;
                                   Exclude : TCache_Handler ) ;
                                   virtual ;
                               { This routine calls the appropriate cache
                                 handlers to free up Siz bytes of memory.  A
                                 specific handler can be excluded from this.
                                 Calling this with Exclude of nil, priority of
                                 maxint, and Siz of -1, will zero all caches. }

{$IFDEF DELEGATION}
                               procedure Add_Event( Routine : TCache_Event ;
                                   Priority : longint ) ; virtual ;
                               procedure Delete_Event( Routine : TCache_Event ) ;
                                   virtual ;
                               procedure Free_Event( Siz, Priority : longint ;
                                   Exclude : TCache_Event ) ;
                                   virtual ;
{$ENDIF}
                       end ;
     PSCache_Manager = ^TSCache_Manager ;

var Cache_Manager : PSCache_Manager
{$IFDEF VARIABLE_DECLARATION_ASSIGN}
    = nil
{$ENDIF}
    ;

implementation

uses { Layer 0... }
     _Common ; { Abstract_Error }

     
{ TSCache_Manager methods... }

{ API... }

procedure TSCache_Manager.Initialize ;

begin
    Abstract_Error ;
end ;


procedure TSCache_Manager.Terminate ;

begin
    Abstract_Error ;
end ;


procedure TSCache_Manager.Add_Handler( Routine : TCache_Handler ;
    Priority : longint ) ;

begin
    Abstract_Error ;
end ;


procedure TSCache_Manager.Delete_Handler( Routine : TCache_Handler ) ;

begin
    Abstract_Error ;
end ;


procedure TSCache_Manager.Free_Cache( Siz, Priority : longint ;
                                   Exclude : TCache_Handler ) ;

begin
    Abstract_Error ;
end ;


{$IFDEF DELEGATION}
procedure TSCache_Manager.Add_Event( Routine : TCache_Event ;
    Priority : longint ) ;

begin
    Abstract_Error ;
end ;


procedure TSCache_Manager.Delete_Event( Routine : TCache_Event ) ;

begin
    Abstract_Error ;
end ;


procedure TSCache_Manager.Free_Event( Siz, Priority : longint ;
    Exclude : TCache_Event ) ;

begin
    Abstract_Error ;
end ;
{$ENDIF}


end.
