/*
              Program Name : _Files
              Package Name : Subroutine Library - Layer 1
              Purpose      : Abstract File classes
              Institution  : Conroy & Conroy Co.
              Date Written : 30-Nov-88
              Written By   : Alan Conroy
              Version      : 2.0

              TO THE GLORY OF GOD THROUGH JESUS CHRIST

        Copyright (C) 1988-2009 by Conroy & Conroy.  Released to the public domain.

        *********************************************************
        *                                                       *
        *        M O D I F I C A T I O N   H I S T O R Y        *
        *                                                       *
        *********************************************************

            DATE      BY             REASON

        *********************************************************
        *                                                       *
        *           P R O G R A M   P U R P O S E               *
        *                                                       *
        *********************************************************

          This unit defines the TSFile class.
*/

#ifndef _FILESH
	#define _FILESH

class TCOM_File : public TStandard_COM_Store
{
     public: // API...
         virtual void __stdcall Reset( char* Name ) = 0;
         virtual void __stdcall Rewrite( char* Name ) = 0;
         virtual void __stdcall Append( char* Name ) = 0;
         virtual void __stdcall Close() = 0;
         virtual void __stdcall Seek( TStore_Address Pos ) = 0;
         virtual TStore_Address __stdcall Read_Integer() = 0;
         virtual long double __stdcall Read_Float() = 0;
         virtual void __stdcall Read( void* Buffer ) = 0;
         virtual void __stdcall Write( void* Buffer ) = 0;
         virtual void __stdcall Readln( char* Buffer ) = 0;
         virtual void __stdcall Writeln( char* Buffer ) = 0;
         virtual void __stdcall Blockread( void* Buf, TRecord_Size Count,
             TRecord_Size& Res ) = 0;
         virtual void __stdcall Blockwrite( void* Buf, TRecord_Size Count,
             TRecord_Size& Res ) = 0;
         virtual bool __stdcall EOF() = 0;
         virtual bool __stdcall EOLn() = 0;
         virtual TStore_Size __stdcall FilePos() = 0;
         virtual TStore_Size __stdcall Get_Size() = 0;
         virtual void __stdcall Set_Size( TStore_Size New_Size ) = 0;
         virtual void __stdcall Erase( char* const Name ) = 0;
         virtual void __stdcall Flush() = 0;
         virtual char* __stdcall FileName() = 0;
         virtual bool __stdcall SeekEOF() = 0;
         virtual bool __stdcall SeekEOLn() = 0;
         virtual void __stdcall GetFTime( int& _Time ) = 0;
         virtual void __stdcall SetFTime( int _Time ) = 0;
         virtual void __stdcall SetTextBuf( void* buf, unsigned short size ) = 0;
         virtual void __stdcall Set_Extend( bool State ) = 0;
         virtual void __stdcall Truncate( TStore_Address Size ) = 0;
         virtual int __stdcall Get_Attributes() = 0;
         virtual void __stdcall Set_Attributes( int Value ) = 0;
         virtual int __stdcall Facility() = 0;
         virtual int __stdcall Version() = 0;
         virtual char* __stdcall Facility_Name() = 0;
         virtual bool __stdcall Opened() = 0;
         virtual int __stdcall Get_Time() = 0;
         virtual void __stdcall Set_Time( int Value ) = 0;
         virtual void __stdcall GetFAttr( unsigned short* Attr ) = 0;
         virtual void __stdcall SetFAttr( unsigned short Attr ) = 0;
         virtual void __stdcall Set_Error( int F, int X ) = 0;
         virtual bool __stdcall Get_Extendable() = 0;
         virtual int __stdcall Get_File_Mode() = 0;
         virtual TUEC __stdcall Get_IO_Error() = 0;
         virtual TRecord_Size __stdcall Get_Record_Size() = 0;
         virtual void __stdcall Set_Extendable( bool Value ) = 0;
         virtual void __stdcall Set_File_Mode( int Value ) = 0;
         virtual void __stdcall Set_IO_Error( TUEC Value ) = 0;
         virtual void __stdcall Set_Record_Size( TRecord_Size Value ) = 0;
} ; // TCOM_File
#endif

