{
        File Name    : _StoreLis
        Package Name : Subroutine Library - Layer 4
        Purpose      : Store Lists
        Institution  : Conroy & Conroy Co.
        Date Written : 29-Oct-2005
        Written By   : Alan Conroy
        Version      : 1.0

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

          Defines various lists stored on managed stores...
}

unit _StoreLis ;

interface

{$I EDEFINES.INC}

{$IFDEF DYNAMIC_OBJECTS}
uses // C&C Subroutine Library - Layer 0...
     CommBase, // TBase_Delphi_Object
     _COMLists, // TCOM_List

     // C&C Subroutine Library - Layer 1...
     MStores, // TManaged_Store
     _Stores, // TStore_Address64

     // C&C Subroutine Library - Layer 3...
     FSFH, // PSFH

     // C&C Subroutine Library - Layer 4...
     BigFH ; // TBig_FH

type TStore_List = class( TBase_Delphi_Object )
                       protected // Property handlers...
                           function Get_Item( Index : longint ) : longint ;
                               virtual ; stdcall ; abstract ;
                           function Get_Address : longint ;
                               virtual ; stdcall ; abstract ;
                           function Get_Capacity : longint ;
                               virtual ; stdcall ; abstract ;
                           function Get_Count : longint ;
                               virtual ; stdcall ; abstract ;
                           function Get_Delta : longint ;
                               virtual ; stdcall ; abstract ;
                           function Get_Store : PFH ;
                               virtual ; stdcall ; abstract ;

                           procedure Set_Item( Index, Value : longint ) ;
                               virtual ; stdcall ; abstract ;
                           procedure Set_Address( Value : longint ) ;
                               virtual ; stdcall ; abstract ;
                           procedure Set_Capacity( Value : longint ) ;
                               virtual ; stdcall ; abstract ;
                           procedure Set_Count( Value : longint ) ;
                               virtual ; stdcall ; abstract ;
                           procedure Set_Delta( Value : longint ) ;
                               virtual ; stdcall ; abstract ;
                           procedure Set_Store( Value : PFH ) ;
                               virtual ; stdcall ; abstract ;

                       public // API...
                           function Add( Value : longint ) : longint ;
                               virtual ; stdcall ; abstract ;
                           function Add_Insert( Value : longint ) : longint ;
                               virtual ; stdcall ; abstract ;
                           function IndexOf( Value : longint ) : longint ;
                               virtual ; stdcall ; abstract ;
                           procedure Update_Header ;
                               virtual ; stdcall ; abstract ;

                           property Address : longint
                               read Get_Address
                               write Set_Address ;
                           property Items[ Index : longint ] : longint
                               read Get_Item
                               write Set_Item ; default ;
                           property Capacity : longint
                               read Get_Capacity
                               write Set_Capacity ;
                           property Count : longint
                               read Get_Count
                               write Set_Count ;
                           property Delta : longint
                               read Get_Delta
                               write Set_Delta ;
                           property Store : PFH
                               read Get_Store
                               write Set_Store ;
                   end ; // TStore_List

  {$IFDEF INT64}
type TStore_List_64 = class( TBase_Delphi_Object )
                         protected // Property handlers...
                             function _Get_Item( Index : int64 ) : int64 ;
                             procedure _Set_Item( Index, Value : int64 ) ;

                             function Get_Item( Index : int64 ) : int64 ;
                                 virtual ; stdcall ; abstract ;
                             function Get_Address : int64 ;
                                 virtual ; stdcall ; abstract ;
                             function Get_Capacity : int64 ;
                                 virtual ; stdcall ; abstract ;
                             function Get_Count : int64 ;
                                 virtual ; stdcall ; abstract ;
                             function Get_Delta : int64 ;
                                 virtual ; stdcall ; abstract ;
                             function Get_Store : PSBig_FH ;
                                 virtual ; stdcall ; abstract ;

                             procedure Set_Item( Index, Value : int64 ) ;
                                 virtual ; stdcall ; abstract ;
                             procedure Set_Address( Value : int64 ) ;
                                 virtual ; stdcall ; abstract ;
                             procedure Set_Capacity( Value : int64 ) ;
                                 virtual ; stdcall ; abstract ;
                             procedure Set_Count( Value : int64 ) ;
                                 virtual ; stdcall ; abstract ;
                             procedure Set_Delta( Value : int64 ) ;
                                 virtual ; stdcall ; abstract ;
                             procedure Set_Store( Value : PSBig_FH ) ;
                                 virtual ; stdcall ; abstract ;

                         public // API...
                             function Add( Value : int64 ) : int64 ;
                                 virtual ; stdcall ; abstract ;
                             function Add_Insert( Value : int64 ) : int64 ;
                                 virtual ; stdcall ; abstract ;
                             function IndexOf( Value : int64 ) : int64 ;
                                 virtual ; stdcall ; abstract ;
                             procedure Update_Header ;
                                 virtual ; stdcall ; abstract ;

                             property Items[ Index : int64 ] : int64
                                 read _Get_Item
                                 write _Set_Item ; default ;

(*
                         published // Properties...
                             property Address : int64
                                 read Get_Address
                                 write Set_Address ;
                             property Capacity : int64
                                 read Get_Capacity
                                 write Set_Capacity ;
                             property Count : int64
                                 read Get_Count
                                 write Set_Count ;
                             property Delta : int64
                                 read Get_Delta
                                 write Set_Delta ;
                             property Store : PSBig_FH
                                 read Get_Store
                                 write Set_Store ;
*)
                     end ; // TStore_List64
  {$ENDIF}


  {$IFDEF DYNAMIC_OBJECTS}
type TCOM_Store_List = class( TCOM_List )
                              public { API... }
                                  function Get_Address : longint ;
                                      virtual ; stdcall ; abstract ;
                                  procedure Set_Address( Value : longint ) ;
                                      virtual ; stdcall ; abstract ;
                                  function Add( Value : longint ) : longint ;
                                      override ; stdcall ; abstract ;
                                  function Get_Count : longint ;
                                      override ; stdcall ; abstract ;
                                  function Get_Item( Index : longint ) : longint ;
                                      override ; stdcall ; abstract ;
                                  procedure Set_Item( Index, Value : longint ) ;
                                      override ; stdcall ; abstract ;
                                  function Get_Capacity : longint ;
                                      override ; stdcall ; abstract ;
                                  procedure Set_Capacity( Value : longint ) ;
                                      override ; stdcall ; abstract ;
                                  function Get_Delta : longint ;
                                      override ; stdcall ; abstract ;
                                  procedure Set_Delta( Value : longint ) ;
                                      override ; stdcall ; abstract ;

                                  function Get_Store : TManaged_Store ;
                                      virtual ; stdcall ; abstract ;
                                  procedure Set_Store( Value : TManaged_Store ) ;
                                      virtual ; stdcall ; abstract ;

                              public // API...
                                  function Add_Insert( Value : longint ) : longint ;
                                      virtual ; stdcall ; abstract ;
                                  function IndexOf( Value : longint ) : longint ;
                                      override ; stdcall ; abstract ;
                                  procedure Update_Header ;
                                      virtual ; stdcall ; abstract ;
                          end ;

type TCOM_Store64_List = class( TCOM_List )
                              public { API... }
                                  function Get_Address : TStore_Address64 ;
                                      virtual ; stdcall ; abstract ;
                                  procedure Set_Address( Value : TStore_Address64 ) ;
                                      virtual ; stdcall ; abstract ;
                                  function Add( Value : longint ) : longint ;
                                      override ; stdcall ; abstract ;
                                  function Get_Count : longint ;
                                      override ; stdcall ; abstract ;
                                  procedure Set_Count( Value : longint ) ;
                                      override ; stdcall ; abstract ;
                                  function Get_Item( Index : longint ) : longint ;
                                      override ; stdcall ; abstract ;
                                  procedure Set_Item( Index, Value : longint ) ;
                                      override ; stdcall ; abstract ;
                                  function Get_Capacity : longint ;
                                      override ; stdcall ; abstract ;
                                  procedure Set_Capacity( Value : longint ) ;
                                      override ; stdcall ; abstract ;
                                  function Get_Delta : longint ;
                                      override ; stdcall ; abstract ;
                                  procedure Set_Delta( Value : longint ) ;
                                      override ; stdcall ; abstract ;

                                  function Get_Store : TCOM_Managed_Store64 ;
                                      virtual ; stdcall ; abstract ;
                                  procedure Set_Store( Value : TCOM_Managed_Store64 ) ;
                                      virtual ; stdcall ; abstract ;

                              public // API...
                                  function Add_Insert( Value : longint ) : longint ;
                                      virtual ; stdcall ; abstract ;
                                  function IndexOf( Value : longint ) : longint ;
                                      override ; stdcall ; abstract ;
                                  procedure Update_Header ;
                                      virtual ; stdcall ; abstract ;
                          end ;
  {$ENDIF}
{$ENDIF}

implementation


// TStore_List_64 methods...

// Property handlers...

function TStore_List_64._Get_Item( Index : int64 ) : int64 ;

begin
    Result := Get_Item( Index ) ;
end ;


procedure TStore_List_64._Set_Item( Index, Value : int64 ) ;

begin
    Set_Item( Index, Value ) ;
end ;


end.
