{
        Program Name : Media
        Package Name : LB
        Purpose      : Multimedia support
        Institution  : Conroy & Conroy Co.
        Date Written : 18-Dec-2002
        Written By   : Alan Conroy
        Version      : 2.0

        Copyright (C) 2002 by Alan Conroy.  Released to the public domain

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

}

unit Media ;

interface

uses // Borland...
     Windows, ActiveX, ComObj, MMSystem;

type TMP3_ID3 = packed record { Last 128 bytes of a .MP3 file, if present }
                    Tag : array[ 0..2 ] of Char ; { "TAG" }
                    Title,
                    Artist,
                    Album : array[ 0..29 ] of Char ;
                    Year : array[ 0..3 ] of Char ;
                    Comment : array[ 0..27 ] of Char ;
                    Track_Flag : byte ;
                    Track : byte ;
                    Genre : Byte ;
                end ; { TMP3_ID3 }

     TExtended_MP3_ID3 = packed record
                    Tag : array[ 0..4 ] of Char ; { "TAG+" }
                    Title,
                    Artist,
                    Album : array[ 0..59 ] of Char ;
                    Speed : integer ;
                    Genre : array[ 0..29 ] of char ;
                    Start_Time : array[ 0..5 ] of char ;
                    End_Time : array[ 0..5 ] of char ;
                end ; { TMP3_ID3 }

     TID3v2 = packed record { ID3v2 header }
                  Tag : array[ 0..2 ] of char ; { "ID3" }
                  Version : byte ;
                  Revision : byte ;
                  Flags : byte ;
                  Size : array[ 0..3 ] of byte ;
              end ; { TID3v2 }

     TMP3_Genre = ( MP3G_Blues, MP3G_Classic_Rock, MP3G_Country, MP3G_Dance,
                    MP3G_Disco, MP3G_Funk, MP3G_Grunge, MP3G_Hip_Hop, MP3G_Jazz,
                    MP3G_Metal, MP3G_New_Age, MP3G_Oldies, MP3G_Other, MP3G_Pop,
                    MP3G_R_B, MP3G_Rap, MP3G_Reggae, MP3G_Rock, MP3G_Techno,
                    MP3G_Industrial, MP3G_Alternative, MP3G_Ska,
                    MP3G_Death_Metal, MP3G_Pranks, MP3G_Soundtrack,
                    MP3G_Euro_Techno, MP3G_Ambient, MP3G_Trip_Hop, MP3G_Vocal,
                    MP3G_Jazz_Funk, MP3G_Fusion, MP3G_Trance, MP3G_Classical,
                    MP3G_Instrumental, MP3G_Acid, MP3G_House, MP3G_Game,
                    MP3G_Sound_Clip, MP3G_Gospel, MP3G_Noise, MP3G_AlternRock,
                    MP3G_Bass, MP3G_Soul, MP3G_Punk, MP3G_Space,
                    MP3G_Meditative, MP3G_Instrumental_Pop,
                    MP3G_Instrumental_Rock, MP3G_Ethnic, MP3G_Gothic,
                    MP3G_Darkwave, MP3G_Techno_Industrial, MP3G_Electronic,
                    MP3G_Pop_Folk, MP3G_Eurodance, MP3G_Dream,
                    MP3G_Southern_Rock, MP3G_Comedy, MP3G_Cult, MP3G_Gangsta,
                    MP3G_Top_40, MP3G_Christian_Rap, MP3G_Pop_Funk, MP3G_Jungle,
                    MP3G_Native_American, MP3G_Cabaret, MP3G_New_Wave,
                    MP3G_Psychadelic, MP3G_Rave, MP3G_Showtunes, MP3G_Trailer,
                    MP3G_Lo_Fi, MP3G_Tribal, MP3G_Acid_Punk, MP3G_Acid_Jazz,
                    MP3G_Polka, MP3G_Retro, MP3G_Musical, MP3G_Rock_n_Roll,
                    MP3G_Hard_Rock, MP3G_Folk, MP3G_Folk_Rock,
                    MP3G_National_Folk, MP3G_Swing, MP3G_Fast_Fusion,
                    MP3G_Bebob, MP3G_Latin, MP3G_Revival, MP3G_Celtic,
                    MP3G_Bluegrass, MP3G_Avantgarde, MP3G_Gothic_Rock,
                    MP3G_Progressive_Rock, MP3G_Psychadelic_Rock,
                    MP3G_Symphonic_Rock, MP3G_Slow_Rock, MP3G_Big_Band,
                    MP3G_Chorus, MP3G_Easy_Listening, MP3G_Acoustic, MP3G_Humor,
                    MP3G_Speech, MP3G_Chanson, MP3G_Opera, MP3G_Chamber_Music,
                    MP3G_Sonata, MP3G_Symphony, MP3G_Booty_Bass, MP3G_Primus,
                    MP3G_Porn_Groove, MP3G_Satire, MP3G_Slow_Jam, MP3G_Club,
                    MP3G_Tango, MP3G_Samba, MP3G_Folklore, MP3G_Ballad,
                    MP3G_Power_Ballad, MP3G_Rhythmic_Soul, MP3G_FreeStyle,
                    MP3G_Duet, MP3G_Punk_Rock, MP3G_Drum_Solo, MP3G_Acapella,
                    MP3G_Euro_House, MP3G_Dance_Hall, MP3G_Goa,
                    MP3G_Drum_n_Bass, MP3G_Club_House, MP3G_Hardcore,
                    MP3G_Terror, MP3G_Indie, MP3G_Britpop, MP3G_Negerpunk,
                    MP3G_Polsk_Punk, MP3G_Beat, MP3G_Christian_Gangsta_Rap,
                    MP3G_Heavy_Metal, MP3G_Black_Metal, MP3G_Crossover,
                    MP3G_Contemporary_Christian, MP3G_Christian_Rock,
                    MP3G_Merengue, MP3G_Salsa, MP3G_Trash_Metal, MP3G_Anime,
                    MP3G_JPop, MP3G_Synthpop, MP3G_Unknown ) ;
const MP3_Genre : array[ TMP3_Genre ] of string = (
    'Blues', 'Classic Rock', 'Country', 'Dance', 'Disco', 'Funk', 'Grunge',
    'Hip-Hop', 'Jazz', 'Metal', 'New Age', 'Oldies', 'Other', 'Pop', 'R&B',
    'Rap', 'Reggae', 'Rock', 'Techno', 'Industrial', 'Alternative', 'Ska',
    'Death Metal', 'Pranks', 'Soundtrack', 'Euro-Techno', 'Ambient', 'Trip-Hop',
    'Vocal', 'Jazz+Funk', 'Fusion', 'Trance', 'Classical', 'Instrumental',
    'Acid', 'House', 'Game', 'Sound Clip', 'Gospel', 'Noise', 'AlternRock',
    'Bass', 'Soul', 'Punk', 'Space', 'Meditative', 'Instrumental Pop',
    'Instrumental Rock', 'Ethnic', 'Gothic', 'Darkwave', 'Techno-Industrial',
    'Electronic', 'Pop-Folk', 'Eurodance', 'Dream', 'Southern Rock', 'Comedy',
    'Cult', 'Gangsta', 'Top 40', 'Christian Rap', 'Pop/Funk', 'Jungle',
    'Native American', 'Cabaret', 'New Wave', 'Psychadelic', 'Rave',
    'Showtunes', 'Trailer', 'Lo-Fi', 'Tribal', 'Acid Punk', 'Acid Jazz',
    'Polka', 'Retro', 'Musical', 'Rock & Roll', 'Hard Rock', 'Folk',
    'Folk-Rock', 'National Folk', 'Swing', 'Fast Fusion', 'Bebob', 'Latin',
    'Revival', 'Celtic', 'Bluegrass', 'Avantgarde', 'Gothic Rock',
    'Progressive Rock', 'Psychadelic Rock', 'Symphonic Rock', 'Slow Rock',
    'Big Band', 'Chorus', 'Easy Listening', 'Acoustic', 'Humor', 'Speech',
    'Chanson', 'Opera', 'Chamber Music', 'Sonata', 'Symphony', 'Booty Bass',
    'Primus', 'Porn Groove', 'Satire', 'Slow Jam', 'Club', 'Tango', 'Samba',
    'Folklore', 'Ballad', 'Power Ballad', 'Rhythmic Soul', 'Freestyle', 'Duet',
    'Punk Rock', 'Drum Solo', 'Acapella', 'Euro-House', 'Dance Hall', 'Goa',
    'Drum & Bass', 'Club-House', 'Hardcore', 'Terror', 'Indie', 'BritPop',
    'Negerpunk', 'Polsk Punk', 'Beat', 'Christian Gangsta Rap', 'Heavy Metal',
    'Black Metal', 'Crossover', 'Contemporary Christian', 'Christian Rock',
    'Merengue', 'Salsa', 'Trash Metal', 'Anime', 'Jpop', 'Synthpop', 'Unknown'
  );

      // ID3v2 Embedded image types...
type ID3v2_EI = ( EI_Other,
                  EI_File_Icon, // 32x32 pixels 'file icon' (PNG only)
                  EI_File_Icon_Other, // Other file icon
                  EI_Front_Cover,
                  EI_Back_Cover,
                  EI_Leaflet, // Leaflet page
                  EI_Media, // Media (e.g. label side of CD)
                  EI_Lead, // Lead artist/lead performer/soloist
                  EI_Artist, // Artist/performer
                  EI_Conductor, // Conductor
                  EI_Band, // Band/Orchestra
                  EI_Composer, // Composer
                  EI_Lyricist, // Lyricist/text writer
                  EI_Recording_Location,
                  EI_Recording, // During recording
                  EI_Performance, // During performance
                  EI_Screen_Capture, // Movie/video screen capture
                  EI_Fish, // A bright coloured fish
                  EI_Illustration,
                  EI_Band_Logo, // Band/artist logotype
                  EI_Publisher_Logo // Publisher/Studio logotype
                ) ;

{$MINENUMSIZE 4}

type puint64 = ^Longword ;

type

   IInitializeWithFile = interface(IUnknown)
   ['{b7d14566-0509-4cce-a71f-0a554233bd9b}']
     function Initialize(pszFilePath: PAnsiChar; grfMode: DWORD):HRESULT; stdcall;
   end;


   IInitializeWithStream = interface(IUnknown)
   ['{b824b49d-22ac-4161-ac8a-9916e8fa3f7f}']
     function Initialize(var pIStream: IStream; grfMode: DWORD):HRESULT; stdcall;
   end;

   _tagpropertykey = packed record 
     fmtid: TGUID;
     pid: DWORD;
   end;
   PROPERTYKEY = _tagpropertykey;
   PPropertyKey = ^TPropertyKey;
   TPropertyKey = _tagpropertykey;

   IPropertyStore = interface(IUnknown)
     ['{886d8eeb-8cf2-4446-8d02-cdba1dbdcf99}']
     function GetCount(out cProps: DWORD): HResult; stdcall;
     function GetAt(iProp: DWORD; out pkey: TPropertyKey): HResult; stdcall;
     function GetValue(const key: TPropertyKey; out pv: TPropVariant):HResult; stdcall;
     function SetValue(const key: TPropertyKey; const propvar:TPropVariant): HResult; stdcall;
     function Commit: HResult; stdcall;
   end;


   IPropertyStoreCapabilities = interface(IUnknown)
   ['{c8e2d566-186e-4d49-bf41-6909ead56acc}']
     function IsPropertyWritable(pPropKey: PPropertyKey): HRESULT; stdcall;
   end;

const
   PKEY_Device_FriendlyName: TPropertyKey = (
                fmtid: (D1:$a45c254e; D2:$df1c ; D3:$4efd;
                D4: ($80, $20, $67, $d1, $46, $a8, $50, $e0));
                pid: 14);

procedure PropVariantInit(var pv : TPropVariant);

const
  CLASS_IMMDeviceEnumerator             : TGUID = '{BCDE0395-E52F-467C-8E3D-C4579291692E}';
  IID_IMMDeviceEnumerator               : TGUID = '{A95664D2-9614-4F35-A746-DE8DB63617E6}';
  IID_IMMDevice                         : TGUID = '{D666063F-1587-4E43-81F1-B948E807363F}';
  IID_IMMDeviceCollection               : TGUID = '{0BD7A1BE-7A1A-44DB-8397-CC5392387B5E}';
  IID_IAudioEndpointVolume              : TGUID = '{5CDF2C82-841E-4546-9722-0CF74078229A}';
  IID_IAudioMeterInformation            : TGUID = '{C02216F6-8C67-4B5B-9D00-D008E73E0064}';
  IID_IAudioEndpointVolumeCallback      : TGUID = '{657804FA-D6AD-4496-8A60-352752AF4F89}';
  IID_IAudioClient                      : TGUID = '{1CB9AD4C-DBFA-4c32-B178-C2F568A703B2}';
  IID_IMMNotificationClient             : TGUID = '{7991EEC9-7E89-4D85-8390-6C703CEC60C0}';
  IID_IAudioSessionManager              : TGUID = '{BFA971F1-4D5E-40BB-935E-967039BFBEE4}';
  IID_IAudioCaptureClient               : TGUID = '{C8ADBD64-E71E-48a0-A4DE-185C395CD317}';
  IID_IAudioRenderClient                : TGUID = '{F294ACFC-3146-4483-A7BF-ADDCA7C260E2}';

  DEVICE_STATE_ACTIVE                   = $00000001;
  DEVICE_STATE_UNPLUGGED                = $00000002;
  DEVICE_STATE_NOTPRESENT               = $00000004;
  DEVICE_STATEMASK_ALL                  = $00000007;

  eRender                               = $00000000;
  eCapture                              = $00000001;
  eAll                                  = $00000002;
  EDataFlow_enum_count                  = $00000003;

  eConsole                              = $00000000;
  eMultimedia                           = $00000001;
  eCommunications                       = $00000002;
  ERole_enum_count                      = $00000003;

  ENDPOINT_HARDWARE_SUPPORT_VOLUME    = $00000001;
  ENDPOINT_HARDWARE_SUPPORT_MUTE      = $00000002;
  ENDPOINT_HARDWARE_SUPPORT_METER     = $00000004;

  AUDCLNT_SHAREMODE_SHARED              = 0;
  AUDCLNT_SHAREMODE_EXCLUSIVE           = 1;

  AUDCLNT_BUFFERFLAGS_DATA_DISCONTINUITY   = 1;
  AUDCLNT_BUFFERFLAGS_SILENT               = 2;
  AUDCLNT_BUFFERFLAGS_TIMESTAMP_ERROR      = 4;

  AUDCLNT_STREAMFLAGS_LOOPBACK        = $00020000;
  AUDCLNT_STREAMFLAGS_EVENTCALLBACK   = $00040000;
  AUDCLNT_STREAMFLAGS_NOPERSIST       = $00080000;

  // AudioSessionState...
  AudioSessionStateInactive = 0;       // The last running stream in the session stops.
  AudioSessionStateActive = 1;         // The session has one or more streams that are running.
  AudioSessionStateExpired = 2;        // The client destroys the last stream in the session by releasing all
                                       // references to the stream object.
  // DisconnectReason...
  DisconnectReasonDeviceRemoval = 0;   // The user removed the audio endpoint device.
  DisconnectReasonServerShutdown = 1;  // The Windows audio service has stopped.
  DisconnectReasonFormatChanged = 2;   // The stream format changed for the device that the audio session is connected to.
  DisconnectReasonSessionLogoff = 3;   // The user logged off the Windows Terminal Services (WTS) session that the audio
                                       // session was running in.
  DisconnectReasonSessionDisconnected = 4; // The WTS session that the audio session was running in was disconnected.
  DisconnectReasonExclusiveModeOverride = 5;  // The (shared-mode) audio session was disconnected to make the audio endpoint
                                              // device available for an exclusive-mode connection.

type
  REFERENCE_TIME = int64;
  EDataFlow = TOleEnum;
  ERole = TOleEnum;
  AUDCLNT_SHAREMODE = TOleEnum;

  PAUDIO_VOLUME_NOTIFICATION_DATA = ^AUDIO_VOLUME_NOTIFICATION_DATA;
  AUDIO_VOLUME_NOTIFICATION_DATA = packed record
    guidEventContext: TGUID;
    bMuted: BOOL;
    fMasterVolume: Single;
    nChannels: UINT;
    afChannelVolumes: array [1..1] of Single;
  end;

type
  IAudioEndpointVolumeCallback = interface(IUnknown)
  ['{657804FA-D6AD-4496-8A60-352752AF4F89}']
    function OnNotify(pNotify:PAUDIO_VOLUME_NOTIFICATION_DATA):HRESULT; stdcall;
  end;

  IAudioEndpointVolume = interface(IUnknown)
    ['{5CDF2C82-841E-4546-9722-0CF74078229A}']
    function RegisterControlChangeNotify(pNotify: IAudioEndpointVolumeCallback): HRESULT; stdcall;
    function UnregisterControlChangeNotify(pNotify: IAudioEndpointVolumeCallback): HRESULT; stdcall;
    function GetChannelCount(var pnChannelCount: UINT): HRESULT; stdcall;
    function SetMasterVolumeLevel(fLevelDB: Single; pguidEventContext: PGuid): HRESULT; stdcall;
    function SetMasterVolumeLevelScalar(fLevel: Single; pguidEventContext: PGuid): HRESULT; stdcall;
    function GetMasterVolumeLevel(var pfLevelDB: Single): HRESULT; stdcall;
    function GetMasterVolumeLevelScalar(var pfLevel: Single): HRESULT; stdcall;
    function SetChannelVolumeLevel(nChannel: UINT; fLevelDB: Single; pguidEventContext: PGuid): HRESULT; stdcall;
    function SetChannelVolumeLevelScalar(nChannel: UINT; fLevel:Single; pguidEventContext: PGuid): HRESULT; stdcall;
    function GetChannelVolumeLevel(nChannel: UINT; fLevelDB: Single): HRESULT; stdcall;
    function GetChannelVolumeLevelScalar(nChannel: UINT; fLevel: Single): HRESULT; stdcall;
    function SetMute(bMute: BOOL; pguidEventContext: PGuid): HRESULT; stdcall;
    function GetMute(var pbMute: BOOL): HRESULT; stdcall;
    function GetVolumeStepInfo(var pnStep: UINT; var pnStepCount: UINT): HRESULT; stdcall;
    function VolumeStepUp(pguidEventContext: PGuid): HRESULT; stdcall;
    function VolumeStepDown(pguidEventContext: PGuid): HRESULT; stdcall;
    function QueryHardwareSupport(var pdwHardwareSupportMask: UINT): HRESULT; stdcall;
    function GetVolumeRange(var pflVolumeMindB: Single; var pflVolumeMaxdB: Single;
                            var pflVolumeIncrementdB: Single): HRESULT; stdcall;
  end;

  IAudioMeterInformation = interface(IUnknown)
  ['{C02216F6-8C67-4B5B-9D00-D008E73E0064}']
    function GetPeakValue(out fPeak: Single): HRESULT; stdcall;
    function GetMeteringChannelCount(out nChannelCount: UINT): HRESULT; stdcall;
    function GetChannelsPeakValues(u32ChannelCount: UINT; pfPeakValues: pSingle): HRESULT; stdcall;
    function QueryHardwareSupport(out dwHardwareSupportMask: UINT): HRESULT; stdcall;
  end;

  IMMDevice = interface(IUnknown)
    ['{D666063F-1587-4E43-81F1-B948E807363F}']
    function Activate(const iid: TGUID; dwClsCtx: UINT; pActivationParams: PPropVariant; out ppInterface:IUnknown): HRESULT; stdcall;
    function OpenPropertyStore(stgmAccess: integer; out ppProperties: IPropertyStore): HRESULT; stdcall;  // ** Changed at 2011-08-09
    function GetId(out ppstrId: PWChar): HRESULT; stdcall;
    function GetState(var pdwState: Integer): HRESULT; stdcall;
  end;


  IMMDeviceCollection = interface(IUnknown)
    ['{0BD7A1BE-7A1A-44DB-8397-CC5392387B5E}']
    function GetCount(var pcDevices: UINT):HRESULT; stdcall;
    function Item(nDevice: UINT; out ppDevice: IMMDevice):HRESULT; stdcall;
  end;

 // IMMNotificationClient = interface(IUnknown)
 // ['{7991EEC9-7E89-4D85-8390-6C703CEC60C0}']
 // end;
  IMMNotificationClient = interface(IUnknown)
  ['{7991EEC9-7E89-4D85-8390-6C703CEC60C0}']
   function OnDeviceStateChanged(DeviceId: LPCWSTR; NewState: DWORD): HRESULT; stdcall;
   function OnOnDeviceAdded(DeviceId: LPCWSTR): HRESULT; stdcall;
   function OnDeviceRemoved(DeviceId: LPCWSTR): HRESULT; stdcall;
   function OnDefaultDeviceChanged(Flow: EDataFlow; Role: ERole; NewDefaultDeviceId: LPCWSTR): HRESULT; stdcall;
   function OnPropertyValueChanged(DeviceId: LPCWSTR; const Key: PROPERTYKEY): HRESULT; stdcall;
  end;

  IMMDeviceEnumerator = interface(IUnknown)
    ['{A95664D2-9614-4F35-A746-DE8DB63617E6}']
    function EnumAudioEndpoints(dataFlow:EDataFlow; dwStateMask:DWORD; out ppDevices: IMMDeviceCollection): HRESULT; stdcall;
    function GetDefaultAudioEndpoint(dataFlow:EDataFlow; role: ERole; out ppEndpoint: IMMDevice): HRESULT; stdcall;
    function GetDevice(pwstrId: PWChar;out ppDevice:IMMDevice): HRESULT; stdcall;
    function RegisterEndpointNotificationCallback(var pClient: IMMNotificationClient): HRESULT; stdcall;
    function UnregisterEndpointNotificationCallback(var pClient: IMMNotificationClient): HRESULT; stdcall;
  end;

  IAudioClient = interface(IUnknown)
  ['{1CB9AD4C-DBFA-4c32-B178-C2F568A703B2}']
   function Initialize(ShareMode: AUDCLNT_SHAREMODE; StreamFlags: DWORD; hmsBufferDuration: REFERENCE_TIME;
    hmsPeriodicity: REFERENCE_TIME; pFormat: PWAVEFORMATEX; AudioSessionGuid: pGuid): HRESULT; stdcall;
   function GetBufferSize(out NumBufferFrames: Longword): HRESULT; stdcall;
   function GetStreamLatency(out hmsLatency: REFERENCE_TIME): HRESULT; stdcall;
   function GetCurrentPadding(out NumPaddingFrames: Longword): HRESULT; stdcall;
   function IsFormatSupported(ShareMode: DWORD; pFormat: PWAVEFORMATEX; out pClosestMatch: PWAVEFORMATEX): HRESULT; stdcall;
   function GetMixFormat(out pFormat: PWAVEFORMATEX): HRESULT; stdcall;
   function GetDevicePeriod(out hmsDefaultDevicePeriod, hmsMinimumDevicePeriod: REFERENCE_TIME): HRESULT; stdcall;
   function Start: HRESULT; stdcall;
   function Stop: HRESULT; stdcall;
   function Reset: HRESULT; stdcall;
   function SetEventHandle(eventHandle: HWND): HRESULT; stdcall;
   function GetService(const iid: TGUID; out ppInterface:IUnknown): HRESULT; stdcall;
  end;

  IAudioSessionEvents = interface(IUnknown)
  ['{24918ACC-64B3-37C1-8CA9-74A66E9957A8}']
   function OnDisplayNameChanged(NewDisplayName: LPCWSTR; EventContext: pGuid): HResult; stdcall;
   function OnIconPathChanged(NewIconPath: LPCWSTR; EventContext: pGuid): HResult; stdcall;
   function OnSimpleVolumeChanged(NewVolume: Single; NewMute: LongBool; EventContext: pGuid): HResult; stdcall;
   function OnChannelVolumeChanged(ChannelCount: uint; NewChannelArray: PSingle; ChangedChannel: uint;
    EventContext: pGuid): HResult; stdcall;
   function OnGroupingParamChanged(NewGroupingParam, EventContext: pGuid): HResult; stdcall;
   function OnStateChanged(NewState: uint): HResult; stdcall; // AudioSessionState
   function OnSessionDisconnected(DisconnectReason: uint): HResult; stdcall; // AudioSessionDisconnectReason
  end;

  IAudioSessionControl = interface(IUnknown)
  ['{F4B1A599-7266-4319-A8CA-E70ACB11E8CD}']
   function GetState(out pRetVal: uint): HResult; stdcall;
   function GetDisplayName(out pRetVal: LPWSTR): HResult; stdcall; // pRetVal must be freed by CoTaskMemFree
   function SetDisplayName(Value: LPCWSTR; EventContext: pGuid): HResult; stdcall;
   function GetIconPath(out pRetVal: LPWSTR): HResult; stdcall; // pRetVal must be freed by CoTaskMemFree
   function SetIconPath(Value: LPCWSTR; EventContext: pGuid): HResult; stdcall;
   function GetGroupingParam(pRetVal: pGuid): HResult; stdcall;
   function SetGroupingParam(OverrideValue, EventContext: pGuid): HResult; stdcall;
   function RegisterAudioSessionNotification(const NewNotifications: IAudioSessionEvents): HResult; stdcall;
   function UnregisterAudioSessionNotification(const NewNotifications: IAudioSessionEvents): HResult; stdcall;
  end;

  ISimpleAudioVolume = interface(IUnknown)
  ['{87CE5498-68D6-44E5-9215-6DA47EF883D8}']
   function SetMasterVolume(fLevel: Single; EventContext: pGuid): HResult; stdcall;
   function GetMasterVolume(out fLevel: Single): HResult; stdcall;
   function SetMute(bMute: LongBool; EventContext: pGuid): HResult; stdcall;
   function GetMute(out bMute: LongBool): HResult; stdcall;
  end;

  IAudioSessionManager = interface(IUnknown)
  ['{BFA971F1-4D5E-40BB-935E-967039BFBEE4}']
   function GetAudioSessionControl(AudioSessionGuid: pGUID; CrossProcessSession: LongBool;
    out SessionControl: IAudioSessionControl): HResult; stdcall;
   function GetSimpleAudioVolume(AudioSessionGuid: pGuid; StreamFlag: uint;
    out AudioVolume: ISimpleAudioVolume): HResult; stdcall;
  end;

  IAudioCaptureClient = interface(IUnknown)
  ['{C8ADBD64-E71E-48a0-A4DE-185C395CD317}']
   function GetBuffer(out pData: PBYTE; out NumFramesToRead: Longword; out dwFlags: DWORD;
    pu64DevicePosition: PUINT64; pu64QPCPosition: PUINT64): HResult; stdcall;
   function ReleaseBuffer(NumFramesRead: Longword): HResult; stdcall;
   function GetNextPacketSize(out NumFramesInNextPacket: Longword): HResult; stdcall;
  end;

  IAudioRenderClient = interface(IUnknown)
  ['{F294ACFC-3146-4483-A7BF-ADDCA7C260E2}']
   function GetBuffer(NumFramesRequested: Longword; out pData: pByte): HResult; stdcall;
   function ReleaseBuffer(NumFramesWritten: Longword; dwFlags: DWORD): HResult; stdcall;
  end;


implementation

procedure PropVariantInit(var pv : TPropVariant);

begin
    pv.vt := VT_EMPTY;
end ;


end.
