{$D-}
{
        Program Name : TSRS
        Package Name : Subroutine Library - Layer 1
        Purpose      : Support for BIOS, Windows, and DOS structures and TSR routines
        Institution  : Conroy & Conroy Co.
        Date Written : 21-Jan-1992
        Written By   : Alan Conroy
        Version      : 2.1B

        Copyright (C) 1992 by Alan Conroy.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *********************************************************
        *                                                       *
        *          M O D I F I C A T I O N   H I S T O R Y      *
        *                                                       *
        *********************************************************

             DATE      BY             REASON

          1-Nov-2002   EAC            Correct compilation
                                      errors.
         20-Nov-2002   EAC            Moved CheckDOS here from
                                      Standard.
         11-Dec-2002   EAC            Added PEB-related stuff.

        *********************************************************
        *                                                       *
        *           P R O G R A M   P U R P O S E               *
        *                                                       *
        *********************************************************

          These strutures and routines are for support of Windows, DOS, and PC
        applications.

}

unit TSRS ;

interface

{$I EDEFINES.INC}

{$IFNDEF FPC_OR_DELPHI}
uses _TSRS ;
{$ENDIF}

{ Constants are now in _TSRS.PAS}

{$IFNDEF FPC_OR_DELPHI}
  {$IFNDEF LINUX}
    {$IFNDEF WINDOWS}
function CheckDOS : Boolean ; { Check DOS for undocumented function calls }
    {$ENDIF}
  {$ENDIF}
{$ENDIF}

procedure TSR ; { Terminate and Stay Resident }

implementation

{$IFNDEF FPC_OR_DELPHI}
  {$IFNDEF WINDOWS}
uses Dos ;
  {$ELSE}
uses Compatib ; { TRegisters }
  {$ENDIF}
{$ELSE}
uses Compatib ; { TRegisters }
{$ENDIF}

procedure Tsr ;
{ Use in place of Turbo Pascal's KEEP procedure.  It frees the environment and
  keeps the size of the TSR in memory smaller than KEEP. }

{$IFNDEF FPC_OR_DELPHI}
  {$IFNDEF LINUX}
    {$IFNDEF WINDOWS}
var R : Registers ;
    {$ENDIF}
  {$ENDIF}
{$ENDIF}

begin
{$IFNDEF LINUX}
  {$IFDEF DPMI}
    Keep( 0 ) ;
  {$ELSE}
    {$IFNDEF FPC_OR_DELPHI}
      {$IFNDEF WINDOWS}
    Swapvectors ;
    R.Ax := $4900 ; { Release memory block }
    R.Es := Memw[ Prefixseg : $2C ] ; { Environment location }
    Msdos( R ) ;
    R.Ax := $3100 ; { TSR }
    R.Dx := TOfs( Heapptr ).Segment - Prefixseg + 1 ;
    Msdos( R ) ;
      {$ENDIF}
    {$ENDIF}
  {$ENDIF}
{$ENDIF}
end ;


{$IFNDEF FPC_OR_DELPHI}
function Checkdos : Boolean ; { Return TRUE if DOS seems OK for undocumented use }

var  Command : string[ 40 ] ; { Dummy buffer area }
     Dummy : Integer ; { Offset and lastdrive from list of lists }
     List : Integer ; { Last drive from DOS }
  {$IFDEF WINDOWS}
     Reg : Tregisters ;
  {$ELSE}
     Reg : Registers ;
  {$ENDIF}

begin
    Checkdos := True ; { Assume OK for now }
    Case Lo( Dosversion ) Of
        0..1 : { Prior to V2.0 }
            begin
                Checkdos := False ;
                Exit
            end ;
        2 : Dummy := $10 ;
        3 : begin
                if( Hi( Dosversion ) = 0 ) then { if V3.0 }
                begin
                    Dummy := $1B
                end else
                begin
                    Dummy := $21 ;
                end ;
            end ;
        else Dummy := $21 ;
    end ;
    Reg.Ax := $1900 ;
    Msdos( Reg ) ; { Get current drive }
    Reg.Dx := Reg.Ax And 255 ;
    Reg.Ax := $0E00 ;
    Msdos( Reg ) ; { Select current drive - gives us # of logical drives }
    List := Lo( Reg.Ax ) ; { Get number of drives }
    Reg.Ax := $5200 ;
    Reg.Bx := 0 ;
    Reg.Es := 0 ;
    Msdos( Reg ) ; { Get list of lists }
    if( ( Reg.Bx Or Reg.Es ) = 0 ) then { Not supported }
    begin
        Checkdos := False ;
        Exit
    end ;
    Dummy := Mem[ Reg.Es : Reg.Bx + Dummy ] ; { Drives in DOS list of lists }
    if( List = Dummy ) then
    begin
        Exit ; {OK}
    end ;
    Reg.Ax := $EA01 ;
    Reg.Bx := 0 ;
    Reg.Es := Seg( Command ) ;
    Reg.Di := Ofs( Command ) ;
    Msdos( Reg ) ; { Check for presence of Novell netware }
    if( Reg.Bx <> 0 ) then { Novell netware is present }
    begin
        if( List = 32 ) then { When netware present, DOS should return 32 drives }
        begin
            Reg.Ax := $DB00 ;
            Msdos( Reg ) ; { Get number of drives from netware }
            if( Lo( Reg.Ax ) = Dummy ) then
            begin
                Exit ; { OK }
            end ;
        end ;
    end ;
    Checkdos := False
end ;
{$ENDIF}



end.
