{
        Program Name : WinAPI
        Package Name : Subroutine Library - Layer 3
        Purpose      : Windows API wrappers
        Institution  : Conroy & Conroy Co.
        Date Written : 28-July-2004
        Written By   : Alan Conroy
        Version      : 1.0

	Copyright (C) 2004 by Alan Conroy.  All rights reserved.

        TO THE GLORY OF GOD THROUGH JESUS CHRIST

        *************************************************************
        *                                                           *
        *        M O D I F I C A T I O N   H I S T O R Y            *
        *                                                           *
        *************************************************************

            DATE        BY          REASON

        *************************************************************
        *                                                           *
        *        P R O G R A M   P U R P O S E                      *
        *                                                           *
        *************************************************************

}

unit WinAPI ;

interface

{$I EDEFINES.INC}
{$IFDEF FPC}
  {$MODE Delphi}
{$ENDIF}

uses // Borland...
     Windows,
{$IFNDEF DELPHI10UP}
     Graphics, { TColor }
{$ENDIF}
     Messages,
{$IFDEF FPC}
     LMessages,
{$ENDIF}
     ShlObj, { PItemIDList }
     SysUtils ; { Exception }

{ Windows Types... }
type DWORD = Windows.DWORD ;
     HDC = Windows.HDC ;
     HFONT = Windows.HFONT ;
     HWND = Windows.HWND ;
     OSVERSIONINFO = Windows.OSVERSIONINFO ;
{$IFNDEF FPC}
     PItemIDList = ShlObj.PItemIDList ;
{$ENDIF}
     TPoint = Windows.TPoint ;
{$IFDEF FPC}
     TFNTimerProc = TIMERPROC ;
{$ENDIF}
     TInputRecord = Windows.TInputRecord ;
     TLogFont = Windows.TLogFontA ;
     TMemoryStatus = Windows.TMemoryStatus ;
{$IFDEF FPC}
     TMessageEvent = procedure( var Msg : TMsg ; var Handled : Boolean ) of object ;
{$ENDIF}
     TMsg = Windows.TMsg ;
     TOFStruct = Windows.TOFStruct ;
     TOSVersionInfo = Windows.TOSVersionInfo ;
     TProcessInformation = Windows.TProcessInformation ;
     Trect = Windows.TRect ;
     TStartupInfo = Windows.TStartupInfo ;
     tSize = Windows.TSize ;
     TTextMetric = Windows.TTextMetricA ;
{$IFDEF FPC}
     tWMLButtonDblclk = Windows.tWMLButtonDblclk ;
     tWMLButtonDown = Windows.tWMLButtonDown ;
     tWMLButtonUp = Windows.tWMLButtonUp ;
     tWMMouseMove = Windows.tWMMouseMove ;
{$ELSE}
     tWMLButtonDblclk = Messages.tWMLButtonDblclk ;
     tWMLButtonDown = Messages.tWMLButtonDown ;
     tWMLButtonUp = Messages.tWMLButtonUp ;
     tWMMouseMove = Messages.tWMMouseMove ;
{$ENDIF}
{$IFNDEF DELPHI2007UP}
     UINT_PTR = Cardinal ;
{$ENDIF}

{ Windows Constants... }
const CF_BITMAP = Windows.CF_BITMAP ;
      CF_TEXT = Windows.CF_TEXT ;

{$IFNDEF DELPHI5UP}
      clHotLight : TColor = $00FF9933 ;
      clGradientActiveCaption : TColor = TColor($80000000 or COLOR_GRADIENTACTIVECAPTION) ;
      clGradientInactiveCaption : TColor = TColor($80000000 or COLOR_GRADIENTINACTIVECAPTION) ;
      clMenuHighlight : TColor = TColor($80000000 or COLOR_MENUHILIGHT) ;
      clMenuBar : TColor = TColor($80000000 or COLOR_MENUBAR) ;
      clMoneyGreen : TColor = $C0DCC0 ;
      clSkyBlue : TColor = $F0CAA6 ;
      clCream : TColor = $F0FBFF ;
      clMedGray : TColor = $A4A0A0 ;
      COLOR_MENUHILIGHT = 29 ;
      COLOR_MENUBAR = 30 ;
{$ENDIF}

      CSIDL_APPDATA = ShlObj.CSIDL_APPDATA ;
      CSIDL_COMMON_APPDATA = $23 ;
      DRIVE_REMOVABLE = Windows.DRIVE_REMOVABLE ;
      DRIVE_FIXED = Windows.DRIVE_FIXED ;
      DRIVE_REMOTE = Windows.DRIVE_REMOTE ;
      DRIVE_CDROM = Windows.DRIVE_CDROM ;
      DRIVE_RAMDISK = Windows.DRIVE_RAMDISK ;
      ETO_CLIPPED = Windows.ETO_CLIPPED ;
      FILE_ATTRIBUTE_NORMAL = Windows.FILE_ATTRIBUTE_NORMAL ;
      FILE_MAP_ALL_ACCESS = Windows.FILE_MAP_ALL_ACCESS ;
      FILE_MAP_READ = Windows.FILE_MAP_READ ;
      FILE_SHARE_READ = Windows.FILE_SHARE_READ ;
      FILE_SHARE_WRITE = Windows.FILE_SHARE_WRITE ;
      FORMAT_MESSAGE_ALLOCATE_BUFFER = Windows.FORMAT_MESSAGE_ALLOCATE_BUFFER ;
      FORMAT_MESSAGE_FROM_SYSTEM = Windows.FORMAT_MESSAGE_FROM_SYSTEM ;
      FORMAT_MESSAGE_IGNORE_INSERTS = Windows.FORMAT_MESSAGE_IGNORE_INSERTS ;
      FW_BOLD = Windows.FW_BOLD ;
      FW_NORMAL = Windows.FW_NORMAL ;
      GENERIC_READ = Windows.GENERIC_READ ;
      GENERIC_WRITE = Windows.GENERIC_WRITE ;
      GMEM_MOVEABLE = Windows.GMEM_MOVEABLE ;
      HKEY_LOCAL_MACHINE = Windows.HKEY_LOCAL_MACHINE ;
{$IFNDEF FPC}
      ID_ABORT = Windows.ID_ABORT ;
      ID_CANCEL = Windows.ID_CANCEL ;
      ID_NO = Windows.ID_NO ;
      ID_RETRY = Windows.ID_RETRY ;
      ID_OK = Windows.ID_OK ;
      ID_YES = Windows.ID_YES ;
{$ENDIF}
      INVALID_HANDLE_VALUE = Windows.INVALID_HANDLE_VALUE ;
      idYes = Windows.IDYES ;
      KEY_EVENT = Windows.KEY_EVENT ;

      LOCALE_IDEFAULTMACCODEPAGE = $1011 ;
      LOCALE_IINTLCURRDIGITS     = $1A ;
      LOCALE_ITIMEMARKPOSN       = $1005 ;
      LOCALE_ICENTURY            = $24 ;
      LOCALE_FONTSIGNATURE       = $58 ;
      LOCALE_S1159 = Windows.LOCALE_S1159 ;
      LOCALE_S2359 = Windows.LOCALE_S2359 ;
      LOCALE_SABBREVDAYNAME1 = Windows.LOCALE_SABBREVDAYNAME1 ;
      LOCALE_SABBREVDAYNAME2 = Windows.LOCALE_SABBREVDAYNAME2 ;
      LOCALE_SABBREVDAYNAME3 = Windows.LOCALE_SABBREVDAYNAME3 ;
      LOCALE_SABBREVDAYNAME4 = Windows.LOCALE_SABBREVDAYNAME4 ;
      LOCALE_SABBREVDAYNAME5 = Windows.LOCALE_SABBREVDAYNAME5 ;
      LOCALE_SABBREVDAYNAME6 = Windows.LOCALE_SABBREVDAYNAME6 ;
      LOCALE_SABBREVDAYNAME7 = Windows.LOCALE_SABBREVDAYNAME7 ;
      LOCALE_SABBREVMONTHNAME1 = Windows.LOCALE_SABBREVMONTHNAME1 ;
      LOCALE_SABBREVMONTHNAME2 = Windows.LOCALE_SABBREVMONTHNAME2 ;
      LOCALE_SABBREVMONTHNAME3 = Windows.LOCALE_SABBREVMONTHNAME3 ;
      LOCALE_SABBREVMONTHNAME4 = Windows.LOCALE_SABBREVMONTHNAME4 ;
      LOCALE_SABBREVMONTHNAME5 = Windows.LOCALE_SABBREVMONTHNAME5 ;
      LOCALE_SABBREVMONTHNAME6 = Windows.LOCALE_SABBREVMONTHNAME6 ;
      LOCALE_SABBREVMONTHNAME7 = Windows.LOCALE_SABBREVMONTHNAME7 ;
      LOCALE_SABBREVMONTHNAME8 = Windows.LOCALE_SABBREVMONTHNAME8 ;
      LOCALE_SABBREVMONTHNAME9 = Windows.LOCALE_SABBREVMONTHNAME9 ;
      LOCALE_SABBREVMONTHNAME10 = Windows.LOCALE_SABBREVMONTHNAME10 ;
      LOCALE_SABBREVMONTHNAME11 = Windows.LOCALE_SABBREVMONTHNAME11 ;
      LOCALE_SABBREVMONTHNAME12 = Windows.LOCALE_SABBREVMONTHNAME12 ;
      LOCALE_SABBREVMONTHNAME13 = Windows.LOCALE_SABBREVMONTHNAME13 ;
      LOCALE_SCURRENCY = Windows.LOCALE_SCURRENCY ;
      LOCALE_SDATE = Windows.LOCALE_SDATE ;
      LOCALE_SDAYNAME1 = Windows.LOCALE_SDAYNAME1 ;
      LOCALE_SDAYNAME2 = Windows.LOCALE_SDAYNAME2 ;
      LOCALE_SDAYNAME3 = Windows.LOCALE_SDAYNAME3 ;
      LOCALE_SDAYNAME4 = Windows.LOCALE_SDAYNAME4 ;
      LOCALE_SDAYNAME5 = Windows.LOCALE_SDAYNAME5 ;
      LOCALE_SDAYNAME6 = Windows.LOCALE_SDAYNAME6 ;
      LOCALE_SDAYNAME7 = Windows.LOCALE_SDAYNAME7 ;
      LOCALE_SDECIMAL = Windows.LOCALE_SDECIMAL ;
      LOCALE_SINTLSYMBOL         = $15 ;
      LOCALE_SMONDECIMALSEP = Windows.LOCALE_SMONDECIMALSEP ;
      LOCALE_SMONTHNAME1 = Windows.LOCALE_SMONTHNAME1 ;
      LOCALE_SMONTHNAME2 = Windows.LOCALE_SMONTHNAME2 ;
      LOCALE_SMONTHNAME3 = Windows.LOCALE_SMONTHNAME3 ;
      LOCALE_SMONTHNAME4 = Windows.LOCALE_SMONTHNAME4 ;
      LOCALE_SMONTHNAME5 = Windows.LOCALE_SMONTHNAME5 ;
      LOCALE_SMONTHNAME6 = Windows.LOCALE_SMONTHNAME6 ;
      LOCALE_SMONTHNAME7 = Windows.LOCALE_SMONTHNAME7 ;
      LOCALE_SMONTHNAME8 = Windows.LOCALE_SMONTHNAME8 ;
      LOCALE_SMONTHNAME9 = Windows.LOCALE_SMONTHNAME9 ;
      LOCALE_SMONTHNAME10 = Windows.LOCALE_SMONTHNAME10 ;
      LOCALE_SMONTHNAME11 = Windows.LOCALE_SMONTHNAME11 ;
      LOCALE_SMONTHNAME12 = Windows.LOCALE_SMONTHNAME12 ;
      LOCALE_SMONTHNAME13 = Windows.LOCALE_SMONTHNAME13 ;
      LOCALE_SMONTHOUSANDSEP = Windows.LOCALE_SMONTHOUSANDSEP ;
      LOCALE_SNATIVEDIGITS       = $13 ;
      LOCALE_SNEGATIVESIGN = Windows.LOCALE_SNEGATIVESIGN ;
      LOCALE_SPOSITIVESIGN = Windows.LOCALE_SPOSITIVESIGN ;
      LOCALE_STHOUSAND = Windows.LOCALE_STHOUSAND ;
      LOCALE_STIME = Windows.LOCALE_STIME ;
      LOCALE_USER_DEFAULT = Windows.LOCALE_USER_DEFAULT ;
      LOGPIXELSY = Windows.LOGPIXELSY ;

      MAX_PATH = Windows.MAX_PATH ;

      MB_ABORTRETRYIGNORE = Windows.MB_ABORTRETRYIGNORE ;
      MB_ICONEXCLAMATION = Windows.MB_ICONEXCLAMATION ;
      MB_OK = Windows.MB_OK ;
      MB_OKCANCEL = Windows.MB_OKCANCEL ;
      MB_RETRYCANCEL = Windows.MB_RETRYCANCEL ;
      MB_YESNO = Windows.MB_YESNO ;
      MB_YESNOCANCEL = Windows.MB_YESNOCANCEL ;

      MK_SHIFT = Windows.MK_SHIFT ;
      NOERROR = Windows.NOERROR ;
      OF_READ = Windows.OF_READ ;
      OF_READWRITE = Windows.OF_READWRITE ;
      OF_SHARE_COMPAT = Windows.OF_SHARE_COMPAT ;
      OPEN_ALWAYS = Windows.OPEN_ALWAYS ;
      OPEN_EXISTING = Windows.OPEN_EXISTING ;
      PAGE_READONLY = Windows.PAGE_READONLY ;
      PAGE_READWRITE = Windows.PAGE_READWRITE ;
      PM_NOREMOVE = Windows.PM_NOREMOVE ;
      PM_REMOVE = Windows.PM_REMOVE ;
      STARTF_USESHOWWINDOW = Windows.STARTF_USESHOWWINDOW ;
      STILL_ACTIVE = Windows.STILL_ACTIVE ;
      SW_HIDE = Windows.SW_HIDE ;
      SW_SHOW = Windows.SW_SHOW ;
      SW_SHOWNORMAL = Windows.SW_SHOWNORMAL ;
      STD_INPUT_HANDLE = Windows.STD_INPUT_HANDLE ;
      TRANSPARENT = Windows.TRANSPARENT ;
      VER_PLATFORM_WIN32_NT = Windows.VER_PLATFORM_WIN32_NT ;
      VER_PLATFORM_WIN32_WINDOWS = Windows.VER_PLATFORM_WIN32_WINDOWS ;
      VER_PLATFORM_WIN32S = Windows.VER_PLATFORM_WIN32S ;

      // Virtual keys...
{$IFDEF FPC}
      VK_ACCEPT = 30 ;
{$ELSE}
      VK_ACCEPT = Windows.VK_ACCEPT ;
{$ENDIF}
      VK_APPS = Windows.VK_APPS ;
      VK_ATTN = Windows.VK_ATTN ;
      VK_CANCEL = Windows.VK_CANCEL ;
      VK_CAPITAL = Windows.VK_CAPITAL ;
      VK_CLEAR = Windows.VK_CLEAR ;
      VK_CONTROL = Windows.VK_CONTROL ;
{$IFDEF FPC}
      VK_CONVERT = 28 ;
{$ELSE}
      VK_CONVERT = Windows.VK_CONVERT ;
{$ENDIF}
      VK_CRSEL = Windows.VK_CRSEL ;
      VK_DELETE = Windows.VK_DELETE ;
      VK_DOWN = Windows.VK_DOWN ;
      VK_END = Windows.VK_END ;
      VK_EREOF = Windows.VK_EREOF ;
      VK_EXSEL = Windows.VK_EXSEL ;
      VK_EXECUTE = Windows.VK_EXECUTE ;
      VK_F1 = Windows.VK_F1 ;
      VK_F2 = Windows.VK_F2 ;
      VK_F3 = Windows.VK_F3 ;
      VK_F4 = Windows.VK_F4 ;
      VK_F5 = Windows.VK_F5 ;
      VK_F6 = Windows.VK_F6 ;
      VK_F7 = Windows.VK_F7 ;
      VK_F8 = Windows.VK_F8 ;
      VK_F9 = Windows.VK_F9 ;
      VK_F10 = Windows.VK_F10 ;
      VK_F11 = Windows.VK_F11 ;
      VK_F12 = Windows.VK_F12 ;
      VK_F13 = Windows.VK_F13 ;
      VK_F14 = Windows.VK_F14 ;
      VK_F15 = Windows.VK_F15 ;
      VK_F16 = Windows.VK_F16 ;
      VK_F17 = Windows.VK_F17 ;
      VK_F18 = Windows.VK_F18 ;
      VK_F19 = Windows.VK_F19 ;
      VK_F20 = Windows.VK_F20 ;
      VK_F21 = Windows.VK_F21 ;
      VK_F22 = Windows.VK_F22 ;
      VK_F23 = Windows.VK_F23 ;
      VK_F24 = Windows.VK_F24 ;
      VK_FINAL = 24 ;
      VK_HANGUL = 21 ;
      VK_HANJA = 25 ;
      VK_HELP = Windows.VK_HELP ;
      VK_HOME = Windows.VK_HOME ;
      VK_INSERT = Windows.VK_INSERT ;
      VK_JUNJA = 23 ;
      VK_KANA = 21 ;
      VK_KANJI = 25 ;
      VK_LBUTTON = Windows.VK_LBUTTON ;
      VK_LEFT = Windows.VK_LEFT ;
      VK_LWIN = Windows.VK_LWIN ;
      VK_MBUTTON = Windows.VK_MBUTTON ;
      VK_MENU = Windows.VK_MENU ;
      VK_MODECHANGE = 31 ;
      VK_NEXT = Windows.VK_NEXT ;
      VK_NONAME = Windows.VK_NONAME ;
      VK_NONCONVERT = 29 ;
      VK_NUMLOCK = Windows.VK_NUMLOCK ;
      VK_OEM_CLEAR = Windows.VK_OEM_CLEAR ;
      VK_PA1 = Windows.VK_PA1 ;
      VK_PAUSE = Windows.VK_PAUSE ;
      VK_PLAY = WIndows.VK_PLAY ;
      VK_PRINT = Windows.VK_PRINT ;
      VK_PRIOR = Windows.VK_PRIOR ;
      VK_PROCESSKEY = Windows.VK_PROCESSKEY ;
      VK_RBUTTON = Windows.VK_RBUTTON ;
      VK_RETURN = Windows.VK_RETURN ;
      VK_RIGHT = Windows.VK_RIGHT ;
      VK_RWIN = Windows.VK_RWIN ;
      VK_SCROLL = Windows.VK_SCROLL ;
      VK_SELECT = Windows.VK_SELECT ;
      VK_SHIFT = Windows.VK_SHIFT ;
      VK_SNAPSHOT = Windows.VK_SNAPSHOT ;
      VK_UP = Windows.VK_UP ;
      VK_ZOOM = Windows.VK_ZOOM ;


// Windows API Wrappers...
function CloseClipboard : boolean ;
function CloseHandle( Handle : THandle ) : boolean ;
procedure CoTaskMemFree( P : pointer ) ;
function CreateFile( FileName : Ansistring ; DesiredAccess, ShareMode : DWORD ;
    SecurityAttributes : PSecurityAttributes ;
    CreationDisposition, FlagsAndAttributes : DWORD ;
    TemplateFile : THandle ) : THandle ;
function CreateFileMapping( Handle : THandle ;
    FileMappingAttributes : PSecurityAttributes ; Protect, MaximumSizeHigh,
    MaximumSizeLow : DWORD ; Name : Ansistring ) : THandle ;
function CreateFontIndirect( const p1: TLogFontA ) : HFONT ;
function CreateProcess( ApplicationName, CommandLine : Ansistring ;
    ProcessAttributes, ThreadAttributes : PSecurityAttributes ;
    InheritHandles : boolean ; CreationFlags : DWORD ; Environment : Pointer ;
    CurrentDirectory : Ansistring ; const lpStartupInfo : TStartupInfo ;
    var ProcessInformation : TProcessInformation ) : boolean ;
function DeviceIoControl( Handle : THandle ; IoControlCode : DWORD ;
    InBuffer : Pointer ; InBufferSize : DWORD ; OutBuffer : Pointer ;
    OutBufferSize : DWORD ; var BytesReturned : DWORD ;
    Overlapped : POverlapped ) : boolean ;
function DeleteObject( p1 : HGDIOBJ ) : boolean ;
function DispatchMessage( const Msg : TMsg ) : Longint ;
function ExtTextOut( DC : HDC ; X, Y : Integer ; Options : Longint ;
    Rect : PRect ; Str : Ansistring ; Count : Longint ; Dx : PInteger ) : boolean ;
function FlushConsoleInputBuffer( Handle : THandle ) : boolean ;
function FlushFileBuffers( Handle : THandle ) : boolean ;
function FlushViewOfFile( const BaseAddress : Pointer ;
    NumberOfBytesToFlush : DWORD ) : boolean ;
function FormatMessage( Flags : DWORD ; Source : Pointer ; MessageId : DWORD ;
    LanguageId : DWORD ; var Buffer : Ansistring ; Size : DWORD ;
    Arguments : Pointer ) : DWORD ;
function FreeLibrary( LibModule : HMODULE ) : boolean ;
function GetClipboardData( Format : UINT ) : THandle ;
function GetCommandLine : Ansistring ;
function GetConsoleMode( Handle : THandle ; var Mode : DWORD ) : boolean ;
function GetCurrentProcessId : DWORD ;
function GetCurrentThreadId : DWORD ;
function GetCursorPos( var Point : TPoint ) : boolean ;
function GetDC( Handle : HWND ) : HDC ;
function GetDeviceCaps( DC : HDC ; Index : Integer ) : Integer ;
function GetDriveType( RootPathName : Ansistring ) : UINT ;
function GetEnvironmentVariable( Name : Ansistring ; var Buffer : Ansistring ;
    Size : DWORD ) : DWORD ;
function GetExitCodeProcess( Handle : THandle ; var ExitCode : DWORD ) : boolean ;
function GetFileAttributes( FileName : Ansistring ) : DWORD ;
function GetFileSize( Handle : THandle ; FileSizeHigh : Pointer ) : DWORD ;
function GetFileVersionInfo( Filename: Ansistring ; Handle, Len : DWORD ;
    Data : Pointer ) : boolean ;
{$IFDEF OVERLOAD_FUNCTIONS}
    overload ;
function GetFileVersionInfo( Filename: string ; Handle, Len : DWORD ;
    Data : Pointer ) : boolean ; overload ;
{$ENDIF}
function GetFileVersionInfoSize( Filename : string ; var Handle : DWORD ) : DWORD ;
{$IFDEF OVERLOAD_FUNCTIONS}
    overload ;
function GetFileVersionInfoSize( Filename : Ansistring ; var Handle : DWORD ) : DWORD ;
    overload ;
{$ENDIF}
function GetFocus : THandle ;
function GetLastError : integer ;
function GetLocaleInfo( Locale : LCID ; LCType : LCTYPE ; var LCData : Ansistring ;
    chData : Integer ) : Integer ;
function GetNumberOfConsoleInputEvents( Handle : THandle ;
    var NumberOfEvents : DWORD ) : boolean ;
function GetObject( p1 : HGDIOBJ ; p2 : Integer ; p3 : Pointer ) : Integer ;
function GetObjectType( h : HGDIOBJ ) : DWORD ;
function GetPrivateProfileString( AppName, KeyName, Default : Ansistring ;
    var ReturnedString : Ansistring ; Size : DWORD ; FileName : Ansistring ) : DWORD ;
function GetProcAddress( Module : HMODULE ; ProcName : ansistring ) : FARPROC ;
function GetProfileString( AppName, KeyName, Default : Ansistring ;
    var ReturnedString : Ansistring ; Size : DWORD ) : DWORD ;
function GetStdHandle( StdHandle : DWORD ) : THandle ;
function GetSystemDirectory( var Buffer : Ansistring ; Size : UINT ) : UINT ;
function GetTempFileName( PathName, PrefixString : Ansistring ; Unique : UINT ;
    var TempFileName : Ansistring ) : UINT ;
function GetTempPath( BufferLength : DWORD ; var Buffer : AnsiString ) : DWORD ;
function GetTextExtentPoint( DC : HDC ; Str : Ansistring ; Count : Integer ;
    var Size : TSize ) : boolean ;
function GetTextExtentPoint32( DC : HDC ; Str : AnsiString ; Count : Integer ;
    var Size : TSize ) : boolean ;
function GetTextMetrics( DC : HDC ; var TM : TTextMetricA ) : boolean ;
function GetUserName( var Buffer : Ansistring ; var Size : DWORD ) : boolean ;
function GetVersionEx( var VersionInformation : TOSVersionInfo ) : boolean ;
function GlobalAlloc( Flags : UINT ; Bytes : DWORD ) : HGLOBAL ;
function GlobalFree( hMem : HGLOBAL ) : HGLOBAL ;
function GlobalLock( hMem : HGLOBAL ) : Pointer ;
procedure GlobalMemoryStatus( var Buffer : TMemoryStatus ) ;
function GlobalSize( hMem : HGLOBAL ) : DWORD ;
function GlobalUnlock( hMem : HGLOBAL ) : boolean ;
function IsWindow( Wnd : HWND ) : boolean ;
function KillTimer( hWnd : HWND ; uIDEvent : UINT_PTR ) : boolean ;
function LineTo( DC : HDC ; X, Y : Integer ) : boolean ;
function LoadLibrary( LibFileName : Ansistring ) : HMODULE ;
function MapViewOfFile( FileMappingObject : THandle ; DesiredAccess : DWORD ;
    FileOffsetHigh, FileOffsetLow, NumberOfBytesToMap : DWORD ) : Pointer ;
function MessageBeep( uType : UINT ) : boolean ;
function MessageBox( Wnd : HWND ; Text, Caption : Ansistring ; uType : UINT ) : Integer ;
function MoveToEx( DC : HDC ; p2, p3 : Integer ; p4 : PPoint ) : boolean ;
function OpenClipboard( WndNewOwner : HWND ) : boolean ;
function OpenFile( const FileName : Ansistring ; var ReOpenBuff : TOFStruct ;
    Style : UINT ) : HFILE ;
function PeekMessage( var Msg : TMsg ; Wnd : HWND ;
    MsgFilterMin, MsgFilterMax, RemoveMsg : UINT ) : boolean ;
function ReadConsoleInput( Handle : THandle ; var Buffer : TInputRecord ;
    Length : DWORD ; var NumberOfEventsRead : DWORD ) : boolean ;
function ReadFile( Handle : THandle ; var Buffer ; NumberOfBytesToRead : DWORD ;
    var NumberOfBytesRead : DWORD ; Overlapped : POverlapped ) : boolean ;
function RegisterClipboardFormat( const Format : Ansistring ) : UINT ;
function ReleaseDC( hWnd : HWND ; DC : HDC ) : Integer ;
function ScreenToClient( hWnd : HWND ; Point : TPoint ) : boolean ;
function SelectObject( DC : HDC ; p2 : HGDIOBJ ) : HGDIOBJ ;
function SetBkMode( DC : HDC ; BkMode : Integer ) : Integer ;
function SetClipboardData( Format : UINT ; hMem : THandle ) : THandle ;
function SetEndOfFile( Handle : THandle ) : boolean ;
function SetFileAttributes( FileName : Ansistring ; FileAttributes : DWORD ) : boolean ;
function SetTextColor( DC : HDC ; Color : COLORREF ) : COLORREF ;
function SetTimer( hWnd : HWND ; nIDEvent : UINT_PTR ; uElapse : UINT ;
    lpTimerFunc : TFNTimerProc ) : UINT_PTR ;
function ShellExecute( Wnd : HWND ; Operation, FileName, Parameters,
    Directory : Ansistring ; ShowCmd : Integer ) : HINST ;
function SHGetSpecialFolderLocation( wndOwner : HWND ; Folder : Integer ;
    var pidl : PItemIDList ) : HResult ;
function SHGetPathFromIDList( idl : PItemIDList ; var Path : Ansistring ) : boolean ;
function TranslateMessage( const Msg : TMsg ) : boolean ;
function UnmapViewOfFile( BaseAddress : Pointer ) : boolean ;
function VerQueryValue( Block : Pointer ; SubBlock : Ansistring ;
    var Buffer : Pointer ; var Len : UINT ) : boolean ;
{$IFDEF OVERLOAD_FUNCTIONS}
    overload ;
function VerQueryValue( Block : Pointer ; SubBlock : string ;
    var Buffer : Pointer ; var Len : UINT ) : boolean ; overload ;
{$ENDIF}
function WaitForInputIdle( Process : THandle ; Milliseconds : DWORD ) : DWORD ;


implementation

uses ActiveX, // CoTaskMemFree
     ShellApi ; // ShellExecute


{$IFDEF CC_Debug}
procedure Show_Error( const S : string ) ;

begin
    try
        //raise Exception.Create( S + ' - ' + inttostr( GetLastError ) ) ;
    except
    end ;
end ;
{$ENDIF}


function CloseClipboard : boolean ;

begin
    Result := Windows.CloseClipboard ;
end ;


function CloseHandle( Handle: THandle ) : boolean ;

begin
    Result := Windows.CloseHandle( Handle ) ;
end ;


function GetConsoleMode( Handle : THandle ; var Mode : DWORD ) : boolean ;

begin
    Result := Windows.GetConsoleMode( Handle, Mode ) ;
end ;


procedure CoTaskMemFree( P : pointer ) ;

begin
    ActiveX.CoTaskMemFree( P ) ;
end ;


function CreateFile( FileName : Ansistring ; DesiredAccess, ShareMode : DWORD ;
    SecurityAttributes : PSecurityAttributes ;
    CreationDisposition, FlagsAndAttributes : DWORD ;
    TemplateFile : THandle ) : THandle ;

var P : string ;

begin
    P := FileName ;
    Result := Windows.CreateFile( PChar( P ), DesiredAccess, ShareMode,
        SecurityAttributes, CreationDisposition, FlagsAndAttributes,
        TemplateFile ) ;
end ;


function CreateFileMapping( Handle : THandle ;
    FileMappingAttributes : PSecurityAttributes ; Protect, MaximumSizeHigh,
    MaximumSizeLow : DWORD ; Name : Ansistring ) : THandle ;

var P : PAnsiChar ;

begin
    if( Name = '' ) then
    begin
        P := nil ;
    end else
    begin
        P := PAnsiChar( Name ) ;
    end ;
    Result := Windows.CreateFileMappingA( Handle, FileMappingAttributes,
        Protect, MaximumSizeHigh, MaximumSizeLow, P ) ;
end ;


function CreateFontIndirect( const p1: TLogFontA ) : HFONT ;

begin
{$IFDEF FPC}
    Result := Windows.CreateFontIndirectA( @p1 ) ;
{$ELSE}
    Result := Windows.CreateFontIndirectA( p1 ) ;
{$ENDIF}
end ;


function CreateProcess( ApplicationName, CommandLine : Ansistring ;
    ProcessAttributes, ThreadAttributes : PSecurityAttributes ;
    InheritHandles : boolean ; CreationFlags : DWORD ; Environment : Pointer ;
    CurrentDirectory : Ansistring ; const lpStartupInfo : TStartupInfo ;
    var ProcessInformation : TProcessInformation ) : boolean ;

var ApplicationNameX, CommandLineX, CurrentDirectoryX : string ;
    P : PChar ;

begin
    ApplicationNameX := ApplicationName ;
    CommandLineX := CommandLine ;
    CurrentDirectoryX := CurrentDirectory ;
    if( ApplicationName = '' ) then
    begin
        P := nil ;
    end else
    begin
        P := PChar( ApplicationNameX ) ;
    end ;
    Result := Windows.CreateProcess( P, PChar( CommandLineX ),
        ProcessAttributes, ThreadAttributes, InheritHandles, CreationFlags,
        Environment, PChar( string( CurrentDirectory ) ), lpStartupInfo,
        ProcessInformation ) ;
end ;


function DeviceIoControl( Handle : THandle ; IoControlCode : DWORD ;
    InBuffer : Pointer ; InBufferSize : DWORD ; OutBuffer : Pointer ;
    OutBufferSize : DWORD ; var BytesReturned : DWORD ;
    Overlapped : POverlapped ) : boolean ;

begin
    Result := Windows.DeviceIoControl( Handle, IoControlCode, InBuffer,
        InBufferSize, OutBuffer, OutBufferSize, BytesReturned, Overlapped ) ;
end ;


function DeleteObject( p1 : HGDIOBJ ) : boolean ;

begin
    Result := Windows.DeleteObject( P1 ) ;
end ;


function DispatchMessage( const Msg : TMsg ) : Longint ;

begin
    Result := Windows.DispatchMessage( Msg ) ;
end ;


function ExtTextOut( DC : HDC ; X, Y : Integer ; Options : Longint ;
    Rect : PRect ; Str : AnsiString ; Count : Longint ;
    Dx : PInteger ) : boolean ;

begin
    Result := Windows.ExtTextOutA( DC, X, Y, Options, Rect, PAnsiChar( Str ), Count, Dx ) ;
end ;


function FlushConsoleInputBuffer( Handle : THandle ) : boolean ;

begin
    Result := Windows.FlushConsoleInputBuffer( Handle ) ;
end ;


function FlushFileBuffers( Handle : THandle ) : boolean ;

begin
    Result := Windows.FlushFileBuffers( Handle ) ;
end ;


function FlushViewOfFile( const BaseAddress : Pointer ;
    NumberOfBytesToFlush : DWORD ) : boolean ;

begin
    Result := Windows.FlushViewOfFile( BaseAddress, NumberOfBytesToFlush ) ;
end ;


function FormatMessage( Flags : DWORD ; Source : Pointer ; MessageId : DWORD ;
    LanguageId : DWORD ; var Buffer : Ansistring ; Size : DWORD ;
    Arguments : Pointer ) : DWORD ;

var P : string ;

begin
    Result := Windows.FormatMessage( Flags, Source, MessageId, LanguageId,
        nil, Size, Arguments ) ;
    setlength( P, Result ) ;
    Windows.FormatMessage( Flags, Source, MessageId, LanguageId, PChar( P ), Size,
        Arguments ) ;
    Buffer := P ;
end ;


function FreeLibrary( LibModule : HMODULE ) : boolean ;

begin
    Result := Windows.FreeLibrary( LibModule ) ;
end ;


function GetClipboardData( Format : UINT ) : THandle ;

begin
    Result := Windows.GetClipboardData( Format ) ;
end ;


function GetCommandLine : Ansistring ;

begin
    Result := Windows.GetCommandLine ;
end ;


function GetCurrentProcessId : DWORD ;

begin
    Result := Windows.GetCurrentProcessId ;
end ;


function GetCurrentThreadId : DWORD ;

begin
    Result := Windows.GetCurrentThreadId ;
end ;


function GetCursorPos( var Point : TPoint ) : boolean ;

begin
    Result := Windows.GetCursorPos( Point ) ;
end ;


function GetDC( Handle : HWND ) : HDC ;

begin
{$IFDEF CC_Debug}
    if( Handle = 0 ) then
    begin
        Show_Error( 'GetDC called with incorrect window handle' ) ;
    end ;
{$ENDIF}
    Result := Windows.GetDC( Handle ) ;
{$IFDEF CC_Debug}
    if( Result = 0 ) then
    begin
        Show_Error( 'GetDC failed' ) ;
    end ;
{$ENDIF}
end ;


function GetDeviceCaps( DC : HDC ; Index : Integer ) : Integer ;

begin
    Result := Windows.GetDeviceCaps( DC, Index ) ;
end ;


function GetDriveType( RootPathName : Ansistring ) : UINT ;

var P : string ;

begin
    P := RootPathName ;
    Result := Windows.GetDriveType( PChar( P ) ) ;
end ;


function GetEnvironmentVariable( Name : Ansistring ; var Buffer : Ansistring ;
    Size : DWORD ) : DWORD ;

var NameX, P : string ;

begin
    NameX := Name ;
    setlength( P, Size ) ;
    Result := Windows.GetEnvironmentVariable( PChar( NameX ), PChar( P ), Size ) ;
    setlength( P, Result ) ;
    Buffer := P ;
end ;


function GetExitCodeProcess( Handle : THandle ; var ExitCode : DWORD ) : boolean ;

begin
    Result := Windows.GetExitCodeProcess( Handle, ExitCode ) ;
end ;


function GetFileAttributes( FileName : Ansistring ) : DWORD ;

var P : string ;

begin
    P := FileName ;
    Result := Windows.GetFileAttributes( PChar( P ) ) ;
end ;


function GetFileSize( Handle : THandle ; FileSizeHigh : Pointer ) : DWORD ;

begin
    Result := Windows.GetFileSize( Handle, FileSizeHigh ) ;
end ;


function GetFileVersionInfo( Filename : Ansistring ; Handle, Len : DWORD ;
    Data : Pointer ) : boolean ;

begin
    Result := Windows.GetFileVersionInfoA( PAnsiChar( Filename ), Handle, Len, Data ) ;
end ;


{$IFDEF OVERLOAD_FUNCTIONS}
function GetFileVersionInfo( Filename : string ; Handle, Len : DWORD ;
    Data : Pointer ) : boolean ;

begin
    Result := Windows.GetFileVersionInfoW( PChar( Filename ), Handle, Len, Data ) ;
end ;
{$ENDIF}


function GetFileVersionInfoSize( Filename : Ansistring ; var Handle : DWORD ) : DWORD ;

begin
    Result := Windows.GetFileVersionInfoSizeA( PAnsiChar( Filename ), Handle ) ;
end ;


{$IFDEF OVERLOAD_FUNCTIONS}
function GetFileVersionInfoSize( Filename : string ; var Handle : DWORD ) : DWORD ;

begin
    Result := Windows.GetFileVersionInfoSizeW( PChar( Filename ), Handle ) ;
end ;
{$ENDIF}


function GetFocus : THandle ;

begin
    Result := Windows.GetFocus ;
end ;


function GetLastError : integer ;

begin
    Result := Windows.GetLastError ;
end ;


function GetLocaleInfo( Locale : LCID ; LCType : LCTYPE ; var LCData : Ansistring ;
    chData : Integer ) : Integer ;

begin
    Result := Windows.GetLocaleInfoA( Locale, LCType, nil, 0 ) ;
    setlength( LCData, Result ) ;
    Windows.GetLocaleInfoA( Locale, LCType, PAnsiChar( LCData ), chData ) ;
end ;


function GetNumberOfConsoleInputEvents( Handle : THandle ;
    var NumberOfEvents : DWORD ) : boolean ;

begin
    Result := Windows.GetNumberOfConsoleInputEvents( Handle, NumberOfEvents ) ;
end ;


function GetObject( p1 : HGDIOBJ ; p2 : Integer ; p3 : Pointer ) : Integer ;

begin
    Result := Windows.GetObject( p1, p2, p3 ) ;
end ;


function GetObjectType( h : HGDIOBJ ) : DWORD ;

begin
    Result := Windows.GetObjectType( H ) ;
end ;


function GetPrivateProfileString( AppName, KeyName, Default : Ansistring ;
    var ReturnedString : Ansistring ; Size : DWORD ; FileName : Ansistring ) : DWORD ;

var AppNameX, KeyNameX, DefaultX, FileNameX, P : Ansistring ;

begin
    AppNameX := AppName ;
    KeyNameX := KeyName ;
    DefaultX := Default ;
    FileNameX := FileName ;
    setlength( P, Size ) ;
    Result := Windows.GetPrivateProfileStringA( PAnsiChar( AppNameX ),
        PAnsiChar( KeyNameX ), PAnsiChar( DefaultX ), PAnsiChar( P ), Size,
        PAnsiChar( FileName ) ) ;
    ReturnedString := P ;
end ;


function GetProcAddress( Module : HMODULE ; ProcName : ansistring ) : FARPROC ;

var P : string ;

begin
    P := ProcName ;
    Result := Windows.GetProcAddress( Module, PChar( P ) ) ;
end ;


function GetProfileString( AppName, KeyName, Default : Ansistring ;
    var ReturnedString : Ansistring ; Size : DWORD ) : DWORD ;

var P : AnsiString ;

begin
    setlength( P, Size ) ;
    Result := Windows.GetProfileStringA( PAnsichar( AppName ),
        PAnsiChar( KeyName ), PAnsichar( Default ), PAnsichar( P ), Size ) ;
    setlength( P, Result ) ;
    ReturnedString := P ;
end ;


function GetStdHandle( StdHandle : DWORD ) : THandle ;

begin
    Result := Windows.GetStdHandle( StdHandle ) ;
end ;


function GetSystemDirectory( var Buffer : Ansistring ; Size : UINT ) : UINT ;

var P : string ;

begin
    setlength( P, Size ) ;
    Result := Windows.GetSystemDirectory( PChar( P ), Size ) ;
    setlength( P, Result ) ;
    Buffer := P ;
end ;


function GetTempFileName( PathName, PrefixString : Ansistring ; Unique : UINT ;
    var TempFileName : Ansistring ) : UINT ;

begin
    System.setlength( TempFileName, MAX_PATH - 14 ) ;
    Result := Windows.GetTempFileNameA( PAnsiChar( PathName ),
        PAnsiChar( PrefixString ), Unique, PAnsiChar( TempFileName ) ) ;
    setlength( TempFileName, pos( #0, TempFileName + #0 ) - 1 ) ;
end ;


function GetTempPath( BufferLength : DWORD ; var Buffer : AnsiString ) : DWORD ;

begin
    setlength( Buffer, BufferLength ) ;
    Result := Windows.GetTempPathA( BufferLength, PAnsiChar( Buffer ) ) ;
    setlength( Buffer, pos( #0, Buffer + #0 ) - 1 ) ;
    Result := length( Buffer ) ;
end ;


function GetTextExtentPoint( DC : HDC ; Str : Ansistring ; Count : Integer ;
    var Size : TSize ) : boolean ;

begin
    Result := Windows.GetTextExtentPointA( DC, PAnsiChar( Str ), Count, Size ) ;
end ;


function GetTextExtentPoint32( DC : HDC ; Str : AnsiString ; Count : Integer ;
    var Size : TSize ) : boolean ;

begin
    Result := Windows.GetTextExtentPoint32A( DC, PAnsiChar( Str ), Count, Size ) ;
end ;


function GetTextMetrics( DC : HDC ; var TM : TTextMetricA ) : boolean ;

begin
{$IFDEF FPC}
    Result := Windows.GetTextMetricsA( DC, @TM ) ;
{$ELSE}
    Result := Windows.GetTextMetricsA( DC, TM ) ;
{$ENDIF}
end ;


function GetUserName( var Buffer : Ansistring ; var Size : DWORD ) : boolean ;

var P : Ansistring ;

begin
    setlength( P, Size ) ;
    Result := Windows.GetUserNameA( PAnsiChar( P ), Size ) ;
    setlength( P, Size ) ;
    Buffer := P ;
end ;


function GetVersionEx( var VersionInformation : TOSVersionInfo ) : boolean ;

begin
    Result := Windows.GetVersionEx( VersionInformation ) ;
end ;


function GlobalAlloc( Flags : UINT ; Bytes : DWORD ) : HGLOBAL ;

begin
    Result := Windows.GlobalAlloc( Flags, Bytes ) ;
end ;


function GlobalFree( hMem : HGLOBAL ) : HGLOBAL ;

begin
    Result := Windows.GlobalFree( hMem ) ;
end ;


function GlobalLock( hMem : HGLOBAL ) : Pointer ;

begin
    Result := Windows.GlobalLock( hMem ) ;
end ;


procedure GlobalMemoryStatus( var Buffer : TMemoryStatus ) ;

begin
    Windows.GlobalMemoryStatus( Buffer ) ;
end ;


function GlobalSize( hMem : HGLOBAL ) : DWORD ;

begin
    Result := Windows.GlobalSize( hMem ) ;
end ;


function GlobalUnlock( hMem : HGLOBAL ) : boolean ;

begin
    Result := Windows.GlobalUnlock( hMem ) ;
end ;


function IsWindow( Wnd : HWND ) : boolean ;

begin
    Result := Windows.IsWindow( Wnd ) ;
end ;


function KillTimer( hWnd : HWND ; uIDEvent : UINT_PTR ) : boolean ;

begin
    Result := Windows.KillTimer( hWnd, uIDEvent ) ;
end ;


function LineTo( DC : HDC ; X, Y : Integer ) : boolean ;

begin
    Result := Windows.LineTo( DC, X, Y ) ;
end ;


function LoadLibrary( LibFileName : Ansistring ) : HMODULE ;

var P : string ;

begin
    P := LibFileName ;
    Result := Windows.LoadLibrary( PChar( P ) ) ;
end ;


function MapViewOfFile( FileMappingObject : THandle ; DesiredAccess : DWORD ;
    FileOffsetHigh, FileOffsetLow, NumberOfBytesToMap : DWORD ) : Pointer ;

begin
    Result := Windows.MapViewOfFile( FileMappingObject, DesiredAccess,
        FileOffsetHigh, FileOffsetLow, NumberOfBytesToMap ) ;
end ;


function MessageBeep( uType : UINT ) : boolean ;

begin
    Result := Windows.MessageBeep( uType ) ;
end ;


function MessageBox( Wnd : HWND ; Text, Caption : Ansistring ; uType : UINT ) : Integer ;

begin
    Result := Windows.MessageBoxA( Wnd, PAnsiChar( Text ), PAnsiChar( Caption ), uType ) ;
end ;


function MoveToEx( DC : HDC ; p2, p3 : Integer ; p4 : PPoint ) : boolean ;

begin
    Result := Windows.MoveToEx( DC, p2, p3, p4 ) ;
end ;


function OpenClipboard( WndNewOwner : HWND ) : boolean ;

begin
    Result := Windows.OpenClipboard( WndNewOwner ) ;
end ;


function OpenFile( const FileName : Ansistring ; var ReOpenBuff : TOFStruct ;
    Style : UINT ) : HFILE ;

var P : string ;

begin
    P := FileName ;
    Result := Windows.OpenFile( PAnsiChar( Filename ), ReOpenBuff, Style ) ;
end ;


function PeekMessage( var Msg : TMsg ; Wnd : HWND ;
    MsgFilterMin, MsgFilterMax, RemoveMsg : UINT ) : boolean ;

begin
    Result := Windows.PeekMessage( Msg, Wnd, MsgFilterMin, MsgFilterMax, RemoveMsg ) ;
end ;


function ReadConsoleInput( Handle : THandle ; var Buffer : TInputRecord ;
    Length : DWORD ; var NumberOfEventsRead : DWORD ) : boolean ;

begin
    Result := Windows.ReadConsoleInput( Handle, Buffer, Length, NumberOfEventsRead ) ;
end ;


function ReadFile( Handle : THandle ; var Buffer ; NumberOfBytesToRead : DWORD ;
    var NumberOfBytesRead : DWORD ; Overlapped : POverlapped ) : boolean ;

begin
    Result := Windows.ReadFile( Handle, Buffer, NumberOfBytesToRead,
        NumberOfBytesRead, Overlapped ) ;
end ;


function RegisterClipboardFormat( const Format : Ansistring ) : UINT ;

var FormatX : string ;

begin
    FormatX := Format ;
    Result := Windows.RegisterClipboardFormat( PChar( FormatX ) ) ;
end ;


function ReleaseDC( hWnd : HWND ; DC : HDC ) : Integer ;

begin
    Result := Windows.ReleaseDC( hWnd, DC ) ;
end ;


function ScreenToClient( hWnd : HWND ; Point : TPoint ) : boolean ;

begin
    Result := Windows.ScreenToClient( hWnd, Point ) ;
end ;


function SelectObject( DC : HDC ; p2 : HGDIOBJ ) : HGDIOBJ ;

begin
    Result := Windows.SelectObject( DC, P2 ) ;
end ;


function SetBkMode( DC : HDC ; BkMode : Integer ) : Integer ;

begin
    Result := Windows.SetBkMode( DC, BkMode ) ;
end ;


function SetClipboardData( Format : UINT ; hMem : THandle ) : THandle ;

begin
    Result := Windows.SetClipboardData( Format, hMem ) ;
end ;


function SetEndOfFile( Handle : THandle ) : boolean ;

begin
    Result := Windows.SetEndOfFile( Handle ) ;
end ;


function SetFileAttributes( FileName : Ansistring ; FileAttributes : DWORD ) : boolean ;

var P : string ;

begin
    P := FileName ;
    Result := Windows.SetFileAttributes( PChar( P ), FileAttributes ) ;
end ;


function SetTextColor( DC : HDC ; Color : COLORREF ) : COLORREF ;

begin
    Result := Windows.SetTextColor( DC, Color ) ;
end ;


function SetTimer( hWnd : HWND ; nIDEvent : UINT_PTR ; uElapse : UINT ;
    lpTimerFunc : TFNTimerProc ) : UINT_PTR ;

begin
    Result := Windows.SetTimer( hWnd, nIDEvent, uElapse, lpTimerFunc ) ;
end ;


function ShellExecute( Wnd : HWND ; Operation, FileName, Parameters,
    Directory : Ansistring ; ShowCmd : Integer ) : HINST ;

var OperationX, FileNameX, ParametersX, DirectoryX : string ;
    OperationP, ParametersP, DirectoryP : PChar ;

begin
    FileNameX := FilenameX ;
    if( Operation = '' ) then
    begin
        OperationP := nil ;
    end else
    begin
        OperationX := Operation ;
        OperationP := PChar( OperationX ) ;
    end ;
    if( Parameters = '' ) then
    begin
        ParametersP := nil ;
    end else
    begin
        ParametersX := Parameters ;
        ParametersP := PChar( ParametersX ) ;
    end ;
    if( Directory = '' ) then
    begin
        DirectoryP := nil ;
    end else
    begin
        DirectoryX := Directory ;
        DirectoryP := PChar( DirectoryX ) ;
    end ;
    Result := ShellApi.ShellExecute( Wnd, OperationP, PChar( FileNameX ),
        ParametersP, DirectoryP, ShowCmd ) ;
end ;


function SHGetSpecialFolderLocation( wndOwner : HWND ; Folder : Integer ;
    var pidl : PItemIDList ) : HResult ;

begin
    Result := ShlObj.SHGetSpecialFolderLocation( wndOwner, Folder, pidl ) ;
end ;


function SHGetPathFromIDList( idl : PItemIDList ; var Path : Ansistring ) : boolean ;

begin
    setlength( Path, MAX_PATH ) ;
    Result := Shlobj.SHGetPathFromIDListA( idl, PAnsiChar( Path ) ) ;
    setlength( Path, pos( #0, Path ) - 1 ) ;
end ;


function TranslateMessage( const Msg : TMsg ) : boolean ;

begin
    Result := Windows.TranslateMessage( Msg ) ;
end ;


function UnmapViewOfFile( BaseAddress : Pointer ) : boolean ;

begin
    Result := Windows.UnmapViewOfFile( BaseAddress ) ;
end ;


function VerQueryValue( Block : Pointer ; SubBlock : Ansistring ;
    var Buffer : Pointer ; var Len : UINT ) : boolean ;

begin
    Result := Windows.VerQueryValueA( Block, PAnsiChar( SubBlock ), Buffer, Len ) ;
end ;


{$IFDEF OVERLOAD_FUNCTIONS}
function VerQueryValue( Block : Pointer ; SubBlock : string ;
    var Buffer : Pointer ; var Len : UINT ) : boolean ;

begin
    Result := Windows.VerQueryValueW( Block, PChar( SubBlock ), Buffer, Len ) ;
end ;
{$ENDIF}


function WaitForInputIdle( Process : THandle ; Milliseconds : DWORD ) : DWORD ;

begin
    Result := Windows.WaitForInputIdle( Process, Milliseconds ) ;
end ;



end.
